/***************************************************************************
 *   Copyright (C) 2008 by Franz Reiter   *
 *   franz.reiter@cadcam.co.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


/*  APP_GIS1.c                                2008-01-24    Franz Reiter.

Linkjob: ../xa/APP_GIS1.mak


gCad_main            CAD-Core starts application here
gCad_fini            close application

gis_init_pl          get surf-pTab-List from DB
gis_init_UI          Create UI-panel (Toolbar)
gis_lst_sup          create list of sufaces with pTabs; display List.
gis_DrawPoints
gis_DrawPoint
gis_HideAllPoints
gis_HidePoints
gis_mdl_upd          create update / Modelcodes
gis_mdl_del_pTab     

gis_CB1              action-dispatcher
gis_sel_CB           CAD-Core reports selection
gis_Lst_CB           userselection of surfaces-listEntry
gis_UI_getPt         get coords from entryfields
gis_disp_surNr       display activeSurfNr & activePointNr
gis_disp_coords      display coords of active gis-point


gis_surPt_chg        change active point-surface
gis_ptab_load        user has pointfile selected; load it to pTab
gis_bload_pTab       load pTab from bin.file
gis_bsave_pTab       save pTab into bin.file
gis_PtabDel          delete (all Points from) surface ActSurPtb
gis_freePos_pTab     get next free Position in pTab
gis_ptab_save        Export points into Ascii-file
gis_PtMod            modify Point Nr ActPtNr from surface ActSurPtb
gis_PtDelAct            delete Point Nr ActPtNr from surface ActSurPtb
gis_PtAdd            add Point to surface ActSurPtb
gis_mesh             create/diplay mesh
// gis_obd_cre          Create OuterBoundary from all points


gis_surTab_add
gis_surInd_surNr     get index into surTab from DB-index of pointSurface
gis_dump_surTab

ptab_file_load1      read Punkte aus einer Ascii-Datei nach pTab
ptab_cad_load1



=================================================================
*/
#ifdef globTag
 void gis(){}
#endif


#include "../GIS1/APP_GIS1.h"

/*
#define APP_NAME  "APP_GIS1"
#define VERSION " APP_GIS1 Version 1.00 / 2008-03-01"


#include "../xa/MS_Def1.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
*/

#include <GL/gl.h>
#include <GL/glu.h>

#include <gdk/gdkkeysyms.h>            // GDK_Esc


// gtk muss vor __declspec(dllimport) stehen
#include "../gtk/ut_gtk.h"             // f. xa_ui.h




#ifdef _MSC_VER
// die folgenden 2 Funktionen exportieren (werden vom Main gerufen):
__declspec(dllexport) int gCad_main ();
__declspec(dllexport) int gCad_fini ();
// nachfolgende externals werden aus dem Main-Exe imported:
#define extern __declspec(dllimport)
#endif




#include "../xa/ut_ui_TX.h"            // TX_Print
#include "../xa/xa_mem.h"              // memspc51
#include "../ut/ut_geo.h"              // Point ...
#include "../ut/ut_txt.h"              // fnam_del
#include "../ut/ut_umem.h"             // UME_alloc_tmp
#include "../ut/ut_tin.h"              // TYP_EDGLN_BL
#include "../gr/ut_UI.h"               // UI_Func... SYM_..
#include "../gr/ut_GL.h"               // GL_GetViewPos
#include "../db/ut_DB.h"               // DB_GetGTxt
#include "../gr/ut_DL.h"               // DB_GetDLatt
#include "../ut/ut_memTab.h"          // MemTab_..


/*
typedef struct {long indp, indm;
  unsigned visi:1, exi_p:1, exi_m:1, modif:1, unused:29;}  typ_sur_ptab;
// indp    DB-Index of PTAB-surf
// indm    DB-Index of MSH-surf
// exi_p   1: PTAB-surf-Code already exists in Model; 0=no.
// exi_m   1: MSH-surf-Code already exists in Model; 0=no.
// visi    0=not visible; 1=visible;
// modif   1=points modified; 0=not.



#define APPTYP_GISPT 0
#define APPTYP_EDGLN 1

#define TYP_EDGLN_BL  2  // BreakLine
#define TYP_EDGLN_IB  3  // InnerBound
#define TYP_EDGLN_OB  4  // OuterBound
*/




typedef_MemTab(int);
typedef_MemTab(Point);
typedef_MemTab(Fac3);
typedef_MemTab(EdgeLine);




//----------------------------------------------------------------
//---------------- local vars: ---------------------
// a list of active surfaces from PTAB's
static  typ_sur_ptab surTab[MAX_SURPTAB];      // Liste der aktiven pTab-surfs
static  int surTabNr;                          // nr of active pTab-surfs
static  int surIndLast;

static  int       ActSurInd;    // index of active surTab-record
        int       ActSurPtb,     // DB-Index (surTab.indp) of active point-surf.
                  ActSurMsh,    // DB-Index (surTab.indm) of active mesh-surface
                  ActPtNr;
static  long      ActPtDli;     


static  MemTab(Point) ActPtab;        // table of Point's
static  int       ActPtabModFlag;              // ActPtabNr
        // Point     *ActPtab = NULL;

static  MemTab(Fac3) ActFtab;         // table of Fac3's
static  int       ActFtabModFlag;              // ActFtabNr
// static  Fac3      *ActFtab = NULL;

// static  Edges     ActEdges;
// static  int       ActEtabNr, ActEtabSiz, ActEtabModFlag;
static  MemTab(EdgeLine) ActEtab;    // table of EdgeLine's

static  MemTab(int) DatEtab;         // dataSpace for all EdgeLines

// static  EdgeLine  actEl;                      // active EdgeLine
static  MemTab(int) actEl;           // dataSpace for active EdgeLine

#define col_actEl 7                  // colour


static  GtkWidget *tbGis1=NULL;    // GIS-Toolbar
static  GtkWidget *wcbcp, *wcbdp, *wcbdi, *wlbas, *wlbap, *wcbDelPt, *wcbDelEl;
static  GtkWidget *wenvx, *wenvy, *wenvz, *wls;
static  GtkWidget *wcbprGis, *wcbprCad, *wcbcre, *wcbPrj;
static  GLfloat GL_col_tab [][4] = {
  0.7,  0.1,  0.1, 1.0,     //  0 col. points
  0.1,  0.1,  0.7, 1.0};    //  1 col. info
// red  green blue intens




//----------------------------------------------------------------
//---------------- prototypes: ---------------------
  GtkWidget* gis_init_UI (GtkWidget *parent, void *data);
  int gis_sel_CB (int src, long dl_ind);
  int gis_CB1 (GtkWidget *parent, void *data);
  int gis_Lst_CB (GtkWidget *parent, void *data);
  int gis_ptab_load (char *fnam, char *dirNam);
  int gis_ptab_save (char *fnam, char *dirNam);
  int gis_surInd_surNr (int surNr);
  int gis_DrawEL (EdgeLine *el1, int ind);
  int gis_EL_disp (long dli, int *ib, int iNr, Point *pa, int att, int mode);



//----------------------------------------------------------------
//---------------- external vars: ---------------------
// ext aus xa.c:
extern char      WC_modnam[128];  // der Modelname
extern char      AP_dir_open[128];
extern  int      WC_modnr;        // Nr of the active submodel; -1=main.

// ex xa_ui.c:
extern GtkWidget  *UIw_Box_TB;    // toolbarBox


// // ex ../ut/ut_txfil.c
// extern char *UTF_FilBuf0;
// extern long UTF_FilBuf0Len;  // die aktuelle Filesize



// aus ../gr/ut_DL.c:
extern DL_Att  *GR_ObjTab;  // das ist die DL






//=========================================================
  int gCad_main () {
//=========================================================
// user has selected this plugin; starting ...


  int     *iba, iNr;
  // Mesh    ms1;

  // write to Main-Infowindow ..
  TX_Print("%s",VERSION);


  // TESTONLY:
  // gis_test1();
  // iNr=1;if(iNr > 0) return 0;


  // init all structs
  MemTab_ini (&ActPtab, sizeof(Point), Typ_PT, INC_Ptab);
  MemTab_ini (&ActFtab, sizeof(Fac3), Typ_Fac3, INC_Ftab);

  MemTab_ini (&actEl,   sizeof(int), Typ_Int4, INC_actEl);
  MemTab_ini (&ActEtab, sizeof(EdgeLine), Typ_EdgeLine, INC_Etab);
  MemTab_ini (&DatEtab, sizeof(int), Typ_Int4, INC_datEtab);


  // create List of active pTabs
  // get list of surfaces with subTyp PTAB
  gis_init_pl ();   // get pTab-List from DB 


  // get memSpc for Edges ..
  gis_Edges_upd (TYP_FuncInit);


  // surNr = find last used surface-nr (A)
  surIndLast = DB_QueryLastUsed (Typ_SUR, 0);
    printf(" LastUsed A-nr = %d\n",surIndLast);


  // create & activate toolbar
  tbGis1 = gis_init_UI (UIw_Box_TB, NULL);

  ActSurInd  = -1;
  ActSurPtb  = -1;
  ActSurMsh = -1;
  if(surTabNr < 1) goto L_99;


  // update surface-list
  gis_lst_sup ();


  // activate last mesh-surf
  gis_surPt_chg (surTabNr-1);


  //----------------------------------------------------------------
  // attach grafic selections
  L_99:
  AP_UserSelection_get (gis_sel_CB);

  ActPtDli = -1;

  TX_Print("%d point-surfaces loaded",surTabNr);


  return 0;

}


//================================================================
  GtkWidget* gis_init_UI (GtkWidget *parent, void *data) {
//================================================================

  GtkWidget *tbc, *box0, *box1, *box2;
  GtkWidget *mb1, *mb1f, *mb2s;

  printf("gis_init_UI \n");



  tbc = GUI_Toolbox (parent);

  box0 = GUI_Vbox (tbc, 0);
  box1 = GUI_Hbox (box0, 0);
  box2 = GUI_Hbox (box0, 0);

  GUI_Label (box1, " GIS1 ", 2);

  mb1 = GUI_MenuBar (box1);


  //----------------------------------------------------------------
  mb1f = GUI_Menu (mb1, " File ", 0);
  GUI_MenuEntry (mb1f, "Import Points from File",
                        gis_CB1, (void*)"opePtab");
  GUI_MenuEntry (mb1f, "Export Points",
                        gis_CB1, (void*)"savPtab");



  //----------------------------------------------------------------
  mb1f = GUI_Menu (mb1, " Tools ", 0);
  wcbcre = 
  GUI_MenuCkBox(mb1f,"Create GIS-Polygon",
                        gis_CB1, (void*)"creEL");
  GUI_Tip  ("Create (or add to) GIS-Polygon from GIS-Point or CAD-Point/Curve (project > Mesh)");

  mb2s =
  GUI_Menu     (mb1f,"Save active Gis-Polygon as ", 's');
  GUI_MenuEntry(mb2s,"OuterBoundary",
                        gis_CB1, (void*)"obdEL");
  GUI_MenuEntry(mb2s,"InnerBoundary",
                        gis_CB1, (void*)"ibdEL");
  GUI_MenuEntry(mb2s,"EdgeLine",
                        gis_CB1, (void*)"elnEL");

  // GUI_MenuEntry(mb1f,"Create EdgeLine from active GIS-Polygon",
                        // gis_CB1, (void*)"elnEL");
  // GUI_MenuEntry(mb1f,"Create OuterBoundary from active GIS-Polygon",
                        // gis_CB1, (void*)"obdEL");
  // GUI_MenuEntry(mb1f,"Create InnerBoundary from active GIS-Polygon",
                        // gis_CB1, (void*)"ibdEL");


  wcbDelEl =
  GUI_MenuCkBox(mb1f,"Delete EdgeLine / Boundary",
                        gis_CB1, (void*)"delEL");
  GUI_MenuEntry(mb1f,"---", NULL, NULL);



  // GUI_MenuEntry (mb1f, "Create OuterBoundary from all points",
                        // gis_CB1, (void*)"obdPt");
  wcbprGis = 
  GUI_MenuCkBox(mb1f,"Create GIS-point",
                        gis_CB1, (void*)"cad2gis");
  GUI_Tip("Create GIS-point from CAD-Point/Curve (project > Mesh)");
  wcbprCad =
  GUI_MenuCkBox(mb1f,"Create CAD-Point/Curve",
                        gis_CB1, (void*)"cad2cad");
  GUI_Tip("Create CAD-Point/Curve from CAD-Point/Curve (project > Mesh) or from GIS-Point");
  wcbDelPt =
  GUI_MenuCkBox(mb1f,"Delete GIS-Point",
                        gis_CB1, (void*)"delPt");
  GUI_MenuEntry(mb1f,"---", NULL, NULL);


  wcbPrj =
  GUI_MenuCkBox(mb1f,"project CAD-objects to mesh",
                        gis_CB1, (void*)"prjObj");
  GUI_Tip("use unmodified CAD-Points/Curves or project to Mesh");



  //----------------------------------------------------------------
  // GUI_Butt (box1, "Import Points", gis_CB1,    (void*)"opePtab", 0);
  // GUI_Butt (box1, "Export Points", gis_CB1,    (void*)"savPtab", 0);
  GUI_Butt (box1, "Delete Points", gis_CB1,    (void*)"delPtab", 0);
  GUI_Tip  (" deletes active surface and ALL its points ");
  GUI_Butt (box1, " create Mesh ", gis_CB1,    (void*)"crMsh", 0);

  // create (empty) list for the mesh-surfaces
  wls = GUI_OptMen (box1, NULL, gis_Lst_CB, -30);
  GUI_Tip  (" change active surface ");

  // wcbdp = GUI_CkButt (box1, "disp.points", 1, NULL, NULL, 0);
  // wcbdi = GUI_CkButt (box1, "disp.info", 1, NULL, NULL, 0);

  wcbcp = GUI_CkButt (box1, "createPoint", 0, gis_CB1, (void*)"PtCre", 0);

  GUI_Butt (box1, "Exit", gis_CB1,    (void*)"Exit", 0);
  GUI_Butt (box1, "Help", gis_CB1,    (void*)"Help", 0);


  //----------------------------------------------------------------
  wlbas = GUI_Label (box2, " Surf.Nr A- ", 2);

  wlbap = GUI_Label (box2, " PointNr P- ", 2);

  wenvx = GUI_Entry (box2, " X: ", "", NULL, -90);
  wenvy = GUI_Entry (box2, " Y: ", "", NULL, -90);
  wenvz = GUI_Entry (box2, " Z: ", "", NULL, -90);

  GUI_Butt (box2, "Del.Pt.", gis_CB1,    (void*)"PtDel", 0);
  GUI_Butt (box2, "Mod.Pt.", gis_CB1,    (void*)"PtMod", 0);
  GUI_Butt (box2, "Add Pt.", gis_CB1,    (void*)"PtAdd", 0);

  GUI_Butt (box2, "Test", gis_CB1,    (void*)"fTest", 0);

  gtk_widget_show (tbc);

  return tbc;

}


//=====================================================================
  int gis_CB1 (GtkWidget *parent, void *data) {
//=====================================================================

  long l1;
  char *cp1, cbuf1[256];

  cp1 = (char*)data;

  printf("gis_CB1  /%s/\n",cp1);



  //-------------------------------------------------
  if(!strcmp(cp1, "Help")) {
    APP_Help (APP_NAME);



  //-------------------------------------------------
  } else if(!strcmp(cp1, "Exit")) {
    gCad_fini ();


  //-------------------------------------------------
  } else if(!strcmp(cp1, "opePtab")) {
    APP_Open ("Open Pointfile", (void*)gis_ptab_load);


  //-------------------------------------------------
  } else if(!strcmp(cp1, "savPtab")) {
    APP_Save ("Save Pointfile", "points.dat", (void*)gis_ptab_save);


  //-------------------------------------------------
  } else if(!strcmp(cp1, "delPtab")) {
    gis_PtabDel();


  //-------------------------------------------------
  } else if(!strcmp(cp1, "crMsh")) {
    if(actEl.rNr > 0) {
      TX_Print("********* WARNING: active Polygon not saved *******");
    }
    gis_mesh ();


  //-------------------------------------------------
  } else if(!strcmp(cp1, "PtDel")) {
    gis_PtDelAct();


  //-------------------------------------------------
  } else if(!strcmp(cp1, "PtMod")) {
    gis_PtMod();


  //-------------------------------------------------
  } else if(!strcmp(cp1, "PtAdd")) {
    gis_PtAdd();


  //-------------------------------------------------
  } else if(!strcmp(cp1, "PtCre")) {
    if(GUI_CkButt_get (wcbcp) == 1) 
      TX_Print("indicate position or select cad-point or select gis-point");


  //-------------------------------------------------
  } else if(!strcmp(cp1, "prjObj")) {
    if(GUI_get_CkBox (wcbPrj) == 1)
      TX_Print("use CAD-Points/Curves projected to Mesh");
    else 
      TX_Print("use unmodified CAD-Points/Curves");


  //-------------------------------------------------
  } else if(!strcmp(cp1, "cad2gis")) {     // Create GIS-Point
    if(GUI_get_CkBox (wcbprGis) == 1) {
      // switch off "Create CAD-Point/Curve"
      if(GUI_get_CkBox (wcbprCad) == 1) GUI_set_CkBox (wcbprCad, 0);
      // switch off "delete GIS-Point"
      if(GUI_get_CkBox (wcbDelPt) == 1) GUI_set_CkBox (wcbDelPt, 0);

      TX_Print("select CAD-Point or CAD-Curve ..");
    } else {
      TX_Print("Function Create-GIS-Point finished");
    }



  //-------------------------------------------------
  } else if(!strcmp(cp1, "cad2cad")) {     // Create CAD-Point/Curve
    if(GUI_get_CkBox (wcbprCad) == 1) {
      // switch off "delete GIS-Point"
      if(GUI_get_CkBox (wcbDelPt) == 1) GUI_set_CkBox (wcbDelPt, 0);
      // switch off "Create GIS-Point"
      if(GUI_get_CkBox (wcbprGis) == 1) GUI_set_CkBox (wcbprGis, 0);
      // switch on "project CAD-objects to mesh"
      if(GUI_get_CkBox (wcbPrj) == 0) GUI_set_CkBox (wcbPrj, 1);
  
      TX_Print("select CAD-Point or CAD-Curve ..");
    } else {
      TX_Print("Function Create-CAD-Point/Curve finished");
    }



  //-------------------------------------------------
  } else if(!strcmp(cp1, "creEL")) {
    if(GUI_get_CkBox (wcbcre) == 1) {

      // switch off "Create GIS-Point"
      if(GUI_get_CkBox (wcbprGis) == 1) GUI_set_CkBox (wcbprGis, 0);
      // switch off "Create CAD-Point/Curve"
      if(GUI_get_CkBox (wcbprCad) == 1) GUI_set_CkBox (wcbprCad, 0);
      // switch off "delete GIS-Point"
      if(GUI_get_CkBox (wcbDelPt) == 1) GUI_set_CkBox (wcbDelPt, 0);
      // switch off "Delete EdgeLine"
      if(GUI_get_CkBox (wcbDelEl) == 1) GUI_set_CkBox (wcbDelEl, 0);

      TX_Print("select Gis-Point or cad-Point or Cad-Curve to add to EdgeLine ..");
      // clear actEl, remove display
      gis_actEl_del ();

    } else {
      gis_actEl_del (); // clear actEl, remove display
      TX_Print("Function finished");
    }


  //-------------------------------------------------
  } else if(!strcmp(cp1, "elnEL")) {
      // check if closed
      actEl.use = TYP_EDGLN_BL; // EdgeLine
      TX_Print("active Polygon changed to EdgeLine ..");
      gis_Edges_upd (TYP_FuncAdd);
      GUI_set_CkBox (wcbcre, 0);     // create_polygon off


  //-------------------------------------------------
  } else if(!strcmp(cp1, "obdEL")) {
      // check if closed
      actEl.use = TYP_EDGLN_OB; // OuterBound
      TX_Print("active Polygon changed to OuterBound ..");
      gis_Edges_upd (TYP_FuncAdd);
      GUI_set_CkBox (wcbcre, 0);     // create_polygon off


  //-------------------------------------------------
  } else if(!strcmp(cp1, "ibdEL")) {
      // check if closed
      actEl.use = TYP_EDGLN_IB; // InnerBound
      TX_Print("active Polygon changed to InnerBound ..");
      gis_Edges_upd (TYP_FuncAdd);
      GUI_set_CkBox (wcbcre, 0);     // create_polygon off


  //-------------------------------------------------
  // } else if(!strcmp(cp1, "obdPt")) { // Create OuterBoundary from all points
      // gis_obd_cre();


  //-------------------------------------------------
  } else if(!strcmp(cp1, "delEL")) {
    if(GUI_get_CkBox (wcbDelEl) == 1) {
      // switch off ""Create GIS-Polygon"
      if(GUI_get_CkBox (wcbcre) == 1) GUI_set_CkBox (wcbcre, 0);
      TX_Print("select EdgeLine to delete ..");
    } else {
      TX_Print("delete-EdgeLine finished");
    }



  //-------------------------------------------------
  } else if(!strcmp(cp1, "delPt")) {
    if(GUI_get_CkBox (wcbDelPt) == 1) {
      // switch off "Create Gis-Polygon"
      if(GUI_get_CkBox (wcbcre) == 1) GUI_set_CkBox (wcbcre, 0);
      // switch off "Create GIS-Point"
      if(GUI_get_CkBox (wcbprGis) == 1) GUI_set_CkBox (wcbprGis, 0);
      // switch off "Create CAD-Point/Curve"
      if(GUI_get_CkBox (wcbprCad) == 1) GUI_set_CkBox (wcbprCad, 0);
      TX_Print("select GIS-Points to delete ..");
    }




  //-------------------------------------------------
  } else if(!strcmp(cp1, "fTest")) {
    GL_temp_delete();
    DL_Redraw ();
    // GL_temp_Delete (1L);   DL_Redraw ();
    // gis_dump_surTab ();
    // gis_dump_pTab ();



  //-------------------------------------------------
  } else {
    TX_Error("gis_CB1 E001 %s",cp1);
  }


  L_exit:
    return 0;

  L_EOM:
    TX_Error("gis_CB1 EOM");
    return -1;


}


/*
//================================================================
  int gis_obd_cre () {
//================================================================
// Create OuterBoundary from all points
// es fehlern noch die 2D-Punkte ..

  int       *ibp, ibNr;


  // get memSpc for the boundary ((p2Nr + 1) indices ..)
  i1 = p2Nr + 1;  // closing Pt
  ibp = (int*)UME_alloc_tmp(i1 * sizeof(int));
  // ibp = (int*)_alloca(p2Nr * sizeof(int));
  if(ibp == NULL) {TX_Error("gis_obd_cre EOF"); return -1;}


  //----------------------------------------------------------------
  // create outside-boundary into ibp
  MSH_ibnd_pt2n (ibp, &ibNr, p2a, p2Nr, NULL);
    printf(" ibNr=%d\n",ibNr);
    // for(i2=0;i2<i1;++i2) printf("ibp[%d]=%d\n",i2,ibp[i2]);

  // add closing point
  ibp[ibNr] = ibp[0];
  ++ibNr;

  // add OuterBound ibp to eTab
  gis_Edges_add (ibp, ibNr, 4);



  return 0;

}
*/


//================================================================
  int gis_mesh () {
//================================================================
// OFFEN:
// write "A# = MSH A<#_pTab>" into mainProg

  int     irc, att, i1, ii;
  // int     *iba, ibNr;
  long    dli, dbm, dbp, l1;
  // Mesh    ms1;
  // Fac3    *fTab = NULL;


  printf("gis_mesh %d\n",ActSurPtb);
  if(ActSurPtb < 0) return 0;



  // fix mesh-surf-Nr
  if(surTab[ActSurInd].indm > -1) {           // use existing
    dbm = surTab[ActSurInd].indm;

  } else {                             // create new mesh-surf
    ++surIndLast;
    dbm = surIndLast;
      printf(" next A-nr = %d\n",dbm);
    surTab[ActSurInd].modif = 1;
  }
    printf(" dbm=%d\n",dbm);




  // reload points > pTab if modfied
  gis_bload_pTab (TYP_FuncInit);
  printf("gis_mesh 1 %d\n",ActPtab.rNr);



  // update points-display
  gis_HideAllPoints ();
  gis_DrawPoints (ActPtab.data, ActPtab.rNr, ActSurPtb, 0);
  surTab[ActSurInd].visi = 1;


  // // get space for boundary
  // iba = (int*)memspc101;
  // ibNr = sizeof(memspc101) / sizeof(int);    // 4 byte


  // create Mesh
  irc = _MSH_msh1 (&ActFtab, &ActEtab, &DatEtab,
                   ActPtab.data, ActPtab.rNr);
                // iba, &ibNr, ActPtab.data, ActPtab.rNr);
  if(irc < 0) return -1;
    printf("gis_mesh 2 fNr=%d\n",ActFtab.rNr);
    MSH_dump_eTab (&ActEtab, &DatEtab);


  // save Mesh into binFile
  gis_bsave_fTab (dbm);
  ActFtabModFlag = 0; // unmodified.
  // load faces
  // gis_bload_fTab (TYP_FuncEnd);
  // printf("gis_mesh 3 fNr=%d\n",ActFtab.rNr);


  // update the boundary-display
  // get ii=index of OutBound in eTab
  for(ii=0; ii<ActEtab.rNr; ++ii) {
    if(ActEtab.data[ii].typ == TYP_EDGLN_OB) goto L_disp_cv;
  }
    TX_Print("gis_mesh E001");
    return -1;
  L_disp_cv:
    printf(" ind.OB=%d\n",ii);


  // if(surTab[ActSurInd].indm > -1) {
    dbp = surTab[ActSurInd].indp;
    // find dli of point-surf
    dli = DL_find_obj (Typ_SUR, dbp, -1L);
      printf(" dbp=%d dli=%d\n",dbp,dli);
    DL_SetInd (dli);             // modify (do not create new DL-Record)
    att = 5;                     // hier act Color uebernehmen !!!
    dli = DL_StoreObj (Typ_SUR, dbp, att);
    // GL_DrawCvIpTab (&dli, att, iba, ibNr, ActPtab.data, 1);
    GL_DrawCvIpTab (&dli, att,
                    ActEtab.data[ii].ia, ActEtab.data[ii].iNr,
                    ActPtab.data, 1);
  // }


  // update the mesh-display (copies dbm > surTab[ActSurInd].indm)
  gis_msh_disp (1, ActSurInd, dbm);

  ActSurMsh = dbm;

  printf("gis_mesh 4\n");


  DL_Redraw ();

  return 0;

}


//================================================================
  int gis_msh_disp (int styl, int inds, long dbm) {
//================================================================
// styl: 0=ON=shade; 1=OFF=symbolic
// inds  index to surTab


  int     iFirst, att;
  long    dli;


  printf("DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD \n");
  printf("gis_msh_disp styl=%d inds=%d dbm=%d\n",styl,inds,dbm);
// gis_dump_surTab ();


  // first time to create mesh ?
  if(surTab[inds].indm != dbm) {
    surTab[inds].indm = dbm;
    iFirst = 1;  // yes
  } else {
    iFirst = 0;  // no
  }


  // load points > pTab
  gis_bload_pTab (TYP_FuncInit);
  printf("gis_msh_disp 1 pNr=%d\n",ActPtab.rNr);



  // load Mesh surTab[inds].indm > fTab
  gis_bload_fTab (TYP_FuncInit);
  printf("gis_msh_disp 2 fNr=%d eNr=%d\n",ActFtab.rNr,ActEtab.rNr);


/*
    col = (ColRGB*)&GR_ObjTab[dli].iatt;
    col->vsym = 0;
*/

  // (Re-)Display mesh
  if(iFirst == 0) {
    // use existing dli - modify
    dli = DL_find_obj (Typ_SUR, dbm, -1L);
      printf(" dbm=%d dli=%d\n",dbm,dli);
    DL_SetInd (dli);  // modify (do not create new DL-Record)
  }




  att = 8;   // hier act Color uebernehmen !!!
  // att = 1;   // 8= blau ?

  printf(" fNr=%d\n",ActFtab.rNr);

  dli = DL_StoreObj (Typ_SUR, dbm, att);
  GL_Surf_Ini (&dli, (void*)&att);           // att unused ..
  // GR_DrawFtab (ActPtab.data, ActFtab.data, ActFtab.rNr, styl);
  GL_DrawFtab (ActPtab.data, ActFtab.data, ActFtab.rNr, styl);
  GL_EndList ();



  return 0;

}
 

//================================================================
  int gis_disp_surNr () {
//================================================================
// display activeSurfNr & activePointNr

  char      cbuf[128];


  // display new activeSurfNr in Label
  if(ActSurPtb >= 0) {
    sprintf(cbuf, " SurfNr. = A%d ",ActSurPtb);
  } else {
    sprintf(cbuf, " SurfNr. = -- ");
  }
  GUI_Label_mod (wlbas, cbuf);


  // display new activePointNr in Label
  if(ActPtNr >= 0) {
    sprintf(cbuf, " PointNr. = P%d ",ActPtNr);
  } else {
    sprintf(cbuf, " PointNr. = -- ");
  }
  GUI_Label_mod (wlbap, cbuf);

  return 0;

}


//================================================================
  int gis_disp_coords (Point *p1) {
//================================================================

  char      cbuf[60];

  cbuf[0] = '\0';
  UTX_add_fl_u (cbuf, p1->x);
  GUI_Entry_set (wenvx, cbuf);
  cbuf[0] = '\0';
  UTX_add_fl_u (cbuf, p1->y);
  GUI_Entry_set (wenvy, cbuf);
  cbuf[0] = '\0';
  UTX_add_fl_u (cbuf, p1->z);
  GUI_Entry_set (wenvz, cbuf);

  return 0;

}


//================================================================
  int gis_sel_CB (int src, long dl_ind) {
//================================================================
// userselection-callback; CAD-Core reports selection

// --------------------------------------------------------
// "Create GIS-Polygon"             "creEL"       wcbcre         ice=1
// save as OuterBoundary            "obdEL"
// save as InnerBoundary            "ibdEL"
// save as EdgeLine                 "elnEL"
// "Delete EdgeLine / Boundary"     "delEL"       wcbDelEl       ide
// --------------------------------------------------------
// "Create GIS-Point"               "cad2gis"     wcbprGis       ice=2
// "Create CAD-Point/Curve"         "cad2cad"     wcbprCad       ice=3
// "delete GIS-Point"               "delPt"       wcbDelPt       idp
// --------------------------------------------------------
// "project CAD-objects to mesh"    "prjObj"      wcbPrj         ipr
// --------------------------------------------------------


  int       i1, ipr, icp, ice, ide, idp, p1Nr, p2Nr, *ia;
  long      dli, dbi;
  char      cbuf[128];
  Point     *pa1, *pa2, p1;
  DL_Att    dla;

  printf("gis_sel_CB src=%d dl_ind=%d\n",src,dl_ind);

  ipr   = GUI_get_CkBox (wcbPrj);     // project > Mesh; 0=no, 1=yes
  ice = 0;
  i1    = GUI_get_CkBox (wcbcre);     // createEdgeLine; 0=no, 1=yes
  if(i1 > 0) ice = 1;
  i1    = GUI_get_CkBox (wcbprGis);   // cad2gis; 0=no, 1=yes
  if(i1 > 0) ice = 2;
  i1    = GUI_get_CkBox (wcbprCad);   // cad2cad; 0=no, 1=yes
  if(i1 > 0) ice = 3;
  icp   = GUI_CkButt_get (wcbcp);     // createPoint; 0=no, 1=yes
  ide   = GUI_get_CkBox (wcbDelEl);   // deleteEdgeLine; 0=no, 1=yes
  idp   = GUI_get_CkBox (wcbDelPt);   // deleteGISPoint; 0=no, 1=yes
    printf(" ipr=%d icp=%d ice=%d ide=%d idp=%d\n",ipr,icp,ice,ide,idp);


  if(dl_ind < 0) {     // indicate
    if(icp == 0) return 0;
    // get userCoords of indicated point
    p1 = GL_GetViewPos ();
    // create gis-point
    gis_disp_coords (&p1);
    gis_PtAdd ();
    return 0;
  }


  // get DL-record of selected object
  dla = DL_GetAtt(dl_ind);
    printf(" sel.typ=%d\n",dla.typ);



  //----------------------------------------------------------------
  // gis-obj selected
  //----------------------------------------------------------------
  if(dla.typ != Typ_APPOBJ) goto L_CadObj;

  //---------------------------------------------------
  // gis-Point selected
  if(dla.iatt != APPTYP_GISPT) goto L_sel_EL;

  // decode Object gis-point
  ActPtDli = dl_ind;
  // ActPtNr  = dla.iatt;     // PointNr
  ActPtNr  = dla.ind;     // PointNr

  // display activeSurfNr & activePointNr
  gis_disp_surNr ();

  // display PointCoords in wenvx/y/z
  gis_disp_coords (&ActPtab.data[ActPtNr]);


  // gis-point selected:
  if(idp != 0) goto L_del_gisPt;    // idp=1 "delete GIS-Point"
  if(icp != 0) goto L_cre_cadPt0;   // AddPt-Button

  // ice=1: add selected gis-point to active EdgeLine
  if(ice == 1) {gisEdg_addGisPt (); return 0;}
  // ice=2: -
  // ice=3: create cad-point from gis-point
  if(ice == 3) goto L_cre_cadPt0;

  return 0;


  //---------------------------------------------------
  // gis-Edgeline selected
  L_sel_EL:
  if(dla.iatt != APPTYP_EDGLN) {TX_Print("gis_sel_CB I001"); return -1;}
  // EdgeLine selected ..
  if(ide == 0) return 0;
  // delete this EdgeLine
    printf(" del EL %d\n",dla.ind);
  gis_Edges_del (dla.ind);
  return 0;




  //----------------------------------------------------------------
  // cad-obj selected:
  //----------------------------------------------------------------
  L_CadObj:

  //----------------------------------------------------------------
  // cad-point selected:
  if(dla.typ != Typ_PT) goto L_cadObj1;
    pa1 = DB_get_PT (dla.ind);

    if(idp > 0) return 0; // DelGis-Pt: skip selection of cad-point

    // project point
    if(ipr != 0) {
      i1 = MSH_pt_prjptmsh_ (&p1, pa1, ActSurMsh, ActSurPtb);
      if(i1 != 0) {TX_Print("point is not inside mesh .."); return 0;}
      pa1 = &p1;
    }
    
    // ice=1 = "Create GIS-Polygon" from cad-point
    if(ice == 1) {
      gis_addPtab (&ia, pa1, 1);  // create GIS-point
      ActPtNr = ia[0];
      gisEdg_addGisPt ();         // add Gis-point to active EdgeLine;
      return 0;
    }

    // ice=2 = create gis-point from cad-point at pa1
    if(ice == 2) goto L_cre_gisPt;

    // ice=3 = "Create CAD-Point" 
    if(ice == 3) goto L_cre_cadPt1;



  //----------------------------------------------------------------
  L_cadObj1:

    // decode; get polygon from DB-object.
    pa1 = (Point*)memspc201;
    p1Nr = sizeof(memspc201) / sizeof(Point);
    i1 = UT3D_pta_dbo (&pa1, &p1Nr, dla.typ, dla.ind, UT_DISP_cv);
    if(i1 < 0) return 0;


    // project Obj
    if(ipr == 1) {
      // create polygon from inputcurve
      i1 = MSH_npt_prjcvmsh_ (&pa2, &p2Nr, pa1, p1Nr,
                              &ActFtab, &ActPtab, &ActEtab, &DatEtab);
      if(i1 != 0) {TX_Print("obj. is not inside mesh .."); return 0;}
      pa1 = pa2;
      p1Nr = p2Nr;
    }


    // ice=1 = "Create GIS-Polygon" from CadCurve
    if(ice == 1) {
      // create GIS-points from polygon
      gis_addPtab (&ia, pa1, p1Nr);
      // create Edgeline from polygon (add cv to actEl)
      gisEdg_addPtab (ia, p1Nr);
    }


    // ice=2 create Gis-points
    if(ice == 2) {
      // create GIS-points from polygon
      gis_addPtab (&ia, pa1, p1Nr);
    }


    if(ice == 3) {        // ice=3 Create CadCurve
      goto L_cre_CadPlg;
    }


    DL_Redraw ();


    return 0;




  //----------------------------------------------------------------
  // create gis-point
  L_cre_gisPt:
    gis_disp_coords (pa1);
    gis_PtAdd ();
    return 0;


  //----------------------------------------------------------------
  // create cad-point
  L_cre_cadPt0:
    p1 = ActPtab.data[ActPtNr];


  // create a CAD-Point at p1
  L_cre_cadPt1:
    i1 = DB_QueryLastUsed (Typ_PT, 1);
    ++i1;
    sprintf(cbuf, "P%d=",i1);
    AP_obj_add_pt(cbuf, &p1);
  
    ED_add_Line (cbuf);
    DL_Redraw ();                 // Redraw DispList
  
    return 0;



  //----------------------------------------------------------------
  // create CAD-Polygon from  pa1[p1Nr]
  L_cre_CadPlg:
  UTO_sav_ost (&i1, &dbi, Typ_CVPOL, Typ_PT, p1Nr, (void*)pa1);




  //----------------------------------------------------------------
  // delete gis-point
  L_del_gisPt:
  gis_PtDel__ (ActPtDli, ActPtNr); // add point ActPtNr to active EdgeLine;
  ActPtNr = -1;
  gis_disp_surNr ();
  return 0;



  //----------------------------------------------------------------


}


//================================================================
  int gis_addPtab (int **iTab, Point *pTab, int pNr) {
//================================================================
// create GIS-points; return pointNumbers.
// see also gis_PtAdd
// returns iTab in memspc102 ! (do not free)

  int    i1, iAct, *ia, iaSiz, ii;


  printf("gis_addPtab %d\n",pNr);


  // get memspc for iTab
  ia = (int*)memspc102;
  iaSiz = sizeof(memspc102) / sizeof(int);
  if(iaSiz < pNr) {TX_Error("gis_addPtab EOM1"); return -1;}


  for(iAct=0; iAct<pNr; ++iAct) {

    // test if point already exists; (2D-Test; tolerance = TOL_GIS_PT)
    ii = MSH_ck_pt3 (ActPtab.data, ActPtab.rNr, &pTab[iAct]);
    // -1=new, >=0=already exists
    if(ii >= 0) {
      TX_Print("point %d not modified; check Z-value ..",ii);
      goto L_store;
    }

    // get a free pos in ActPtab
    ii = gis_freePos_pTab ();
    if(ii < 0) {TX_Error("gis_addPtab E001"); return -1;}

    // save point in ?
    ActPtab.data[ii] = pTab[iAct];

    L_store:
      ia[iAct] = ii;

    // display point
    gis_DrawPoints (&ActPtab.data[ii], 1, ActSurPtb, ii);
  }


  ActPtabModFlag = 1;
  ActFtabModFlag = 1;


  *iTab = ia;

    for(ii=0;ii<pNr;++ii) printf(" ia[%d]=%d\n",ii,ia[ii]);

  return 0;

}


//===================================================================
  int gis_bload_pTab (int mode) {
//===================================================================
// load or save points from/to bin. file.
// mode=TYP_FuncInit   Load ActPtab from file A<ActSurPtb>
// mode=TYP_FuncEnd    save ActPtab to file A<ActSurPtb>

  int   i1, ii;

  static int oldSur = -1;


  printf("gis_bload_pTab mode=%d sur=%d pNr=%d\n",mode,ActSurPtb,ActPtab.rNr);
  printf("               oldSur=%d flg=%d\n",oldSur,ActPtabModFlag);


  if(ActSurInd < 0) return -1;


  // TYP_FuncEnd:  save points into bin.File
  if(mode == TYP_FuncEnd) {
    if(ActPtab.data) {
      if(ActPtabModFlag) {
        gis_bsave_pTab (); // save ActPtab > file A<ActSurPtb>
        surTab[ActSurInd].modif = 1;
      }
      // printf(" <<<<<<<<<<<<<<<<<<<<  free ActPtab\n");
      // APP_free (&ActPtab.data);
      ActPtab.rNr = 0;
      ActPtabModFlag = 0;
      // ActPtab = NULL;
    }
    return 0;
  }

 
  // TYP_FuncInit = Load.


  // if(ActPtab.data == NULL) goto L_new_load;
  if(ActPtab.rNr == 0) goto L_new_load;
  if(oldSur != ActSurPtb) goto L_load;
  if(ActPtabModFlag == 0) return 0;


  L_load:

  if(ActPtabModFlag) gis_bsave_pTab (); // save ActPtab > file A<ActSurPtb>
    // printf(" <<<<<<<<<<<<<<<<<<<<  free ActPtab %p\n",ActPtab);
  ActPtab.rNr = 0;
  // APP_free (&ActPtab.data);
  // ActPtab = NULL;


  L_new_load:
  // load pTab from bin.file; mallocs ActPtab !
  i1 = MSH_bload_pTab (&ActPtab, -1, ActSurPtb);
  if(i1 < 0) return -1;
    printf(" ActPtab.rNr=%d\n",ActPtab.rNr);

  oldSur = ActSurPtb;
  ActPtabModFlag = 0;    // unmodified

  // dump pTab
  // for(i1=0; i1<ActPtab.rNr; ++i1)
  // UT3D_stru_dump (Typ_PT,&ActPtab.data[i1],"P[%d]",i1);

  return 0;

}

//================================================================
  int gis_bsave_fTab (int dbSurM) {
//================================================================
// save mesh & EdgeLines into binary file
 
  printf("gis_bsave_fTab %d\n",dbSurM);

  MSH_bsav_fTab (&ActFtab, &ActEtab, &DatEtab, -1, dbSurM);

  return 0;

}


//================================================================
  int gis_bload_fTab (int mode) {
//================================================================
// mode=TYP_FuncEnd: unload mesh; save if modified.

  int    ii, dbSurM;

  static int oldSur = -1;


  printf("gis_bload_fTab %d\n",mode);


  if(ActSurInd < 0) return -1;

  dbSurM = surTab[ActSurInd].indm;
    printf(" ActSurPtb=%d ActSurInd=%d dbSurM=%d\n",ActSurPtb,ActSurInd,dbSurM);


  // TYP_FuncEnd:  save Mesh into bin.File
  if(mode == TYP_FuncEnd) {
    if(ActFtab.data) {
      if(ActFtabModFlag) {
        surTab[ActSurInd].modif = 1;
        gis_bsave_fTab (dbSurM);
      }
      // APP_free (&ActFtab.data);
      ActFtab.rNr = 0;
      // ActFtab = NULL;
    }
    return 0;
  }


  // if(ActFtab.data == NULL) goto L_new_load;
  if(ActFtab.rNr == 0) goto L_new_load;
  if(oldSur != dbSurM) goto L_load;
  if(ActFtabModFlag == 0) return 0;


  L_load:

  if(ActFtabModFlag) gis_bsave_fTab (dbSurM);

  ActFtab.rNr = 0;
  // APP_free (&ActFtab.data);
  // ActFtab = NULL;


  L_new_load:
  // load pTab from bin.file; mallocs ActPtab !
  // MSH_bload_fTab (&ActFtab.data, &ActFtab.rNr, -1, dbSurM);
  MSH_bload_fTab (&ActFtab, &ActEtab, &DatEtab, -1, dbSurM);
    printf(" ActFtab.rNr=%d\n",ActFtab.rNr);

  oldSur = dbSurM;
  ActFtabModFlag = 0;    // unmodified


  return 0;

}


//================================================================
  int gis_bsave_pTab () {
//================================================================
// save all points of ActPtab into file A<ActSurPtb>

  int   i1;


  printf("gis_bsave_pTab %d\n",ActPtab.rNr);
 
  // delete unused points
  for(i1=ActPtab.rNr-1; i1 >= 0; --i1) {
    if(ActPtab.data[i1].x != UT_VAL_MAX) continue;

    // delete point in ActPtab
    MemTab_del (&ActPtab, i1, 1);

    // check if this point is used by EdgeLines; 
    // if yes: remove this point from the EdgeLines 
    // decrement all pointNr's higher than i1 in the EdgeLines
    MSH_EL_del_pt (&ActEtab, &DatEtab, i1);

  }

  // recover EdgeLines
  MSH_eTab_fix (&ActEtab, &DatEtab);


  // save pTab
  MSH_bsav_pTab (&ActPtab, -1, ActSurPtb);


  return 0;

}

 
//=====================================================================
  int gis_lst_sup () {
//=====================================================================
// create list of point-surfaces from surTab

  int    i1, sl;
  char   *pBuf[MAX_SURPTAB], cbuf1[40], *cBuf2;


  cBuf2 = memspc55;


  // Create a List of Pointers for a list of words.
  for(i1=0; i1<surTabNr;  ++i1) {
    sprintf(cbuf1, " A%d ", surTab[i1].indp);
    sl = strlen(cbuf1);
    strcpy(cBuf2, cbuf1);
    cBuf2[sl] = '\0';
    pBuf[i1] = cBuf2;
    cBuf2 += sl+1;
  }

  pBuf[surTabNr] = NULL; // terminat List



  // GUI_OptMen (parent, pBuf, gis_Lst_CB, 0);

  GUI_OptMenChg (wls, pBuf, gis_Lst_CB);




  return 0;

}


//===================================================================
  int gis_Lst_CB (GtkWidget *parent, void *data) {
//===================================================================
// userselection of listEntry

  int   lNr;

  lNr = (int)data;

  printf("gis_Lst_CB A%d\n",surTab[lNr].indp);


  /// activate surface surTab[lNr]
  gis_surPt_chg (lNr);



  return 0;

}


//================================================================
  int gis_init_pl () {
//================================================================
// fill surTab-List from ModelCodes


/*
  int      i1, grpNr;
  ObjGrp   grp[MAX_SURPTAB];
  ObjGX    flt[1];
  flt[0].typ = Typ_SURPTAB;  // filter all surfaces
  grpNr = MAX_SURPTAB;
  i1 = DB_Filter__ (&grp, &grpNr, &flt, 1);
  // fehlerhaft; da Objekte in der DB nicht geloescht werden !
*/


  int   irc, typ, ii, ind1, ind2, lNr, lLen;
  char  *lSta, *p1;


  printf("---------- gis_init_pl ----------\n");

  lSta = NULL;

  surTabNr = 0;
  for(;;) {
    // get next surface
    irc = APED_nxt_def_typ (&lSta, &lNr, &lLen, Typ_SUR);
    if(irc < 0) break;

      // printf(" nxt ln |");UTX_dump_cnl (lSta, 40);printf("|\n");
      

    // check for PTAB-SUR; next word after '=' must be PTAB
    p1 = UTX_find_Del1 (lSta);
    while(*p1 == ' ') ++p1;
    if(*p1 != '=') continue;

    irc = APT_decode_obj (&typ, &ind1, lSta);
    if(irc != 0) continue;
      // printf(" typ=%d ind1=%d\n",typ,ind1);

    // find next delimiter
    ++p1;
    while(*p1 == ' ') ++p1;

    if(!strncmp(p1, "PTAB", 4)) {
      surTab[surTabNr].indp   = ind1;           // DB-Index.
      surTab[surTabNr].indm   = -1;
      surTab[surTabNr].visi  = 0;               // not yet visible
      surTab[surTabNr].exi_p = 1;               // 1=exists in Model
      surTab[surTabNr].exi_m = 0;               // 0=does not exists in Model
      surTab[surTabNr].modif = 0;               // 0=unmodfied
      ++surTabNr;
    }

    if(!strncmp(p1, "MSH", 3)) {
      // find db-ind of pointSurface
      p1 += 4;
      while(*p1 == ' ') ++p1;
      irc = APT_decode_obj (&typ, &ind2, p1);
        // printf(" p1=|%s| %d %d\n",p1,typ,ind2);
      if(irc != 0) continue;
      if(typ != Typ_SUR) {printf("gis_init_pl E001\n"); continue;}
      // find pointSurf with ind ind1; set mesh-ind to ind2
      ii = gis_surInd_surNr (ind2);
      if(ii < 0) {printf("gis_init_pl E002\n"); continue;}
      surTab[ii].indm = ind1;
      surTab[ii].exi_m = 1;
        printf(" surTab[%d].indm = %d\n",ii,ind2);
    }

  }


  printf("ex gis_init_pl %d\n",surTabNr);


  return 0;

}


//================================================================
  int gis_UI_getPt (Point *pt1) {
//================================================================

  char    *p1, *p2;


  p1 = GUI_Entry_get (wenvx);
  if(strlen(p1) < 1) goto L_err1;
  pt1->x = strtod (p1, &p2);

  p1 = GUI_Entry_get (wenvy);
  if(strlen(p1) < 1) goto L_err1;
  pt1->y = strtod (p1, &p2);

  p1 = GUI_Entry_get (wenvz);
  if(strlen(p1) < 1) goto L_err1;
  pt1->z = strtod (p1, &p2);

  UT3D_stru_dump(Typ_PT, pt1, "ex gis_UI_getPt:");

  return 0;

  L_err1:
  TX_Print("***** coordinate - inputfield empty *****");
  return -1;

}


//================================================================
  int gis_surInd_surNr (int surNr) {
//================================================================
// get index into surTab from DB-index of pointSurface

  int surInd;

  for(surInd=0; surInd<surTabNr;  ++surInd) {
    if(surTab[surInd].indp == surNr) return surInd;
  }

  return -1;

}

 
//================================================================
  int gis_PtabDel () {
//================================================================
// delete (all Points from) surface ActSurPtb

  int   irc, i1, lNr;
  long  dli, dbi;
  char  *lPos, oNam[32];

  printf("gis_PtabDel %d %d\n",ActSurInd,ActSurPtb);
  if(ActSurInd < 0) return -1;

  // gis_dump_surTab ();



  //----------------------------------------------------------------
  // delete mesh
  dbi = surTab[ActSurInd].indm;
  if(dbi < 0) goto L_p;
    printf(" dbi-m=%d\n",dbi);


  if(surTab[ActSurInd].indm < 0) goto L_p;

  // // delete bin.Mesh
  // MSH_bdel_fTab (WC_modnr, dbi);

  if(surTab[ActSurInd].exi_m == 0) {
    // delete mesh-display
    dli = DL_find_obj (Typ_SUR, dbi, -1L);
     // printf(" del %d %d\n",dbi,dli);
    GL_Del0 (dli);

  } else {
    // delete Mesh from model (deletes also its display)
    gis_mdl_del_msh (ActSurInd);
  }




  //----------------------------------------------------------------
  // delete all points from display
  L_p:
  if(surTab[ActSurInd].visi == 1)
    gis_HidePoints (surTab[ActSurInd].indp);


  // delete pTab-Code from model (del A<ActSurInd> - Line)
  if(surTab[ActSurInd].exi_p == 0) {
    dbi = surTab[ActSurInd].indp;
    if(dbi < 0) goto L_9;
      printf(" dbi-p=%d\n",dbi);
    // delete mesh-display
    dli = DL_find_obj (Typ_SUR, dbi, -1L);
     // printf(" del %d %d\n",dbi,dli);
    GL_Del0 (dli);

  } else {
    gis_mdl_del_pTab (ActSurInd);
  }


  // // delete bin. pointFile
  // MSH_bdel_pTab (WC_modnr, ActSurPtb);



  //----------------------------------------------------------------
  L_9:
  // delete record # ActSurInd from surTab
  MEM_del_nrec (&surTabNr, surTab, ActSurInd, 1, sizeof(typ_sur_ptab));

  // update surf-list
  gis_lst_sup ();

  // activate last surf
  gis_surPt_chg (surTabNr-1);

  DL_Redraw ();

  return 0;

}

 
//================================================================
  int gis_PtDelAct () {
//================================================================
// delete Point Nr ActPtNr from surface ActSurPtb
// Point.x is set to UT_VAL_MAX; nothing else ..


  printf("gis_PtDelAct %d %d %d\n",ActSurPtb,ActPtNr,ActPtDli);


  if(ActPtNr < 0) {
    TX_Print(" select point to delete ..");
    return 0;
  }
  if(ActPtNr >= ActPtab.rNr) { TX_Error("gis_PtDelAct E001"); return -1; }


  // // load points > pTab
  // gis_bload_pTab (TYP_FuncInit);


  gis_PtDel__ (ActPtDli, ActPtNr);

  // update Labels; ActPtNr-display
  ActPtNr = -1;
  gis_disp_surNr ();


  return 0;

}

 
//================================================================
  int gis_PtDel__ (long dli, int ptNr) {
//================================================================
// delete Point Nr ActPtNr from surface ActSurPtb
// Point.x is set to UT_VAL_MAX; nothing else ..


  // delete point ActPtNr from Display
  GL_Del0 (dli);
  // DL_unvis_set (ActPtDli, 1);
  DL_Redraw ();                 // Redraw DispList


  // delete point ActPtNr in pTab
  ActPtab.data[ptNr].x = UT_VAL_MAX;



  ActPtabModFlag = 1;
  ActFtabModFlag = 1;
 
  return 0;

}


//================================================================
  int gis_PtMod () {
//================================================================
// modify Point Nr ActPtNr from surface ActSurPtb

  int    i1;
  Point  pt1;


  printf("gis_PtMod %d %d %d\n",ActSurPtb,ActPtNr,ActPtDli);


  if(ActPtNr < 0) {
    TX_Print(" select point to modify ..");
    return 0;
  }


  // get point from UI
  i1 = gis_UI_getPt (&pt1);
  if(i1 < 0) return -1;


  // test if point already exists; (2D-Test; tolerance = TOL_GIS_PT)
  ActPtab.data[ActPtNr].x = UT_DB_LEER;  // cannot find this point as equal
  if(MSH_ck_pt3(ActPtab.data, ActPtab.rNr, &pt1) >= 0) {
    TX_Print("***** point already exists ..");
    return 0;
  }


  // // load points > pTab
  // gis_bload_pTab (TYP_FuncInit);


  // modify point ActPtNr from Display
  DL_SetInd (ActPtDli);   // modify DL
  gis_DrawPoints (&pt1, 1, ActSurPtb, ActPtNr);
  DL_Redraw ();                 // Redraw DispList


  // modify point ActPtNr in pTab
  ActPtab.data[ActPtNr] = pt1;

  ActPtabModFlag = 1;
  ActFtabModFlag = 1;

  return 0;

}


//================================================================
  int gis_ptab_init () {
//================================================================
 
  printf(" gis_ptab_init\n");


  ActPtab.rNr = 0;

  
  // surNr = find next free surface-nr (A)
  ++surIndLast;
  ActSurPtb = surIndLast;
    printf(" init ActSurPtb %d\n",ActSurPtb);


  // add surf to surTab
  gis_surTab_add (ActSurPtb, 0);
  // ActSurPtb = surNr;


  // add surf to List
  gis_lst_sup ();


  // activate new surface
  gis_surPt_chg (surTabNr-1);

  return 0;

}


//================================================================
  int gis_PtAdd () {
//================================================================
// add Point to surface ActSurPtb

  int    i1;
  Point  pt1;


  printf("gis_PtAdd %d %d\n",ActSurPtb,ActPtab.rNr);

  if(ActSurPtb < 0) {
    TX_Print("***** create new pointTable.");
    gis_ptab_init ();
  }


  // get point from UI
  i1 = gis_UI_getPt (&pt1);
  if(i1 < 0) return -1;


  // test if point already exists; (2D-Test; tolerance = TOL_GIS_PT)
  if(MSH_ck_pt3(ActPtab.data, ActPtab.rNr, &pt1) >= 0) {
    TX_Print("***** point already exists ..");
    return 0;
  }

  // // load points > pTab
  // gis_bload_pTab (TYP_FuncInit);


  // get a free pos in pTab
  ActPtNr = gis_freePos_pTab ();
  if(ActPtNr < 0) return -1;


  // unhilite active point
  GL_UnHiliObj (ActPtDli);


  // create point ActPtab.rNr from Display
  // hier fehlt noch PunktIndexOffset !
  gis_DrawPoints (&pt1, 1, ActSurPtb, ActPtNr);


  // hilite last created object
  GL_HiliObj (ActPtDli);
  DL_Redraw ();                 // Redraw DispList


  // save point in pTab
  ActPtab.data[ActPtNr] = pt1;

  // update ActPtNr-display
  gis_disp_surNr ();

  ActPtabModFlag = 1;
  ActFtabModFlag = 1;

  TX_Print("point %d added..",ActPtNr);

  return 0;

}


//================================================================
  int gis_freePos_pTab () {
//================================================================
// return next free Position in pTab; update ActPtab.rNr
// creates new (empty) point in ActPtab if necessary.

  int    i1, i2;
  long   ld;


  // printf("FFFFFFFFFFFF gis_freePos_pTab %p %d\n",ActPtab.data,ActPtab.rNr);

  for(i1=0; i1<ActPtab.rNr; ++i1) {
    if(ActPtab.data[i1].x == UT_VAL_MAX) goto L_exit;
  }


  // no free pos; realloc.
  printf("gis_freePos_pTab %d\n",ActPtab.rNr);
  MemTab_sav (&ActPtab, &ld, NULL, INC_Ptab);

  if(ActPtab.data == NULL) {TX_Error("gis_freePos_pTab EOM"); return -1;}

  // new points are unused
  for(i2=ActPtab.rNr; i2<ActPtab.rMax; ++i2) ActPtab.data[i2].x = UT_VAL_MAX;

  i1 = ActPtab.rNr;
  ActPtab.rNr += 1;


  L_exit:
  printf("ex gis_freePos_pTab %d\n",i1);
  return i1;

}
 

//================================================================
  int gis_ptab_save (char *fnam, char *dirNam) {
//================================================================
// Export points into Ascii-file


  int   i1;
  char  cbuf[256];
  FILE  *fpo;

  if(fnam == NULL) return 0;


  printf("gis_ptab_save |%s|%s|\n",dirNam,fnam);


  // unload active surf
  gis_bload_pTab (TYP_FuncEnd);

  // load points > pTab
  gis_bload_pTab (TYP_FuncInit);


  if(ActPtab.rNr < 1) {
    TX_Print(" pTab not active ..");
    return 0;
  }


  sprintf(cbuf,"%s%s",dirNam,fnam);
  if((fpo=fopen(cbuf,"w")) == NULL) {
    TX_Print("gis_ptab_save E001 %s",fnam);
    return -1;
  }


  for(i1=0; i1<ActPtab.rNr; ++i1) {
    // printf(" %d %f %f %f\n",i1,
            // ActPtab.data[i1].x,ActPtab.data[i1].y,ActPtab.data[i1].z);
    fprintf(fpo,"P%d %f %f %f\n",i1,
            ActPtab.data[i1].x,ActPtab.data[i1].y,ActPtab.data[i1].z);
  }

  fclose(fpo);

  return 0;

}


//================================================================
  int gis_surPt_chg (int surInd) {
//================================================================
// disactivate surface surTab[ActSurInd]
// activate surface surTab[surInd]

  int        irc, actInd;
  long       dli, dbi;
  ColRGB     *col;



  printf("gis_surPt_chg %d act=%d\n",surInd,ActSurInd);


  // no change: exit ...
  if(surInd == ActSurInd) return 0;
  // if(ActSurPtb == surTab[surInd].indp) return 0;


  // if no surf exists
  if(surInd < 0) {
    ActSurInd  = -1;
    ActSurPtb  = -1;
    ActSurMsh  = -1;
    ActPtNr    = -1;
    gis_disp_surNr ();
    return 0;
  }


  // unload active surf-points
  gis_bload_pTab (TYP_FuncEnd);  // save ActPtab to file A<ActSurPtb>


  // delete display of all points
  gis_HideAllPoints ();

  // remove the Display of all EdgeLines
  gis_HideAllEL (&ActEtab);

  // delete Edglines
  ActEtab.rNr = 0;
  DatEtab.rNr = 0;


  //----------------------------------------------------------------
  // change display of active mesh to shaded
  if(ActSurInd < 0) goto L_1;

  dbi = surTab[ActSurInd].indm;
  if(dbi < 1) goto L_1;
    printf(" m-act-dbi=%d\n",dbi);

  // if mesh already exists, just modify ..
  if(surTab[ActSurInd].exi_m > 0) {
    // find dli of A<dbi>
    dli = DL_find_obj (Typ_SUR, dbi, -1L);
    if(dli < 0) goto L_1;
    GA_sStyl__ (dli, 1, Typ_SUR, dbi);    // change attrib & redraw


  } else {   // modify Attribut of temporary Element dli
    gis_msh_disp (0, ActSurInd, dbi);   // load & display mesh
  }



  //----------------------------------------------------------------
  L_1:
  // load pTab from bin.file for surf. ActSurPtb > ActPtab
  ActSurInd = surInd;
  ActSurPtb = surTab[surInd].indp;
  ActSurMsh = surTab[surInd].indm;
  irc = gis_bload_pTab (TYP_FuncInit); // Load ActPtab from file A<ActSurPtb>
  if(irc < 0) return -1;


  // display points
  gis_DrawPoints (ActPtab.data, ActPtab.rNr, ActSurPtb, 0);
  surTab[surInd].visi = 1;


  //----------------------------------------------------------------
  // change display of new Mesh to symbolic
  dbi = surTab[surInd].indm;
  if(dbi < 1) goto L_2;
    printf(" m-new-dbi=%d\n",dbi);

    printf(" dbi=%d  dli=%d\n",dbi,dli);

  // if mesh already exists, just modify ..
  if(surTab[surInd].exi_m > 0) {
    // find dli of A<dbi>
    dli = DL_find_obj (Typ_SUR, dbi, -1L);
    if(dli < 0) goto L_2;
    GA_sStyl__ (dli, 2, Typ_SUR, dbi);    // change attrib & redraw


  } else {     // modify Attribut of temporary Element dli
    gis_msh_disp (1, surInd, dbi);
  }

  // load fTab & eTab
  gis_bload_fTab (TYP_FuncInit);

  // display EdgeLines
  gis_DrawAllEL (&ActEtab);




  //----------------------------------------------------------------
  L_2:
  // activate actual surface in list
  GUI_OptMenActivate (wls, surInd);


  // display new activepointTab in Label
  ActPtNr = -1;
  gis_disp_surNr ();



  return 0;

};


//================================================================
  int gis_ptab_load (char *fnam, char *dirNam) {
//================================================================
// user has pointfile selected;
// see also AP_ImportXML

  int       irc, i1, ptNr;
  long      surNr;
  char      cbuf[256], attrib[2];
  // Point     *pTab;


  if(fnam == NULL) return 0;

  strcpy(cbuf, dirNam);
  strcat(cbuf, fnam);


  printf("gis_ptab_load |%s|\n",cbuf);

  TX_Print("importing %s",cbuf);

/*
  gis_surPt_chg sollte man zerteilen in ein disActivate und in ein activate.
  bei gis_ptab_load (hier) use disActivate
  bei gCad_fini ?
*/

  gis_ptab_init ();
/*
  ActPtab.rNr = 0;

  // // assign memspace > pTab
  // pTab = (void*)memspc101;
  // ptNr = sizeof(memspc101) / sizeof(Point);
    // printf(" pNr=%d\n",ptNr);
*/

  // load points > pTab
  // irc = ptab_file_load1 (pTab, &ptNr, 0, cbuf);
  irc = ptab_file_load1 (&ActPtab, 0, cbuf);
  if(irc < 0) return -1;

/*
  // surNr = find next free surface-nr (A)
  ++surIndLast;
  surNr = surIndLast;
    printf(" next A-nr = %d\n",surNr);


  // save points to file M#A#.ptab
  MSH_bsav_pTab (&ActPtab, WC_modnr, surNr);


  // add surf to surTab
  gis_surTab_add (surNr, 0);
  // ActSurPtb = surNr;


  // add surf to List
  gis_lst_sup ();


  // activate new surface
  gis_surPt_chg (surTabNr-1);
*/


  // create point ActPtab.rNr from Display
  // hier fehlt noch PunktIndexOffset !
  gis_DrawPoints (ActPtab.data, ActPtab.rNr, ActSurPtb, 0);


  // update ActPtNr-display
  gis_disp_surNr ();

  ActPtabModFlag = 1;
  ActFtabModFlag = 1;

  TX_Print("%d points imported ..",ActPtab.rNr);

  return 0;

}


//=======================================================================
  int gis_DrawPoints (Point *pTab,  int ptNr, int surNr, int iOff) {
//=======================================================================
// Input:
//   iOff  the nr of the first point
// DispList:
//   typ   ApplicationObject (Typ_APPOBJ = 20)
//   indp   SurfNr (A#)
//   iatt  pointNr (index in pTab)

// Wie soll Bezug auf die Application eingebracht werden ?
// Gis hat viele ApplicationObjectTypes ..

// see APT_disp_SymB GL_DrawSymB
// see APT_disp_TxtA GR_DrawTxtA GL_DrawTxtA

  int    i1, icol1, icol2;
  long   l1;
  char   info[20];


  printf("gis_DrawPoints %d %d\n",ptNr,surNr);

  icol1 = 0;
  icol2 = 1;

  for(i1=0; i1<ptNr; ++i1) {
    sprintf(info, "%d", i1+iOff);   // itoa
    // save objtyp APPTYP_GISPT as att
    // save pointNr as ind
    // l1 = DL_StoreObj (Typ_APPOBJ, surNr, i1+iOff);
    l1 = DL_StoreObj (Typ_APPOBJ, i1+iOff, APPTYP_GISPT);
    gis_DrawPoint (&l1, SYM_TRI_S, &pTab[i1], icol1, icol2, info);
  }
  ActPtDli = l1;

  return 0;

}



//================================================================
  int gis_DrawPoint (long *ind, int symTyp, Point *pt1,
                     int icol1, int icol2, char *info) {
//================================================================

  GLuint dlInd;


  // printf("gis_DrawPoint %d %d\n",*ind,symTyp);


   // den DL-Index (+ Offset) holen)
   dlInd = GL_fix_DL_ind (ind);
     // printf(" dlInd=%d\n",dlInd);
  
   glNewList (dlInd, GL_COMPILE);
  
   glDisable (GL_LIGHTING);
  
   // nur fuer das Rescale mit Feedback erforderlich:
   glBegin (GL_POINTS);
   glVertex3dv ((double*)pt1);
   glEnd ();

   // display symbol symTyp
   glColor3fv    (GL_col_tab[icol1]);
   glRasterPos3d (pt1->x, pt1->y, pt1->z); // notwendig zum activate color!
   glCallList ((GLuint)symTyp);

   // display info
   glColor3fv    (GL_col_tab[icol2]);
   glRasterPos3d (pt1->x, pt1->y, pt1->z);
   glCallLists (strlen(info), GL_UNSIGNED_BYTE, (GLubyte*)info);


   glEnable (GL_LIGHTING);

   glEndList ();

   // GR_Disp_pt (&pTab[i1], SYM_TRI_S, 0);
   // GR_Disp_txi (&pTab[i1], i1, 0);

     // printf("ex gis_DrawPoint dli=%d\n",dlInd);
 
  return 0;

}

//================================================================
  int gis_HideAllPoints () {
//================================================================
// remove diplay of all Points

  int   i1;

  printf("gis_HideAllPoints \n");
// gis_dump_surTab ();

  for(i1=0; i1<surTabNr;  ++i1) {
      printf(" AllPoints-%d vis=%d mod=%d\n",i1,
              surTab[i1].visi,surTab[i1].modif);
    if(surTab[i1].visi == 1) {
      gis_HidePoints (surTab[i1].indp);
      surTab[i1].visi = 0;
    }
  }

// gis_dump_surTab ();
  printf("ex gis_HideAllPoints \n");

  return 0;

}

 
//================================================================
  int gis_HidePoints (int surNr) {
//================================================================
// delete display of GIS-points

  printf("gis_HidePoints sur=%d\n",surNr);

  // GL_Del_om (Typ_APPOBJ, surNr, -1);   // del multiple objects from DL
  GL_Del_om (Typ_APPOBJ, -1, APPTYP_GISPT);  // del multiple objects from DL
  GL_Regen1 ();                        // reset DL
  

  return 0;

}


//================================================================
  int gis_DrawAllEL (MemTab(EdgeLine) *eTab) {
//================================================================

  int    i1;

  printf("EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE \n");
  printf("gis_DrawAllEL %d\n",eTab->rNr);

  for(i1=0; i1<eTab->rNr; ++i1) {
    gis_DrawEL (&eTab->data[i1], i1);
  }

  return 0;

}


//================================================================
  int gis_DrawEL (EdgeLine *el1, int ind) {
//================================================================
// display EdgeLine
// see gis_DrawPoint gis_EL_disp

  int    iAtt, iClo;
  long   l1;
  GLuint dlInd;

  static unsigned char atta[] = {9, 9, 5, 8, 9};  // see GR_Disp_ln2
                             //  0  1  2  3  4
                             //        BL IB OB

  printf("EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE \n");
  printf("gis_DrawEL %d\n",ind);

  
  // iAtt = 9;
  iAtt = atta[el1->typ];


  if(el1->typ > 2) iClo = 1; // 0=open; 1=closed
  else             iClo = 0;


  l1 = DL_StoreObj (Typ_APPOBJ, ind, APPTYP_EDGLN);
    printf(" l1=%d\n",l1);

  gis_EL_disp (l1, el1->ia, el1->iNr, ActPtab.data, iAtt, iClo);

  return 0;

}


//================================================================
  int gis_HideAllEL (MemTab(EdgeLine) *eTab) {
//================================================================

  int   i1;


  printf("EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE \n");
  printf("gis_HideAllEL \n");

  gis_HideEL (-1);

  // for(i1=0; i1<eTab->rNr; ++i1) {
    // gis_HideEL (eTab->data[i1]);
  // }

  return 0;

}


//================================================================
  int gis_HideEL (int  i1) {
//================================================================

  printf("EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE \n");
  printf("gis_HideEL \n");

  // GL_Del_om (Typ_APPOBJ, surNr, -1);   // del multiple objects from DL
  GL_Del_om (Typ_APPOBJ, i1, APPTYP_EDGLN);  // del multiple objects from DL
  GL_Regen1 ();                        // reset DL

  return 0;

}


//=========================================================
  int gCad_fini () {
//=========================================================
// dll being unloaded - reset Input, kill all open windows

  int    i1, ii;
  long   dbi, dli;


  printf("gCad_fini GIS1\n");
// gis_dump_surTab ();


  // write to Main-Infowindow ..
  TX_Print("...... gCad_fini GIS1");


  if(tbGis1) {

    // get index of active surf into sufTab
    if(ActSurInd < 0) goto L_mu;


    // save mesh if modified.
    if(ActPtabModFlag != 0) {
      gis_bload_pTab (TYP_FuncEnd);  // save ActPtab to file A<ActSurPtb>
    }


    //----------------------------------------------------------------
    // restore meshDisplay of active surf


    // GA_sStyl__ ruft APT_Draw__; dazu muss ein DB-Objekt existieren !
    dbi = surTab[ActSurInd].indm;
    if(dbi < 1) goto L_mu;     // ok; mesh exists ...

    // find dli of A<dbi>
    dli = DL_find_obj (Typ_SUR, dbi, -1L);
    if(dli < 1) goto L_mu;

      printf(" dbi=%d  dli=%d\n",dbi,dli);

    // if Mesh did exist before:
    if(surTab[ActSurInd].exi_m == 1) {
      GA_sStyl__ (dli, 1, Typ_SUR, dbi);    // change attrib & redraw


    } else {   // - new Mesh; Mdl-Code is created.
      GL_Del0 (dli);                        // delete mesh-display
      GA_delRec (Typ_SUR, dbi);             // reset Attribute of new MeshSurf.
    }




    //----------------------------------------------------------------
    // restore pointsDisplay of active surf
    L_mu:

    // remove display of actEl
    GL_temp_delete ();

    // remove the Display of all points
    gis_HideAllPoints ();

    // remove the Display of all EdgeLines
    gis_HideAllEL (&ActEtab);

    // unload mesh; save if modified.
    gis_bload_fTab (TYP_FuncEnd);

    // unload points
    gis_bload_pTab (TYP_FuncEnd);


    // create update / Modelcodes
    gis_mdl_upd ();


    //-----------free memory:
    // free memSpace for active EdgeLine
    MemTab_free (&actEl);

    // free memSpace for Edgelines
    MemTab_free (&ActEtab);

    // free EdgeLine-dataSpace
    MemTab_free (&DatEtab);

    MemTab_free (&ActFtab);
    MemTab_free (&ActPtab);


    // remove the toolbar tbGis1
    GUI_del_widged (tbGis1);
    tbGis1 = NULL;

  }


  // reset  select (give back to mainApp)
  AP_UserSelection_reset ();
  APP_Close ();

  return 0;

}


//================================================================
  int gis_mdl_del_msh (int surInd) {
//================================================================
// delete mesh-codeline in model

  int      irc, lNr, ll, surNr;
  char     *lPos, cbuf[64];

 
  // no mesh to delete - did not exist before
  if(surTab[surInd].exi_m == 0) return 0;

  // no mesh created
  if(surTab[surInd].indm < 0) return 0;

  surNr = surTab[surInd].indm;

    AP_name_typInd (cbuf, Typ_SUR, surNr);
    // search defineition-line
    irc = APED_search_defLn (&lPos, &lNr, &ll, cbuf, -1);
    printf(" irc=%d lNr=%d |%s|\n",irc,lNr,cbuf);
    if(irc < 0) goto L_cr;

    // delete line in model
    APED_undo (lNr, lPos, 1);

  L_cr:

  return 0;

}


//================================================================
  int gis_mdl_del_pTab (int surInd) {
//================================================================
// delete pTab from model (del A<surInd> - Line)

  int       irc, lNr, ll, surNr;
  char      *lPos, cbuf[64];

  
  // no mesh to delete - did not exist before
  if(surTab[surInd].exi_p == 0) return 0;

  // points deleted ..
  if(surTab[surInd].indp < 0) return 0;

    surNr = surTab[surInd].indp;

    AP_name_typInd (cbuf, Typ_SUR, surNr);
    // search defineition-line
    irc = APED_search_defLn (&lPos, &lNr, &ll, cbuf, -1);
    printf(" irc=%d lNr=%d |%s|\n",irc,lNr,cbuf);
    if(irc < 0) goto L_cr;

    // delete line in model
    APED_undo (lNr, lPos, 1);
    // UTF_comment_line (lNr, lPos, 1, "_");

  L_cr:

  return 0;

}


//================================================================
  int gis_mdl_upd () {
//================================================================
// create update / Modelcodes

  int       i1;
  char      cbuf[80];


  printf("gis_mdl_upd %d\n",surTabNr);
    // gis_dump_surTab ();


  for(i1=0; i1<surTabNr;  ++i1) {

    // if(surTab[i1].modif == 0) continue;


    //----------------------------------------------------------------
    // add A1=PTAB "pointfilename" to model;
    // pointfilename is unused !
    // sprintf(cbuf, "A%d=PTAB \"%s\"",surNr,fnam);
    if(surTab[i1].exi_p == 0) {    // did not exist before
      if(surTab[i1].indp > -1) {
        sprintf(cbuf, "A%d=PTAB",surTab[i1].indp);
          printf(" add |%s|\n",cbuf);
        ED_add_Line (cbuf);
      }
    }


    // add A1=MSH A<pointSurfNr>   to model;
    if(surTab[i1].exi_m == 0) {    // did not exist before
      if(surTab[i1].indm > -1) {
        sprintf(cbuf, "A%d=MSH A%d",surTab[i1].indm,surTab[i1].indp);
          printf(" add |%s|\n",cbuf);
        ED_add_Line (cbuf);
      }
    }

  }


  return 0;

}

 
//====================================================================
  int ptab_cad_load1 (Point *pTab, int *ptNr, Edg3 *lTab, int *lnNr) {
//====================================================================
// get points from DB &
// get breaklines from DB


  int      i1, ip1, ip2, ptMaxNr, lnMaxNr;
  long     dbi, dbMax;
  double   tol;
  Point    *pt1;
  Line     *ln1;

  printf("ptab_cad_load1 %d %d\n",*ptNr,*lnNr);

  tol = UT_DISP_cv;
  ptMaxNr = *ptNr;
  lnMaxNr = *lnNr;

  // pTab ex DB-points laden.
  dbMax = DB_QueryLastUsed (Typ_PT, 0);
    printf(" PT-dbMax=%d\n",dbMax);

  // Punkte ex DB holen
  *ptNr = 0;
  for(dbi=1; dbi<=dbMax; ++dbi) {
    if(DB_QueryDef(Typ_PT, dbi) < 0) continue;
    pt1 = DB_get_PT (dbi);
    ip1 = ptab_ptAdd (pt1, pTab, ptNr, ptMaxNr, tol);
    if(ip1 < 0) break;
  }



  // Linien (breaklines) ex Db holen ...
  // neue Punkt an pTab anhaengen ..
  // ptMaxNr = *ptNr;
  dbMax = DB_QueryLastUsed (Typ_LN, 0);
    printf(" LN-dbMax=%d\n",dbMax);



  // Lines ex DB holen
  i1 = 0;
  for(dbi=1; dbi<=dbMax; ++dbi) {
    if(DB_QueryDef(Typ_LN, dbi) < 0) continue;
    ln1 = DB_get_LN (dbi);
    // in pTab suchen, ob points already defined; ip1, ip2 setzen.
    // not yet defined: add to pTab.
    ip1 = ptab_ptAdd (&ln1->p1, pTab, ptNr, ptMaxNr, tol);
    ip2 = ptab_ptAdd (&ln1->p2, pTab, ptNr, ptMaxNr, tol);
    if(ip2 < 0) break;
    // add breakline
    if(i1 >= lnMaxNr) {TX_Print("ptab_cad_load1 E002"); break;}
    lTab[i1].i1 = ip1;
    lTab[i1].i2 = ip2;
    ++i1;
  }
  *lnNr = i1;



  // Test only ...........
    for(i1=0;i1<*ptNr;++i1) printf("p[%d]=%f %f %f\n",i1,
      pTab[i1].x,pTab[i1].y,pTab[i1].z);
    for(i1=0;i1<*lnNr;++i1) printf("l[%d]=%d %d\n",i1,
      lTab[i1].i1,lTab[i1].i2);


  return 0;

}


//==============================================================================
  int ptab_ptAdd (Point *pt1, Point *pTab, int *ptNr, int ptMaxNr, double tol) {
//==============================================================================
// check if pt1 is already in pTab; return its index,
// if not: add pt1 to pTab, return its index.
// RetCod = pointIndex or -1 (pTab.-Overfolw).
// used by ptab_cad_load1

  int   i1;

  UT3D_stru_dump(Typ_PT, pt1, "ptab_ptAdd:");
  printf(" ptNr=%d\n",*ptNr);

  // check if pt1 is already in pTab
  for(i1=0; i1<*ptNr; ++i1) {
    if(UT3D_comp2pt(pt1, &pTab[i1], tol) == 0) continue;
    return i1;   // gefunden ..
  }

  // add pt1 to pTab.
  i1 = *ptNr;
  if(i1 >= ptMaxNr) {TX_Print("ptab_ptAdd E001"); return -1;}
  pTab[i1] = *pt1;
  ++(*ptNr);


    GR_Disp_pt (&pTab[i1], SYM_TRI_S, 0);
    GR_Disp_txi (&pTab[i1], i1, 0);

  
  printf("ex ptab_ptAdd ptNr=%d\n",*ptNr);
  
  return i1;

}





//====================================================================
  int ptab_file_load1 (MemTab(Point) *pTab, int mode, char *fNam) {
//====================================================================
// Punkte aus einer Ascii-Datei nach pTab einlesen.
// mode beschreibt das Dateiformat.
// Input:
//   ptNr   max nr of points on input !
//   mode   = Filetyp; 0 = N X Y Z C; 1 = X Y Z N C   UNUSED
//   fNam   incl. Filetyp

// Es wird getestet, ob erstes Wort numerisch.

// DefaultFileFormat:
// N=PointName, Text, zB "P001"; X,Y,Z=Coords; C=PointCode, Text, zB "Haus"
 
  int   irc, i1, i2, ix, iy, iz, lNr; //, ptMaxNr;
  long  ld;
  FILE  *fpi;
  char  cBuf[256], *cTab[6], *cp, *p1, cWd[80];
  Point pt1;


  printf("ptab_file_load1 |%s|\n",fNam);

  // ptMaxNr = *ptNr;


  if ((fpi = fopen (fNam, "r")) == NULL) {
    TX_Print("FILE NOT FOUND |%s| in ptab_file_load1",fNam);
    return -1;
  }


  // fix the correlation-pointers
  // read first line & test first word.
  fgets (cBuf, 250, fpi);
/*
  cp = UTX_pos_skipDeli1 (cBuf); // skip leading blanks, tabs ..
  if(UTX_ck_num1(&p1, cp) == 0) {    // yes numer.
    ix = 0;
    iy = 1;
    iz = 2;
  } else {
    ix = 1;
    iy = 2;
    iz = 3;
  }
*/
  p1 = cBuf;
  i1 = -1;


  // search 1. word containing "."
  // - this is position of X-coord; Y-Coord and Z-Coord follows.

  // get next word
  L_nxt_wd:
  ++i1;
  cp = UTX_cp_word__ (cWd, p1);
    // printf(" wd[%d]=|%s|%s|\n",i1,cWd,cp);
  if(strchr(cWd, '.') == NULL) {
    p1 = UTX_pos_skipDeli1 (cp);
    if(i1 < 3) goto L_nxt_wd;
    TX_Print("FileFormat-Error %s",fNam);
    return -1;
  }


  // from extern:
  ix = i1;
  iy = ix + 1;
  iz = iy + 1;
    printf(" positions %d %d %d\n",ix,iy,iz);


  rewind(fpi);


  lNr = 0;
  while (!feof (fpi)) {
    if(fgets (cBuf, 250, fpi) == NULL) break;
    UTX_CleanCR (cBuf);    // cut off CR,LF 
      // printf("%s\n",cBuf);
    cp = cBuf;
    while (*cp == ' ') ++cp; // skip leading blanks
    if(strlen(cp) < 6) continue;
    // separate words ..
    cTab[0] = &cBuf[0];
    i2 = 0;

    // find starting-positions of first 6 words
    for(i1=0; i1<5; ++i1) {
      ++i2;
      // skip leading blanks
      cp = cTab[i1];
      // skip leading blanks
      while (*cp == ' ') ++cp;
      cTab[i2] = UTX_find_Del1 (cp);
      if(cTab[i2]) {*cTab[i2] = '\0'; ++cTab[i2];}   // separate with '\0'
    }
      // printf("|%s|%s|%s|%s|%s|\n",cTab[0],cTab[1],cTab[2],cTab[3],cTab[4]);

    // distribute; load Coords according to ix,iy,iz;
    pt1.x = strtod (cTab[ix], &cp);
    pt1.y = strtod (cTab[iy], &cp);
    pt1.z = strtod (cTab[iz], &cp);

    // test if point already exists; (2D-Test; tolerance = TOL_GIS_PT)
    if(MSH_ck_pt3(ActPtab.data, ActPtab.rNr, &pt1) < 0) {     // 0=newPoint ..

      // save point ..
      irc = MemTab_sav (pTab, &ld, &pt1, 1);
      if(irc) goto L_EOM;
        // UT3D_stru_dump (Typ_PT, &pTab[lNr], "%s:",cTab[0]);
        // GR_Disp_pt (&pTab[lNr], SYM_TRI_S, 0);
        // GR_Disp_txi (&pTab[lNr], lNr, 0);

    }

    // proceed to next line ...
    ++lNr;
    // if(lNr > ptMaxNr) {
      // TX_Error("ptab_file_load1 EOM %d",ptMaxNr);
      // return -1;
    // }
  }

  fclose(fpi);

  // *ptNr = lNr;
    printf("ex ptab_file_load1 points=%d\n",lNr);
  return 0;


  L_EOM:
    printf("ptab_file_load1 EOM\n");
    return -1;
}


//================================================================
  int gis_Edges_del (int elInd) {
//================================================================
// delete EdgeLine elInd

  int iSta, iNr;


  printf("gis_Edges_del %d\n",elInd);

  iSta = gis_DatEtab_sum (elInd);
  iNr  = ActEtab.data[elInd].iNr;
    printf(" iSta=%d iNr=%d\n",iSta,iNr);

  // remove display
  // gis_HideEL (elInd);
  gis_HideAllEL (&ActEtab); // remove the Display of all EdgeLines

  // delete ActEtab-record Nr elInd
  MEM_del_nrec (&ActEtab.rNr, ActEtab.data, elInd, 1, ActEtab.rSiz);

  // delete data out of DatEtab
  MEM_del_nrec  (&DatEtab.rNr, DatEtab.data, iSta, iNr, DatEtab.rSiz);

  // die pointers ActEtab[].ia neu aufbauen
  gis_DatEtab_fix ();

  // draw all (remaining) Edgelines
  gis_DrawAllEL (&ActEtab);

  ActFtabModFlag = 1;

  return 0;

}
 

//================================================================
  int gis_Edges_add (int *iTab, int iNr, int typ) {
//================================================================
// add polygon iTab[iNr] to ActEtab/DatEtab

  int      ind;
  long     l1;
  EdgeLine el1;


  printf("gis_Edges_add iNr=%d typ=%d\n",iNr,typ);

  // add one more EdgeLine in ActEtab
  ind = ActEtab.rNr;
  el1.iNr = iNr;
  el1.typ = typ;
  MemTab_sav (&ActEtab, &l1, &el1, 1);
  if(ActEtab.data == NULL) goto L_EOM;

  // add/copy data; actEl.iNr ints in actEl.ia.
  MemTab_sav (&DatEtab, &l1, iTab, iNr);
  if(DatEtab.data == NULL) goto L_EOM;

  // die pointers ActEtab[].ia neu aufbauen
  gis_DatEtab_fix ();

  // display EdgeLine
  gis_DrawEL (&ActEtab.data[ind], ind);

  // modified
  ActFtabModFlag = 1;

    // MSH_dump_eTab ();

  return 0;

  L_EOM:
  TX_Print("gis_Edges_add EOM"); return -1;

}


//================================================================
  int gis_Edges_upd (int mode) {
//================================================================
// init/add/update/delete ActEdges

  int      irc, i1, i2;
  long     l1;
  double   d1;
  EdgeLine *el1;


  //----------------------------------------------------------------
  // Init: create empty Record.
  if(mode == TYP_FuncInit) {
    printf(" gis_Edges_upd TYP_FuncInit\n");

    // get memSpace for EdgeLine-records
    ActEtab.rNr = 0;     // reset

    // get memSpace for EdgeLine-dataSpace
    DatEtab.rNr = 0;     // reset


    // ActEdges.eTab = NULL;
    // ActEdges.eNr  = 0;
    // ActEdges.eTyp = NULL;
    return 0;
  }



  //----------------------------------------------------------------
  // Add: add EdgeLine actEl to ActEdges
  if(mode != TYP_FuncAdd) goto L_Del;

  // test if actEl is OK ..
  gis_dump_actEl ();
  if(actEl.rNr < 2) {
    TX_Print("***** active Poygon is not defined *****");
    return -1;
  }

  // remove closing-point from boundaries
  if((actEl.use == TYP_EDGLN_IB)||(actEl.use == TYP_EDGLN_OB)) {
    i1 = actEl.data[0];
    i2 = actEl.data[actEl.rNr - 1];
    if(i1 == i2) actEl.rNr -= 1;
  }

  // check if actEl is CCW; else invert.
  irc = UT2D_srar_inpt3 (&d1, actEl.rNr, actEl.data, ActPtab.data);
  if(irc < 0) MEM_inv_itab (actEl.rNr, actEl.data);

  // add actEl to ActEtab
  irc = gis_Edges_add (actEl.data, actEl.rNr, actEl.use);

  // clear actEl, remove display
  gis_actEl_del ();

  return irc;


  //----------------------------------------------------------------
  // Delete:  remove EdgeLine ? from ActEdges
  L_Del:
  if(mode != TYP_FuncDel) {TX_Print("gis_Edges_upd E001"); return -1;}
  TX_Print("gis_Edges_upd E002");
  return -1;

}
 

//================================================================
  int gis_DatEtab_sum (int recNr) {
//================================================================
// recNr 0-ActEtab.rNr  returns startPos of datavalues
//                        of ActEtab-Record recNr in DatEtab
// recNr   -1           returns size of DatEtab

  int    i1, ii;

  // get ii = actual used size of DatEtab
  if((recNr < 0)||(recNr > ActEtab.rNr)) recNr = ActEtab.rNr;

  ii = 0;

  for(i1=0; i1<recNr; ++i1) ii += ActEtab.data[i1].iNr;
    printf("ex gis_DatEtab_sum %d\n",ii);

  return ii;

}

  // if(l1 != 0) for(..) ActEtab[i1].ia = DatEtab[i2];

//================================================================
  int gis_DatEtab_fix () {
//================================================================
// (nach relocation) die pointers neu aufbauen
// ersetzen durch MSH_eTab_fix

  int    i1, ii;

  // get ii = actual used size of DatEtab
  ii = 0;
  for(i1=0; i1<ActEtab.rNr; ++i1) {
    ActEtab.data[i1].ia = &DatEtab.data[ii];
      printf(" _fix ActEtab[%d] = %d\n",i1,ii);
    ii += ActEtab.data[i1].iNr;
  }

  return 0;

}



//================================================================
  int gis_surTab_add (long indp, int visi) {
//================================================================
// add new created pointSurf to surTab

  if(surTabNr >= MAX_SURPTAB) return -1;

  surTab[surTabNr].indp  = indp;
  surTab[surTabNr].indm  = -1,       // does not yet exist
  surTab[surTabNr].visi  = visi;
  surTab[surTabNr].exi_p = 0;        // new created
  surTab[surTabNr].exi_m = 0;        // new created
  surTab[surTabNr].modif = 1;        // modified = yes

  ++surTabNr;

  return 0;

}
 

//================================================================
  int gis_dump_pTab () {
//================================================================
 
  int  i1;

  printf("========== gis_dump_pTab %d ===========\n",surTabNr);

  for(i1=0; i1<ActPtab.rNr;  ++i1) {
    UT3D_stru_dump (Typ_PT, &ActPtab.data[i1], "P[%d]",i1);
  }

  return 0;

}


//================================================================
  int gis_dump_actEl () {
//================================================================

  int  i1;

  UT3D_stru_dump (Typ_MemTab, &actEl, "actEl:");
  for(i1=0; i1<actEl.rNr; ++i1) {
    printf("  actEl[%d]=%d\n",i1,actEl.data[i1]);
  }

  return 0;

}

 
//================================================================
  int gis_dump_surTab () {
//================================================================

  int  i1;

  printf("========== gis_dump_surTab %d ===========\n",surTabNr);
  printf(" active PTAB=%d MSH=%d PtabMod=%d FtabMod=%d\n",
         ActSurPtb, ActSurMsh,
         ActPtabModFlag,ActFtabModFlag);


  for(i1=0; i1<surTabNr;  ++i1) {
    printf(" surTab[%d].indp=%d indm=%d vis=%d exp=%d exm=%d mod=%d\n",i1,
             surTab[i1].indp,
             surTab[i1].indm,
             surTab[i1].visi,
             surTab[i1].exi_p,
             surTab[i1].exi_m,
             surTab[i1].modif);

  }


  gis_dump_actEl ();

  UT3D_stru_dump (Typ_MemTab, &ActPtab, "ActPtab:");
  UT3D_stru_dump (Typ_MemTab, &ActFtab, "ActFtab:");

  MSH_dump_eTab (&ActEtab, &DatEtab);


  return 0;

}


//================================================================
  int gisEdg_addPtab (int *iTab, int pNr) {
//================================================================
// add polygon iTab to active EdgeLine actEl
// see gisEdg_addGisPt

  int   i1, i1s, i1e, i2s, i2e;
  long  l1;


  printf("gisEdg_addPtab %d\n",pNr);
  gis_dump_actEl ();       // dump actEl
  for(i1=0;i1<pNr;++i1)printf(" iTab[%d] = %d\n",i1,iTab[i1]);
  

  if(actEl.rNr < 1) goto L_add;

  i1s = actEl.data[0];
  i1e = actEl.data[actEl.rNr - 1];

  i2s = iTab[0];
  i2e = iTab[pNr - 1];
    printf(" i1s=%d i1e=%d i2s=%d i2e\n",i1s,i1e,i2s,i2e);


  // test if last point of actEl == 1. point of iTab;
  // if yes: remove last point of actEl.
  if(i1e == i2s) {
    actEl.rNr -= 1;
    goto L_add;
  }


  // test if last point of actEl == last point of iTab;
  // if yes: remove last point of iTab; invert itab;
  if(i1e == i2e) {
    pNr -= 1;
    MEM_inv_itab (pNr, iTab);
    goto L_add;
  }


  // test if 1 point of actEl == 1. point of iTab;
  // if yes: invert actEl; remove last point of actEl.
  if(i1s == i2s) {
    MEM_inv_itab (actEl.rNr, actEl.data);
    actEl.rNr -= 1;
    goto L_add;
  }


  // test if 1 point of actEl == last point of iTab;
  // if yes: invert actEl; remove last point of actEl; invert itab.
  if(i1s == i2e) {
    MEM_inv_itab (actEl.rNr, actEl.data);
    pNr -= 1;
    MEM_inv_itab (pNr, iTab);
    goto L_add;
  }


  // add iTab to actEl
  L_add:
  // check free space (realloc if necessary) & add index
  // UME_alloc_add (&actEl.ia, &l1, &actElSiz, &actEl.iNr,
                 // sizeof(int), &ActPtNr, 1, INC_actEl);
  for(i1=0; i1<pNr; ++i1) {
    MemTab_sav (&actEl, &l1, &iTab[i1], 1);
    if(actEl.data == NULL) goto L_EOM;
  }

  // temporary preview of EdgeLine
  gis_actEl_disp ();

    printf("ex gisEdg_addGisPt\n");
  return 0;



  L_EOM:
    TX_Print("gisEdg_addGisPt EOM");
    return -1;
}

   
//================================================================
  int gisEdg_addGisPt () {
//================================================================
// add index to point ActPtNr to active EdgeLine;

  long l1;

  printf("gisEdg_addGisPt %d %d\n",ActPtNr,actEl.rNr);


  // check free space (realloc if necessary) & add index
  // UME_alloc_add (&actEl.ia, &l1, &actElSiz, &actEl.iNr,
                 // sizeof(int), &ActPtNr, 1, INC_actEl);
  MemTab_sav (&actEl, &l1, &ActPtNr, 1);
  if(actEl.data == NULL) goto L_EOM;
  

  // temporary preview of EdgeLine
  gis_actEl_disp ();

  return 0;

  L_EOM:
    TX_Print("gisEdg_addGisPt EOM");
    return -1;


}


//================================================================
  int gis_actEl_disp () {
//================================================================


  // temporary preview of EdgeLine
  GL_temp_delete ();   // remove all temp elems (previous EdgeLine)
  // GR_Disp_cv
  gis_EL_disp (-1L, actEl.data, actEl.rNr, ActPtab.data, col_actEl, 0);


  gis_dump_actEl ();       // dump actEl
  return 0;

}
 

//================================================================
  int gis_actEl_del () {
//================================================================
// clear actEl, remove display


      GL_temp_delete ();
      DL_Redraw ();

      actEl.rNr = 0;
      actEl.use = 2; // EdgeLine

  return 0;

}
 

//========================================================================
  int gis_EL_disp (long dli,
                   int *ib, int iNr, Point *pa, int att, int mode) {
//========================================================================
// display polygon - us3d for display of Edgline actEl
/// Input:
///   dli       -1 for temporary element; or from DL_StoreObj
///   ib, iNr   boundary; indices into pa
///   pa        pointTable
///   mode 0    open polygon
///        1    closed polygon - closing point is added !

  int    i1, iSiz;
  Point  *cv;


  printf("gis_EL_disp dli=%d iNr=%d mode=%d\n",dli,iNr,mode);
  if(iNr < 2) return 0;

  iSiz = iNr + mode;
  i1 = sizeof(Point) * iSiz;
    printf(" tmpSpcSiz=%d\n",i1);

  cv = (Point*)UME_alloc_tmp(i1);
  // cv = (Point*)alloca(sizeof(Point)*(iNr + 1));
  if(cv == NULL) {TX_Print("gis_EL_disp EOM"); return -1;}


  for(i1=0; i1<iNr; ++i1) {
      printf(" P[%d] ib=%d\n",i1,ib[i1]);
    cv[i1] = pa[ib[i1]];
  }

  if(mode > 0) cv[iNr] = cv[0];

  GL_DrawPoly (&dli, att, iSiz, cv);
  DL_Redraw ();

  // dli=DL_Ind_tmp-1
    printf(" dli=%d\n",GL_GetInd_temp() - 1);

  return 0;

}

/*
///=================================================================
  int UT2D_srar_inpt3 (double *aro, int ptNr, int *ipa, Point *pa)  {
///=================================================================
/// UT2D_srar_inpt3                        nach Karl Sauer 2004-04-07
/// Umlaufsinn (sr=sense of rotation) und Flaeche (ar=area) eines
/// geschlossenen 2D-Polygons (polc) berechnen.
///
/// Input:
///   ptNr   Anzahl PunktIndices ohne den letzten == ersten Punkt !
///   ipa    Indexarray into pa; 
///   pa     PunkteTabelle
/// Output:
///   RetCod = 1 = CCW
///           -1 = CW

  double   FLAE;
  int      i1, i2, i3, ie, sr;


  FLAE = 0.;
  ie   = ptNr-1;

  for(i2=0; i2<ptNr; ++i2) {

    if(i2 > 0) i1 = i2-1;
    else       i1 = ie;

    if(i2 < ie) i3 = i2+1;
    else        i3 = 0;

    // nun ist p1,p2,p3 ein Dreieck aus dem polygon pa von 3
    // aufeinanderfolgenden Punkten; p2 ist der mittlere.
    // FLAE += pa[i2].x * (pa[i3].y - pa[i1].y);
    FLAE += pa[ipa[i2]].x * (pa[ipa[i3]].y - pa[ipa[i1]].y);
    // printf(" %d %d %d - %f\n",i1,i2,i3,FLAE);
  }


  if(FLAE < 0.) {
    sr = -1;
    *aro = FLAE / -2.;
  } else {
    sr = 1;
    *aro = FLAE / 2.0;
  }


  printf("ex UT2D_srar_inpt3 %d %f\n",sr,*aro);

  return sr;

}
*/

//================  EOF  ==================================
