/*  Test MultiColumnList                             2009-04-10     RF


make -f tst_mList.mak&&./tst_mList.exe
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#include <gtk/gtk.h>

#include "../gtk/ut_gtk.h"
#include "../ut/ut_const.h"        // necessary without ut_geo


#include "../gr/ut_UI.h"


static GtkWidget    *w_win;
static GUIobj_mList    w_lst1;

// static GtkTreeModel *w_tree1;
// static GtkWidget    *w_list1;

int    actLnr;    // number of selected line



// prototypes
  int CB_lstSel (GtkTreeSelection *selection, gpointer data);
  int CB_lstBut (GtkWidget *widget, GdkEventButton *event);
  int CB_lstKey (GtkWidget *parent, GdkEventKey *event);



//================================================================
  int main (int argc, char *argv[]) {
//================================================================
 
  GtkWidget *box0, *box1;


  GUI_Init ("");

  w_win = GUI_Window ("tst_mList", gtk_exit, NULL, 0);

  // primary box
  box0 = GUI_Vbox (w_win, 0);


  // make GUI_Hbox; do not expand its box.
  box1 = GUI_Hbox (box0, -1);
  GUI_Butt (box1, " C L O S E ", gtk_exit, NULL, 5);


  // create list
  GUI_mList__ (box0, &w_lst1,
    "title",                // columnheader
    1,                      // 1=selectable
    CB_lstSel,              // callback-function selection
    CB_lstKey,              // callback-function keyIn
    CB_lstBut);             // callback-function mousebutton


  // add lines to List
  GUI_mList_add (&w_lst1, "first line");
  GUI_mList_add (&w_lst1, "second line");
  GUI_mList_add (&w_lst1, "third line");


  gtk_widget_set_uposition (w_win, 0, 0);     // Pos of mainwin
  gtk_widget_set_usize (w_win, 400, 400);     // size of mainwin


  gtk_widget_show_all (w_win);

  gtk_main ();

  return 0;
}


//================================================================
  int CB_lstSel (GtkTreeSelection *selection, gpointer data) {
//================================================================
// callback-function selection in list

  char         s1[512];
  GtkTreeModel *model;
  GtkTreeIter  iter1;


  printf("CB_lstSel \n");

  if (gtk_tree_selection_get_selected (selection, &model, &iter1)) {

    // get lineNumber from iter
    actLnr = GUI_mList_iter2rowNr (&w_lst1,  &iter1);
    printf("  sel lNr=%d\n",actLnr);

    // get text from iter
    GUI_mList_read_iter (s1, &w_lst1, &iter1);
      printf(" sel: |%s|\n",s1);

  }

  return 0;

}


//================================================================
  int CB_lstBut (GtkWidget *widget, GdkEventButton *event) {
//================================================================
// callback-function Mousbutton pressed ..

  int   i1;

  printf("CB_lstBut %d\n",event->button);


  // query nr of lines in playlist
  i1 = GUI_mList_lNr (&w_lst1);
  printf(" lNr=%d\n",i1);


  return FALSE;  // do defaultOperations: allow selection
  // return TRUE;  // do no defaultOperations (NO selection !)

}


//================================================================
  int CB_lstKey (GtkWidget *parent, GdkEventKey *event) {
//================================================================
// callback-function keyboard-keys (a line must be selected)


  int     iCtrl;


  printf("CB_lstKey key=%x typ=%d\n",event->keyval,event->type);

  // check Ctrl-function
  iCtrl = ((GdkEventKey*)event)->state & GDK_CONTROL_MASK;
    printf(" Ctrl+key = %d\n",iCtrl);


  if(event->keyval == 'm') {
    // modify active line
    GUI_mList_modify_rowNr (&w_lst1, "new linetext", actLnr);
  }

  if(event->keyval == 'l') {
    // get lineNr of slected line
    printf(" selNr=%d\n",GUI_mList_get_sel_nr (&w_lst1));
  }



  // return FALSE;  // do defaultOperations: allow modification
  return TRUE;  // do no defaultOperations (NO modifications !)

}


// EOF
