/*   ut_gtk.c

Utilities for GTK-2. (nicht in GTK1: gtk_disable_setlocale ..)


Offen:
  Die Funktionen sollten ein GUI_obj zurueckgeben; eine struct in der der typ
    und alle notwendigen Objekte enthalten sind. Am wichtigsten f. GUI_Ed_Init.



-----------------------------------------------------
Modifications:
2009-04-12 fList3.c extracted. RF.
2008-01-24 GUI_Slider, GUI_GetxText, GUI_del_widged. RF.
2007-04-29 GUI_Notebook_ new. RF.
2007-04-12 GUI_HList_.. new RF.
2005-10-17 GUI_GetText_CB Cancel korr. RF.
2005-01-07 Port -> GTK2. RF.
2003-11-14 GUI_WinUp komplett geaendert. RF.
2001-11-07 GUI_CB_WinDel neu. RF.
2001-11-06 GUI_SetActW neu. RF.
2001-10-25 Tooltips f. OptMens. RF.
2001-10-23 GUI_DialogY u. GUI_DialogYN neu. RF.
2001-10-22 GUI_OptMenChg u. GUI_GetText neu zu. RF.
2001-10-19 GUI_List korr. RF.
2001-07-20 GUI_OptMen u GUI_Combo neu. RF.
2001-06-17 GUI_File_selGet neu. RF.
2001-06-16 GUI_Toolbox zu. RF.
2001-06-14 GUI_Tip neu. RF.
2001-06-13 GUI_Menu: parameter mode zu. RF.
2001-06-08 GUI_Xbox: parameter expand zu. GUI_Butt_Att zu. RF.


-----------------------------------------------------
*/
#ifdef globTag
void GUI(){}
#endif
/*!
\file ../gtk/ut_gtk.c
\ingroup grp_gtk
\code

=====================================================
Liste_Funktionen_Beginn:

GUI_Init
GUI_Window
GUI_Hbox
GUI_Vbox
GUI_VSpace                make a vertical (free) space
GUI_Hsep                  horiz. Trennlinie Ruler
GUI_Frame                 Rahmen um ein Feld

GUI_Label                 BackgroundText (Label)
GUI_Label_mod             modify label

GUI_Butt
GUI_Butt_Att
GUI_Tip                   Tooltip (Zusatzinfo zu Widget)
GUI_CkButt                Checkbox
GUI_CkButt_get            returns state of checkbox; 0=not sel, 1=selected.
GUI_CkButt_set            activate/disactivate Checkbox, Radiobutton.
GUI_ButtPix

GUI_Entry                 Eingabefeld (+ Infotext)
GUI_EntryL                InputField; Labeltext right of InputField
GUI_Entry_set             set text in entryField
GUI_Entry_get             get text from entryField - gives back a Pointer
GUI_Entry_Get             get text from entryField - copy

GUI_Menu
GUI_MenuSub
GUI_MenuCkBox
GUI_set_CkBox          sets state of GUI_MenuCkBox
GUI_get_CkBox          returns state of GUI_MenuCkBox
GUI_MenuEntry
GUI_MenuBar
GUI_MenuRadButt

GUI_RadButt
GUI_RadButtAdd
GUI_RadButtSet

GUI_OptMen
GUI_OptMenActivate
GUI_OptMenChg
GUI_Combo
GUI_Popup              disp. popup-Liste; callbacks f. mouseOver & select
GUI_Pix

GUI_Slider__           Slider = AdjustmentControl
GUI_Slider_get         query slider-value
GUI_Slider_set         change slider-value

GUI_List
GUI_List_add
GUI_List_clear
GUI_List_remove
GUI_List_select

GUI_Notebook__
GUI_Notebook_add       add a page to a notebook

GUI_ColSel             ColorselectionDilaog
GUI_GetText            Text vom User holen
GUI_GetText_CB         callback of GUI_GetText
GUI_GetxText           Query text from user extended
GUI_GetxText_get       get userInput from GUI_GetxText

GUI_MsgBox             display text, OK-Button, if GTK is not yet up
GUI_Dialog             Ausgabetext mit einem OK-Button zum Beenden
GUI_DialogY            Textausgabefenster mit OK-Button zum Beenden und Callback.
GUI_DialogYN           Ausgabetext, OK-Button, Cancel-Button, Callback.

GUI_File_selGet
GUI_File_select
GUI_File_selext

GUI_SetActW
GUI_GetActW
GUI_GetWidgetPos
GUI_GetWinPos
GUI_SetWinpos
GUI_Toolbox
GUI_CB_WinDel
GUI_WinUp              window always on top ..
GUI_WinDwn             remove alwaysOnTop-attribute
GUI_update__           update pending events ..
GUI_del_events         kill all pending events
GUI_Idle               register a idle-function
GUI_del_widged         delete widget

GUI_set_active         makes widgets / groups of widgets unselectable

Liste_Funktionen_Ende:
=====================================================

\endcode *//*----------------------------------------


------------------------------------
Fehler von gtk am PC:
gdk_window_set_cursor
gtk_signal_connect (GTK_OBJECT(wText), "key_release_event",   geht ned



------------------------------------
Offen:
======
GUI_Tip: es sollte fuer jedes neue Window (zB PP-Win) eine eigenes NewTip geben
Oder mit dem GUI_Window mitgeben ?
Oder nach dem GUI_Window als GUI_TipInit liefern?


GUI_Entry - text nach rechts ausrichten (Zahlen) ???
  gtk_entry_get_text macht Mist; g_free -> Absturz. Durch gtk_text ersetzen ?


GUI_Label akzeptiert noch keine Tooltips ! Frame ebenfalls nicht.
  Eventuell Textfeld machen ?
  Gibts ein explizites Textausgabefeld ?

GUI_Label: wie kann man einen Frame rundherum machen (damit man
  die Feldlnge erkennen kann ?
  Feldlaenge ebenso wie bei _Entry machen !


GUI_Label: border noch nicht aktiv. Testen in grossem Panel.


Noch kein GtkOptionMenu: S.470.




------------------------------------
Beispiele:
vi /usr/include/gtk/gtkwidget.h
vi /p2/devel/gtk/exa/ex1/testgtk.c
vi /p2/devel/gtk/mygtk/gtk1.c
vi /usr/src/RPM/SOURCES/gftp-2.0.6a/gftp.c
vi /p2/devel/gtk/gtk_tutorial.20000721/txt/gtk_tut.txt

 if (!GTK_WIDGET_VISIBLE (window))
    gtk_widget_show (window);

??
      GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
      gtk_widget_grab_default (button);



------------------------------------
  gtk_alignment_new laesst Widgets gleich gross, der Platz aussen
  rum aber wird trotzdem groesser.

      // MenuBar soll in Y-Richtung nicht groesser werden S.533
      // align1 = gtk_alignment_new(0., 0., 1., 0.);
      // gtk_container_add (GTK_CONTAINER (box0), align1);
      // gtk_widget_show (align1);

------------------------------------
Probleme gtk:


------------------------------------
Allgemeiner Aufbau:

  GtkWidget *window, *box0, *menu_bar, *menu;

  GUI_Init ("gtk1.rc");
  window = GUI_Window ("TW1", exitFunc, exitData, 0);
  box0 = GUI_Vbox (window, 0);

  ..

  gtk_widget_show (window);
  gtk_main ();



------------------------------------
 Andere wichtige:

  gtk_widget_set_usize (window, 150, 300);

  gtk_widget_set_uposition (window, 150, pos);


	// Einen Button deaktivieren (dimmen);
  gtk_widget_set_sensitive (blst, FALSE);
	// TRUE setzt wieder auf aktiv.

  gtk_entry_set_text ((GtkEntry*) (entry),
           gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));


  // ein widget ausblenden (gtk_widget_unrealize, gtk_widget_unmap ??)
  gtk_widget_hide (tb1);
  // wieder einblenden
  gtk_widget_show (tb1);


	// Ein Widget ganz lschen.
  gtk_widget_destroy (wnam);

	// Eine Taste druecken
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (button), TRUE);


  wid=gtk_widget_get_ancestor(wid *child, gtk_window_get_type());





-----------------------------------------------------
Cursortypen:
------------
  gdk_window_set_cursor (window->window, gdk_cursor_new (GDK_HAND1));




-----------------------------------------------------
Inhalt einer struct GtkWidget:
-----------------------------------------------------
  widget->allocation.width,widget->allocation.heigh
    Liefert die volle Size des Window.
  widget->allocation.x,widget->allocation.y sollte die Posi. sein.




------------------------------------------------------------
Der Status der Modifier-Keys, der Mausbuttons und die Curpos:
-------------------------------------------------------------
Beim Signal Buttonpress od Release:

gint UI_ButtonRelease (GtkWidget *widget, GdkEventMotion *event) {

  int x, y;
  GdkModifierType state;

  if (event->is_hint) {
    gdk_window_get_pointer (event->window, &x, &y, &state);
  }

  if(state & GDK_BUTTON1_MASK) {
    //MB1 ist ON
  }
}

state erhaelt den akt. Status; nicht welcher Key veraendert wurde !

vi /usr/include/gdk/gdktypes.h   // siehe GdkModifierType







======================================================================
Compile Linux:
cc -c `gtk-config --cflags` ut_gtk.c

Compile MS-Win:
cl -c /I ..\include ut_gtk.c



======================================================================
*/

#include "../xa/MS_Def0.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// #include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>         // f. GDK_Return

#include "../ut/ut_txt.h"           // fnam_del

#include "../gtk/ut_gtk.h"          // GUI_..


#include "../gr/ut_UI.h"







GtkWidget *WinAct, *ButtKett, *ButtKettArr[25];
int       ButtKettAnz;
int       UI_fontsizX, UI_fontsizY;


static int butt_expand = TRUE;

static GtkWidget *UI_List3l, *UI_List3w=NULL;

static GtkWidget *UI_DialogYWin=NULL;

static GtkWidget *UI_DialogYNWin=NULL;
static void      (*UI_DialogYNFunc)();

static GtkWidget *UI_GetTextWin=NULL, *UI_GetTextEnt;
static void      (*UI_GetTextFunc)();



static GtkWidget *UI_act_wi;
static GtkWidget *UI_act_FileSelBox;


static GtkStyle *UI_style_act;
static GtkTooltips *UI_tip = NULL;


static int UI_WinposX=0, UI_WinposY=0;



// Prototypes:
void GUI_Notebook_CB (GtkNotebook*, GtkNotebookPage*, guint, void*);




//=====================================================================
  void GUI_Init (char *wtit) {
//=====================================================================
/// \code
/// Muss der erste Call sein.
/// wtit = Resourcedatei fnam.rc
/// 
///   GUI_Init ("");
///   GUI_Init ("gtk1.rc");
/// 
/// \endcode
// 
// Debug-options:
// --g-fatal-warnings      stop on warnings.


  int       i1;

  // char      *argv[]={"gCAD3D","--g-fatal-warnings",NULL};
  // char      **p1;


  printf("GUI_init |%s| %d\n",wtit,strlen(wtit));


#ifdef GTK2
  // gtk_set_locale ();
  gtk_disable_setlocale ();  // sonst Beistrich statt Decimalpunkt !! (LC_ALL)
#endif


  // i1 = 0;
  // while(argv[i1]) {printf(" %d |%s|\n",i1,argv[i1]); ++i1;}



  /* gtk_init (&argc, &argv); */
  i1 = 0;
  gtk_init (&i1, NULL);
  // i1 = 2; p1 = argv; gtk_init (&i1, &p1);  // geht so ned ..


  // Die Styles (Farben, Fonts, Pixmaps ..) aus rc-Datei einlesen
  if (strlen(wtit) > 0) {
    gtk_rc_parse (wtit);
  }


  UI_tip = gtk_tooltips_new();

  // printf("ex GUI_init\n");
  return;
}


//=========================================================================
  void GUI_GetWinPos (int *x, int *y, GtkWidget *w1) {
//=========================================================================
/// ACHTUNG: geht nicht bei MS-Win!!!


  int       x1,y1,sx,sy;
  // GdkWindow *wp;

  printf("GUI_GetWinPos\n");


  // wp = gtk_widget_get_parent_window (GTK_WIDGET(w1));
  // L.148
  //  gtk_widget_get_ancestor ?
  // printf(" get_parent_window OK\n");



  // if(wp) {
    // gdk_window_get_geometry(wp, &x1,&y1,&sx,&sy,&i1);  // L.791
    gdk_window_get_geometry(w1->window, &x1,&y1,&sx,&sy,NULL);  // L.791
    // gdk_window_get_geometry (w1, &x1,&y1,&sx,&sy,NULL);  // L.791
    *x = x1;
    *y = y1;
    // printf("wp=%d,%d\n",x1,y1);
  // }

  printf("ex GUI_GetWinPos=%d,%d\n",*x,*y);

}




//=========================================================================
  void GUI_GetWidgetPos (int *x, int *y, GtkWidget *w1) {
//=========================================================================
/// \code
///  liefert leider nur die relative Position im Window od Toolbar.
/// 
///     GUI_GetWinPos(&x1, &y1, wcGeo_tb);
///     GUI_GetWidgetPos(&x2, &y2, wcGeo_tb); // rel. Posi des Toolbar
///     x1 += x2;  y1 += y2;
///     GUI_GetWidgetPos(&x2, &y2, parent);
///     x1 += x2;  y1 += y2;
///     GUI_SetWinpos (x1, y1);
/// \endcode



  // int       x1,y1,sx,sy,i1;
  // GtkWidget  *win1;
  // GdkWindow *wp;

  // printf("GUI_GetWidgetPos\n");

  *x = GTK_WIDGET(w1)->allocation.x;
  *y = GTK_WIDGET(w1)->allocation.y;

/*
  wp=gtk_widget_get_parent_window (GTK_WIDGET(w1));


  if(wp) {
    gdk_window_get_geometry(wp, &x1,&y1,&sx,&sy,&i1);
    // *x=GTK_WIDGET(wp)->allocation.x;
    // *y=GTK_WIDGET(wp)->allocation.y;
    *x += x1;
    *y += y1;
    printf("wp=%d,%d\n",x1,y1);
  }
*/

  // win1 = gtk_widget_get_toplevel (w1);
  // win1 = gtk_widget_get_ancestor(w1, GTK_TYPE_WINDOW);
  // GUI_GetWinPos (x, y, win1);

  // kann in MS-Win Windowpos nicht lesen; daher absolute Pointerpos holen
  gdk_window_get_pointer (NULL, x, y, NULL);


  // printf("ex GUI_GetWidgetPos=%d,%d\n",*x,*y);

}


//=========================================================================
  void GUI_SetWinpos   (int xpos, int ypos) {
//=========================================================================
/// position only for auxiliary windows !!

  UI_WinposX = xpos;
  UI_WinposY = ypos;

}



//=========================================================================
  int GUI_CB_WinDel (GtkWidget *parent, GdkEvent *event,void(*data)()) {
//=========================================================================

  // printf("GUI_CB_WinDel\n");

  (*data)(NULL, (void*)UI_FuncKill); 

  return TRUE;

}

//=========================================================================
  int GUI_WinTit (GtkWidget *window, char *wtit) {
//=========================================================================

  // printf("GUI_WinTit |%s|\n",wtit);

  gtk_window_set_title (GTK_WINDOW (window), wtit);

  return 0;

}


//=========================================================================
  GtkWidget* GUI_Window (char *wtit, void *funcnam, void* data, int border) {
//=========================================================================
/// \code
/// 
/// wtit:		WindowTitle.
/// funcnam:	wird bei DestroyWindow (mit zugehrigem data) gerufen !
/// border:		wieviel Platz innen (rundum) frei bleiben soll.
/// 
/// winID = GUI_Window ("Line", NULL, NULL, 0);
/// winID = GUI_Window ("Liste", UI_Typ_Ltyp, (void*)UI_FuncKill, 0);
/// 
/// Die Size; normal unnutz.
///   gtk_widget_set_usize (window, 550, 60);
/// 
/// Position setzen:
///   // auf fixe Pos.:
///   gtk_widget_set_uposition (window, 100, 400);
///   // oder auf aktuelle maouspos:
///   gtk_window_set_position (window, GTK_WIN_POS_MOUSE);
/// 
/// Windowtitle nachtraeglich nochmal korrigieren:
///   gtk_window_set_title (GTK_WINDOW (winID), "neuer titel");
/// 
/// Achtung: derzeit kann mit "destroy" und delete_event kein data mitgegeben
///   werden, daher muss eigene Funktion gemacht werden.
/// 
/// allow_grow und allow_shrink in gtk_window_set_policy.
/// \endcode


// vi /usr/include/gtk/gtkwindow.h
// vi /usr/include/gtk/gtkmain.h


  GtkWidget *window;

  GdkFont   *wFont;


  // printf("GUI_Window |%s|%d|\n",wtit,(int)data);


  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  GUI_WinTit (window, wtit);


  if (border > 0) {
    gtk_container_border_width (GTK_CONTAINER (window), border);
  }


  /* printf("connect exit\n"); */
  if (funcnam) {

    gtk_signal_connect (GTK_OBJECT(window), "destroy",
                     (GtkSignalFunc) funcnam, data);

/*
    // komplett umleiten
    gtk_signal_connect (GTK_OBJECT(window), "delete-event",
                     (GtkSignalFunc) GUI_CB_WinDel, funcnam);
*/
  }

  /* gdk_window_set_cursor (window->window, gdk_cursor_new (GDK_HAND1)); */

  /* gtk_quit_add_destroy (0, GTK_OBJECT(window)); */


  /* Die Size; normal unnutz. */
  /* gtk_widget_set_usize (window, 550, 60); */

  /* welche Position ? */
  // gtk_widget_set_uposition (window, 100, 400);


  /* Ohne eine Box geht nix; */
  /* box0 = GUI_Vbox (window, 0); */




  // geht das auch mit GTK1 ?
  // Style hat farben, Font GdkFont *font, BackgrndPixmap usw
  UI_style_act = gtk_widget_get_style (window);


#ifdef GTK1

  // Breite/Hoehe eines einzelnen Char einlesen. = 7,21
  UI_fontsizX = gdk_char_width (UI_style_act->font, '0');
  UI_fontsizY = gdk_char_height (UI_style_act->font, '0');

#else

  wFont = gtk_style_get_font (UI_style_act);

  // Breite/Hoehe eines einzelnen Char einlesen. = 7,21
  UI_fontsizX = gdk_char_width (wFont, '0');

  
  // UI_fontsizY = gdk_char_height (wFont, '0');
  // funktioniert in MS-Win leider nicht; lifert 21 statt 10
  UI_fontsizY = wFont->ascent - wFont->descent;


#endif

    printf("UI_fontsizX/Y=%d,%d\n",UI_fontsizX,UI_fontsizY);
    // printf("fontAsc=%d\n",UI_style_act->font->ascent);
    // exit(0);



  /* return window; */
  WinAct = window;

  // 2007-04-20
  // wird ein window geloescht, werden wahrscheinlich auch einige zum
  // tooltip gehoerige Pointer geloescht; daher:
  UI_tip = gtk_tooltips_new();

  return window;

}



//=====================================================================
  GtkWidget* GUI_Toolbox (GtkWidget *parent) {
//=====================================================================
/// \code
/// vi /usr/include/gtk/gtkhandlebox.h
/// gtk_handle_box_set_handle_position
/// gtk_handle_box_set_snap_edge
/// \endcode


  GtkWidget *box1;


  box1 = gtk_handle_box_new ();
  gtk_box_pack_start (GTK_BOX (parent), box1, FALSE, FALSE, 0);
  gtk_widget_show (box1);


  return box1;

}



//=====================================================================
  GtkWidget* GUI_Hbox (GtkWidget *parent, int border) {
//=====================================================================
/// \code
/// border >= 0: wieviel Platz innen (rundum) frei bleiben soll.
/// border = -1: expand widgets in box; box aber fixed size.
/// 
/// Fr jedes primre Window ist eine primre box notwendig.
/// In Hboxen werden Widgets nebeneinander (Vboxen untereinander) geschlichtet.
/// Wenn mehrere Widgets in einen frame sollen, Box notwendig.
/// 
/// Den Level Vertikal mit Ziffern,  horiz. mit Buchstaben bezeichen.
/// Also abwechselnd Ziffer - Buchstabe.
/// 
/// border: wieviel Platz innen (rundum) frei bleiben soll.
/// 
///   GtkWidget *boxneu;
/// 
///   boxneu = GUI_Hbox (parentbox, 0);
/// \endcode

  
  GtkWidget *box1;

  // printf("GUI_Hbox %d\n",border);


  // box1 = gtk_hbox_new (expand, 0);
  // expand: TRUE=anpassen; FALSE=keep size (S.73)
  if(border < 0) {
    box1 = gtk_hbox_new (FALSE, 1);
    gtk_box_pack_start (GTK_BOX (parent),box1, FALSE, FALSE, 0);
    // if(border < -1) {
      // printf("..............resize\n");
      // gtk_widget_set_usize (box1, 500, 0);
    // }
  } else {
    box1 = gtk_hbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (parent), box1);
  }


  

  if (border > 0) {
    gtk_container_border_width (GTK_CONTAINER (box1), border);
  }

  gtk_widget_show (box1);

  return box1;

}



//=====================================================================
  GtkWidget* GUI_Frame (GtkWidget *parent, char* ltxt, int border) {
//=====================================================================
/// \code
/// Wenn mehrere Widgets in einen frame sollen, Box notwendig!
/// 
/// border: wieviel Platz innen (rundum) frei bleiben soll.
/// 
///   w1 = GUI_Hbox (box0, -1);
///   w2 = GUI_Frame (w1, "FrameTitel", 0);
///   w3 = GUI_Hbox (w2, 1);
///   w_info = GUI_Label (w3, "text", 0);
/// 
/// Optional:
///   gtk_widget_set_usize (frm1, 100, 75);
/// \endcode


  GtkWidget *frm1;

  frm1 = gtk_frame_new (ltxt);

  if (border > 0) {
    gtk_container_border_width (GTK_CONTAINER (frm1), border);

  } else if(border < 0) {
    gtk_box_pack_start (GTK_BOX (parent),frm1, TRUE, TRUE, 0);

  } else {
    gtk_container_add (GTK_CONTAINER (parent), frm1);
  }

  gtk_widget_show (frm1);

  UI_act_wi = frm1;
  return frm1;

}



//=====================================================================
  GtkWidget* GUI_Vbox (GtkWidget *parent, int border) {
//=====================================================================
/// \code
/// border >= 0: wieviel Platz innen (rundum) frei bleiben soll.
/// border = -1: expand widgets in box
/// \endcode


  GtkWidget *box1;

  // expand: TRUE=anpassen; FALSE=keep size (S.73)
  // box1 = gtk_vbox_new (expand, 0);
  if(border < 0) {
    box1 = gtk_vbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (parent),box1, FALSE, FALSE, 0);
  } else {
    box1 = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (parent), box1);
  }




  if (border > 0) {
    gtk_container_border_width (GTK_CONTAINER (box1), border);
  }
  gtk_widget_show (box1);


  if(border < -1) {
    gtk_widget_set_usize (box1, -border, -1);
  }

  return box1;

}


//================================================================
  int GUI_VSpace (GtkWidget *parent) {
//================================================================

  GtkWidget  *box0;

  box0 = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (parent),box0, FALSE, FALSE, 10);
  gtk_widget_show (box0);

  return 0;

}

 
//=====================================================================
  GtkWidget* GUI_Hsep (GtkWidget *parent, int border) {
//=====================================================================
/// \code
/// Hor. Trennlinie.
/// Border: Abstand ober- und unterhalb der Trennlinie.
/// \endcode


  GtkWidget *w1;

  w1 = gtk_hseparator_new ();

  // gtk_box_pack_start (GTK_BOX (parent), w1, TRUE, TRUE, border);
  gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, TRUE, border);
  // gtk_box_pack_start (GTK_CONTAINER (parent), w1, FALSE, TRUE, border);
  gtk_widget_show (w1);

  return w1;

}



//=====================================================================
  int GUI_Label_mod (GtkWidget *wlb, char* txt) {
//=====================================================================
/// modify label

  gtk_label_set_text ((GtkLabel*)wlb, txt);

/// gtk_label_set_text((GtkLabel*)(lbl), GTK_JUSTIFY_FILL);
/// gtk_label_set_text((GtkLabel*)(lbl), GTK_JUSTIFY_LEFT);
/// gtk_label_set_text ((GtkLabel*) (label), FALSE); //

  return 0;

}


//=====================================================================
  GtkWidget* GUI_Label (GtkWidget *parent, char* ltxt, int border) {
//=====================================================================
/// \code
/// border:  >0:  wieviel Platz innen (rundum) frei bleiben soll.
///          <0:  absoluter Platzbedarf; - fixed size.
/// 
/// more than 1 line: use \n
/// 
/// modify label: GUI_Label_mod (w_nam, "modified Text");
/// 
/// Lable nach links ausrichten: ( , xalign, yalign)
///   gtk_misc_set_alignment (GTK_MISC (label), 0.2, 0.5);
/// 
/// ??
/// gtk_misc_set_padding (GTK_MISC (label), 10, 10);
/// 
/// gtk_widget_set_usize(button, 250, 40);
/// 
/// // geht ned ?
///   // GTK_JUSTIFY_RIGHT od GTK_JUSTIFY_CENTER
/// 
/// 
/// ??
/// gtk_box_pack_start_defaults(GTK_BOX(vbox), lbl);
/// 
/// \endcode


  int       i1;
  GtkWidget *w1;

  w1 = gtk_label_new (ltxt);

  // expand,fill (S.74/75) 
  // expand: True=fill gesamten Space in box;
  // fill: nur bei expand=TRUE: TRUE=file space by Button, else by space around
  if(border > 0) {
    i1=border;
  } else {
    i1=0;
  }
  // gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, TRUE, i1);
  gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, FALSE, i1);

  // gtk_container_add (GTK_CONTAINER (parent), w1);

  gtk_widget_show (w1);

  // gtk_widget_set_usize (w1, strlen(ltxt)*3, 0);

  if(border < 0) {
    gtk_widget_set_usize (w1, -border, 0);
  }

  UI_act_wi = w1;
  return w1;

}


//================================================================
  int GUI_CkButt_get (GtkWidget *cb) {
//================================================================
/// returns state of checkbox; 0=not sel, 1=selected.
 
  return GTK_TOGGLE_BUTTON (cb)->active;

}


//================================================================
  void GUI_CkButt_set (GtkWidget* ckb1, int mode) {
//================================================================
/// \code
/// activate/disactivate Checkbox, Radiobutton.
/// Input:
///   mode    1 = TRUE  = ON
///           0 = FALSE = OFF
/// \endcode

  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (ckb1), mode);

}


//=====================================================================
  GtkWidget* GUI_CkButt (GtkWidget *parent, char* ltxt, int state,
				void *funcnam, void *data, int border) {
//=====================================================================
/// \code
/// Checkbox.
/// state: Vorbelegeung - int, 0=not checked; TRUE od FALSE.
/// 
/// ---------------------------
/// Example without callback:
/// 
///   int istate;
///   GtkWidget  *cb1;
///   // create checkbox
///   cb1 = GUI_CkButt (box0, "ckb 1", TRUE, NULL, NULL, 0);
///   // query state
///   istate = GUI_CkButt_get (cb1)        // 0=not sel, 1=selected.
/// 
/// 
/// ---------------------------
/// Example with callback:
/// 
///   w1=GUI_CkButt (box0, "ckb 1", 0, f_ckbutt, NULL, 0);
/// 
/// int f_ckbutt (GtkWidget *parent, void *data) {
/// 
///   if(GUI_CkButt_get(parent)) goto L_activate;
///   printf("f_ckbutt disactivate\n");
///   ..
///   L_activate:
///   ..
/// }
/// 
/// ---------------------------
/// Optional:
/// 
/// activate with:
///   GUI_CkButt_set (ckb1, TRUE);
///   // gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (ckb1), TRUE);
///   // gtk_toggle_button_toggled (ckb1);
/// \endcode



  int i1;


  UI_act_wi = gtk_check_button_new_with_label (ltxt);

  // if (state == TRUE) {
    gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (UI_act_wi), state);
  // }

  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT (UI_act_wi), "clicked",
                      (GtkSignalFunc) funcnam, data);
  }

  gtk_container_add (GTK_CONTAINER (parent), UI_act_wi);
  // NICHT mit gtk_box_pack_start !

  // gtk_misc_set_alignment geht nicht ..
  
  gtk_widget_show (UI_act_wi);

  return UI_act_wi;

}


//======================================================================
  GtkWidget* GUI_MenuRadButt    (GtkWidget *parent, char* ltxt) {
//======================================================================

  GtkWidget *w1;



  w1 = gtk_radio_menu_item_new_with_label (NULL, ltxt);

/*
  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT (w1), "activate",
                      (GtkSignalFunc) funcnam, data);
  }
*/


  gtk_menu_append (GTK_MENU(parent), w1);
  gtk_widget_show (w1);


  UI_act_wi = w1;
  return w1;

}


//======================================================================
	GtkWidget* GUI_MenuRadButtAdd (GtkWidget *parent, char* ltxt) {
//======================================================================


  GtkWidget *w1;



  w1 = gtk_radio_menu_item_new_with_label (
                      gtk_radio_menu_item_group(
                      GTK_RADIO_MENU_ITEM(UI_act_wi)),
                      ltxt);

/*
  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT (w1), "activate",
                      (GtkSignalFunc) funcnam, data);
  }
*/


  gtk_menu_append (GTK_MENU(parent), w1);
  gtk_widget_show (w1);


  UI_act_wi = w1;
  return w1;

}


//=====================================================================
  GtkWidget* GUI_RadButt (GtkWidget *parent, char* ltxt,
				void *funcnam, void *data, int border) {
//=====================================================================
/// \code
/// Radiobuttons:
/// get state:
///   printf("ckb1 = %d\n", GUI_CkButt_get (widget);  // 1=ON;0=OFF
/// 
/// activate:
///   GUI_CkButt_set (wb, TRUE|FALSE);
///     //gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON  (bA), TRUE);
///   // skip disactivation ..
///   if(GTK_TOGGLE_BUTTON (parent)->active == 0) return 0;  // 1=ON;0=OFF
///   oder
///   if(GTK_TOGGLE_BUTTON (ckb1)->active == 0) return 0;  // 1=ON;0=OFF
/// \endcode



  /* int       i1; */
  GtkWidget *w1;
  /* GSList    *g1; */

  /* printf("GUI_RadButt\n"); */

  w1 = gtk_radio_button_new_with_label (NULL, ltxt);

  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT (w1), "clicked",
                      (GtkSignalFunc) funcnam, data);
  }


  // gtk_container_add (GTK_CONTAINER (parent), w1);

  gtk_box_pack_start (GTK_BOX (parent), w1, FALSE,FALSE,0);

  // gtk_box_pack_start (GTK_BOX (parent), w1, TRUE, TRUE, border);

  if(border < 0) {
     gtk_widget_set_usize (w1, -border, 0);  // size in pixel x,y.
  }

  gtk_widget_show (w1);

  ButtKett = w1;

  ButtKettAnz = 0;
  ButtKettArr[ButtKettAnz] = w1;

  UI_act_wi = w1;
  return w1;

}


//=====================================================================
  GtkWidget* GUI_RadButtAdd (GtkWidget *parent, char* ltxt,
				void *funcnam, void *data, int border) {
//=====================================================================
/// \code
/// Radiobuttons.
///   GUI_RadButt    (box0, "button1",f_radbutt,(void*)0,0);
///   GUI_RadButtAdd (box0, "button2",f_radbutt,(void*)1,0);
///   GUI_RadButtAdd (box0, "button3",f_radbutt,(void*)2,0);
/// 
///   int f_radbutt (GtkWidget *parent, void *data) {
///     if ((GTK_TOGGLE_BUTTON (parent)->active) == 0) {
///       printf("skip pt disactivation\n");
///       goto Fertig;
///     }
///     ..........
///   }
/// 
/// activate:    (deaktiviert den momentan aktiven Button):
///   GUI_CkButt_set (w2, TRUE);
/// or
///   GUI_RadButtSet
/// get state:
///   printf("ckb1 = %d\n", GUI_CkButt_get (widget);  // 1=ON;0=OFF
/// 
/// Ruft funcnam eigentlich 2-mal; einmal deactive voher aktiven Button, dann
/// 	activate new Buttton.
/// \endcode


  /* int       i1; */
  GtkWidget  *w2;
  /* GSList    *g1; */

  /* printf("GUI_RadButtAdd\n"); */

  w2 = gtk_radio_button_new_with_label
         (gtk_radio_button_group (GTK_RADIO_BUTTON (ButtKett)), ltxt); 

  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT (w2), "clicked",
                      (GtkSignalFunc) funcnam, data);
  }

  /* gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (w2), FALSE); */

  // gtk_container_add (GTK_CONTAINER (parent), w2);
  gtk_box_pack_start (GTK_BOX (parent), w2, FALSE,FALSE,0);
  // gtk_box_pack_start (GTK_BOX (parent), w2, TRUE, TRUE, border);

  if(border < 0) {
     gtk_widget_set_usize (w2, -border, 0);  // size in pixel x,y.
  }

  gtk_widget_show (w2);

  ButtKettAnz++;
  ButtKettArr[ButtKettAnz] = w2;
  ButtKett = w2;

  // printf("GUI_RadButtAdd %d %d\n",ButtKettAnz,ButtKettArr[ButtKettAnz]);

  UI_act_wi = w2;
  return w2;

}


//=====================================================================
  void GUI_RadButtSet (int ind) {
//=====================================================================


  // printf("GUI_RadButtSet %d %d\n",ind,ButtKettArr[ind]);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (ButtKettArr[ind]), TRUE);

}




//=====================================================================
  void GUI_OptMenActivate (GtkWidget *w1, int ind) {
//=====================================================================


  // set startindex; 0=erster, 2=dritter ...
  gtk_option_menu_set_history (GTK_OPTION_MENU (w1), ind);


}



//=====================================================================
  void GUI_OptMenChg (GtkWidget *parent, char *optLst[], void* funcnam) {
//=====================================================================
/// \code
/// 
/// Change the menu of existing OptionMenu.
/// 
/// gtk_option_menu_remove_menu ??
/// 
/// Windows: vor dem beladen aktivieren, sonst immer inaktiv !!
/// 
///   char *optLst[]={"A1","A2",""};
/// 
/// vi /usr/include/gtk/gtkoptionmenu.h
/// vi /usr/include/gtk/gtkmenu.h
/// vi /usr/include/gtk/gtkmenuitem.h
/// vi /usr/include/gtk/gtkitem.h
/// \endcode


  int    i1;
  GtkWidget *menu=NULL, *item;



/*
gtk_object_destroy ()
gtk_object_destroy(
gtk_type_free().
*/

  // printf("GUI_OptMenChg\n");



  menu = GTK_OPTION_MENU (parent)->menu;
  item = GTK_OPTION_MENU (parent)->menu_item;


  // delete previous List
  if(menu != NULL) {
    gtk_option_menu_remove_menu (GTK_OPTION_MENU(parent));
    // gtk_object_destroy (GTK_OBJECT (menu)); // od gtk_widget_destroy ?
    // gtk_object_destroy (GTK_OBJECT (item)); // od gtk_widget_destroy ?
  }


  // if(menu == NULL) {
    menu = gtk_menu_new();
    // gtk_widget_set_usize (menu, 100, 0);  // size in pixel x,y.
    // gtk_menu_detach(menu); // NEIN !!
  // }
  


  i1=0;


  // poulate list
  if(optLst) {
    while (optLst[i1]) {
      // printf(" optLst[%d]=|%s|\n",i1,optLst[i1]);
      if(strlen(optLst[i1]) < 1) break;
  
      item = gtk_menu_item_new_with_label (optLst[i1]);
      // gtk_widget_set_usize (item, 60, 0);  // size in pixel x,y.
  
      // clicked,selection_changed gehen nicht?
      gtk_signal_connect (GTK_OBJECT (item), "activate",
                        (GtkSignalFunc) funcnam, (void*)i1);
  
      gtk_menu_append (GTK_MENU (menu), item);
      gtk_widget_show (item);
  
      ++i1;
    }



  // } else {
    // printf(" init option_menu\n");
    // item = gtk_menu_item_new_with_label (" ");
    // gtk_widget_set_usize (item, 100, 0);  // size in pixel x,y.
    // gtk_menu_append (GTK_MENU (menu), item);
    // gtk_widget_show (item);

  }



  gtk_option_menu_set_menu (GTK_OPTION_MENU (parent), menu);

  return;

}


//=====================================================================
  GtkWidget* GUI_OptMen (GtkWidget *parent, char *optLst[], void* funcnam,
                         int border) {
//=====================================================================
/// \code
/// OptionMenu ist eine Liste wie ComboBox, aber ohne Eingabemoeglichkeit.
/// funcnam wird mit dem Index der gewaehlten Zeile gerufen
/// Abfrage der aktiven Zeile nicht moeglich; nur via Callback funcnam.
///
/// parent     parentBox
/// optLst     a null-terminated list of words; NULL for empty List.
/// funcnam    callback-function
/// border     if negativ: width of list in pixels
///            pos:  fixed pos; 16 bit dx, 16 bit dy.  (dx + (dy << 16);)
/// 
/// AuxFunctions:
///   GUI_OptMenChg      Load/Modify list later ..
///   GUI_OptMenActivate     preselect a listEntry
/// 
/// Examples:
///   char *optLst[]={"Jaenner","Februar","Maerz",NULL};
/// 
///   GUI_OptMen  (box0, optLst, OptMen_CB, 0);
/// 
/// //=====================================================================
///   int OptMen_CB (GtkWidget *parent, void *data) {
/// //=====================================================================
/// 
///   printf("OptMen_CB sel. Line = |%d|\n",(int)data);
///   return 0;
/// 
/// }
/// ----------------------------------------------------------------------
/// vi /usr/include/gtk/gtkoptionmenu.h
/// gtk_option_menu_new S.469
/// \endcode



typedef union {long i4; short i2[2];} uni_i4i2;

  static GtkWidget *w1, *box1;
  uni_i4i2  i2;
  int       iy;


  // printf("OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO \n");
  // printf("GUI_OptMen %d\n",border);


  w1 = gtk_option_menu_new ();

  GUI_OptMenChg (w1, optLst, funcnam);


  if(border > 0) {
    // horizPosition geht mit h/vbox nicht;
    box1 = gtk_fixed_new ();
    gtk_container_add (GTK_CONTAINER (parent), box1);
    gtk_widget_show (box1);
    if(border > 65535) {
      iy = border >> 16;
      border = border & 65535;
      // printf(" dx=%d dy=%d\n",border, iy);
    } else {
      iy = 0;
    }
    gtk_fixed_put (GTK_FIXED (box1), w1, border, iy);
    // gtk_widget_show (box1);


  } else if(border == 0) {
    
    gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, FALSE, 0);


  } else if(border < 0) {
     // gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, FALSE, 0);
     gtk_widget_set_usize (w1, -border, 0);  // size in pixel x,y.
     gtk_box_pack_start (GTK_BOX (parent), w1, TRUE, TRUE, 0);
  }



  // gtk_widget_set_usize (w1, 100, 0);
  gtk_widget_show (w1);


  UI_act_wi = w1;

  return w1;

}



//=====================================================================
  GtkWidget* GUI_Combo (GtkWidget *parent, void *funcnam, int border) {
//=====================================================================
/// \code
/// ONLY FOR DEMONSTRATION PURPOSES !!!
/// 
///   // Auslesen der aktiven Zeile:
///   char *txt;
///   txt = gtk_entry_get_text ((GtkEntry*) (GTK_COMBO (cm1)->entry));
/// 
///   // Listindex scheinbar nicht in der COMBO-struct.
///   // gehen NICHT:
///   // printf("    ind= %d\n",GTK_COMBO (cm1)->list_change_id);
///   //ind = gtk_list_child_position(GTK_LIST(GTK_COMBO(cm1)->list),
///   //      GTK_WIDGET(GTK_LIST(GTK_COMBO(cm1)->list)->last_focus_child));
///   // printf("    ind= %d\n",ind);
///   // printf("    ind= %d\n",GTK_LIST(GTK_COMBO(cm1)->list)->vtimer);
/// 
/// 
/// vi /usr/include/gtk/gtkcombo.h
/// vi /usr/include/glib-1.2/glib.h   //g_list...
/// \endcode



  // GtkWidget *list;

  static GtkWidget *w1;

  GList *entLst = NULL;



  // create doubly linked list /usr/include/glib./glib.h
  // vi /usr/include/gtk/gtklist*
  entLst = g_list_append (entLst, "Point");
  entLst = g_list_append (entLst, "Line");
  entLst = g_list_append (entLst, "Circ");



  // list = gtk_list_new ();


  w1 = gtk_combo_new ();

  gtk_combo_set_popdown_strings (GTK_COMBO(w1), entLst);


  // clicked gibts fuer ?? nicht.
  // "selection_changed",   gibts fuer ?? nicht.
  // "activate", kommt nur mit CR
  // Koennte man einen Event ais das List-click setzen ?
  // gtk_signal_connect (GTK_OBJECT (GTK_COMBO (w1)->entry),
  gtk_signal_connect (GTK_OBJECT (GTK_COMBO (w1)->entry),
                      "activate", // kommt nur mit CR
                      GTK_SIGNAL_FUNC (funcnam), NULL);


  // nur damit kommt jedes CR als Event !!
  gtk_combo_disable_activate (GTK_COMBO (w1));


  // Zeile # 3 vorwaehlen ..
  // gtk_list_select_item (GTK_LIST (GTK_COMBO (w1)->list), 2);


  // geht nur einmal
  // gtk_entry_set_text ((GtkEntry*) (GTK_COMBO (w1)->entry), "def");

  gtk_box_pack_start (GTK_BOX (parent), w1, FALSE, FALSE, border);
  gtk_widget_show (w1);


  // gtk_widget_set_sensitive (w1, (gint)0);

  g_list_free (entLst);

  // gtk_combo_set_value_in_list(w1, 2, TRUE); // ????

  return w1;
}


//================================================================
  int GUI_Entry_set (GtkWidget* entry, char* text) {
//================================================================
/// set text in entryField

  gtk_entry_set_text ((GtkEntry*)entry, text);

  return 0;

}


//================================================================
  char* GUI_Entry_get (GtkWidget* entry) {
//================================================================
/// get text from entryField - gives back a Pointer !

  return gtk_entry_get_text((GtkEntry*)entry);

}


//================================================================
  int GUI_Entry_Get (char *cbuf, GtkWidget* entry) {
//================================================================
/// GUI_Entry_Get get text from entryField - copy

  char  *cp1;

  cp1 = gtk_entry_get_text((GtkEntry*)entry);

  strcpy(cbuf, cp1);

  return 0;

}

 
//=====================================================================
  GtkWidget* GUI_Entry (GtkWidget *parent, char* ltxt, char* etxt,
				void *funcnam, int border) {
//=====================================================================
/// 
/// \code
/// ltxt:    Labeltext; NULL or "" for none
/// etxt:    Text im Entryfield; NULL oder "" for none
/// funcnam: callback-function for all Keypress & FocusIn-Events (none: NULL)
/// border   < 0:   entSiz direkt (in Pixels;
///          0:     via len von etxt
/// 
/// 
/// entry = GUI_Entry (parent, "0.0", "sum", NULL, 0);
/// 
/// Preset:
///   GUI_Entry_set (GtkWidget* entry, char* text);
///   //gtk_entry_set_text ((GtkEntry*) (w_nam), "newText");
/// 
/// Read:
///   char* text = GUI_Entry_get (GtkWidget* entry);
///   //char* gtxt = gtk_entry_get_text ((GtkEntry*) (w_nam));  // DO NOT free!
/// 
/// Readonly:
///   gtk_entry_set_editable (entry, FALSE);
///
/// Callbackroutine:
/// 
/// //=====================================================================
///   int Ent1_CB (GtkWidget *parent, GdkEventAny *event) {
/// //=====================================================================
/// 
/// #include <gdk/gdkkeysyms.h>         // f. GDK_Return
/// 
///   char     *txt;
/// 
///   // if(event->type == GDK_FOCUS_CHANGE) return;
///   if(event->type != GDK_KEY_PRESS) return;
/// 
///   switch (((GdkEventKey*)event)->keyval) {
/// 
///     case GDK_Return:
///     case GDK_Tab:
///       txt = gtk_entry_get_text ((GtkEntry*) (parent));
///       // g_free (txt);  // damit Absturz !!
///       break;
///   }
/// 
///   return FALSE;  // do defaultOperations (set focus to this field)
///   // return TRUE;  // do no defaultOperations
/// 
/// }
/// 
/// vi /usr/include/gtk/gtkentry.h
/// \endcode


  int    i1;
  static GtkWidget *w1, *w2, *box1;


  if (ltxt) {
    /* printf("Labelext /%s/\n",ltxt); */
    box1 = GUI_Hbox (parent, -1);
    w2 = gtk_label_new (ltxt);
    gtk_container_add (GTK_CONTAINER (box1), w2);
    // gtk_box_pack_start (GTK_BOX (parent), w2, TRUE, TRUE, 0);
    gtk_widget_show (w2);
  } else {
    box1 = parent;
  }


  w1 = gtk_entry_new (); 


  if (funcnam) {

    // gtk_widget_set_events (GTK_WIDGET(w1),
                        // GDK_KEY_PRESS_MASK);

    // gtk_signal_connect (GTK_OBJECT (w1),
                        // "key_press_event",
                        // (GtkSignalFunc) funcnam, NULL);

    g_signal_connect (G_OBJECT (w1),
                        "key-press-event",
                        G_CALLBACK (funcnam), NULL);

    g_signal_connect (G_OBJECT (w1),
                        "focus-in-event",
                        G_CALLBACK (funcnam), NULL);

                        // "focus-out-event",
                        // "leave-notify-event",
                        // "populate-popup",  ??

  }


  // preset Text
  i1 = 0;
  if(etxt) i1 = strlen(etxt);
  if(i1 > 0) {
    /* printf("preset Text /%s/\n",etxt); */
    gtk_entry_set_text ((GtkEntry*) (w1), etxt);
  }


  // gtk_box_pack_start (GTK_BOX (box1), w1, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (box1), w1, FALSE, TRUE, 0);

  gtk_widget_show (w1);

/*
  // Macht einen Absturz !!!
  // Achtung; geht erst nach gtk_widget_show!
  if(i1 > 0) {
    // printf("len %d\n",i1);
    // i2 = i1 * UI_fontsizX;
    UI_style_act = gtk_widget_get_style (w1);
    UI_fontsizX = gdk_char_width (UI_style_act->font, '0');
    i2 = gdk_string_width (UI_style_act->font, etxt) + UI_fontsizX;
    gtk_widget_set_usize (w1, i2, 0);  // size in pixel x,y.
  }
*/


  // (wid, x, y); y=0automat; bei x geht das nicht
  if(border < 0) {
    gtk_widget_set_usize (w1, -border, 0);
  } else {
    // gtk_widget_set_usize (w1, (i1*6)+5, 0);            // GTK1 !?
    gtk_widget_set_usize (w1, (i1*UI_fontsizX)+5, 0);
  }

  // Text nach links ausrichten: gtk_misc_set_alignment geht nicht! (nur label


  UI_act_wi = w1;
  return w1;

}


//=====================================================================
  GtkWidget* GUI_EntryL (GtkWidget *parent, char* ltxt, char* etxt,
        void *funcnam, int border) {
//=====================================================================
/// \code
/// InputField - Labeltext  (Labeltext right of InputField))
/// see also GUI_Entry (Labeltext left of InputField))
/// \endcode

  int       i1;
  GtkWidget *w1, *w2, *box1;


  // printf("GUI_EntryL |%s|%s|\n",ltxt,etxt);


  w1 = gtk_entry_new ();

  if (funcnam) {
    g_signal_connect (G_OBJECT (w1),
                        "key-press-event",
                        G_CALLBACK (funcnam), NULL);
    g_signal_connect (G_OBJECT (w1),
                        "focus-in-event",
                        G_CALLBACK (funcnam), NULL);
  }


  // preset Text
  i1 = 0;
  if(etxt) i1 = strlen(etxt);
  if(i1 > 0) {
    /* printf("preset Text /%s/\n",etxt); */
    gtk_entry_set_text ((GtkEntry*) (w1), etxt);
  }


  // create hbox (field - label)
  if (ltxt) {
    box1 = GUI_Hbox (parent, -1);
  } else {
    box1 = parent;
  }


  gtk_box_pack_start (GTK_BOX (box1), w1, FALSE, TRUE, 0);
  //gtk_container_add (GTK_CONTAINER (box1), w1);
  gtk_widget_show (w1);


  // (wid, x, y); y=0automat; bei x geht das nicht
  if(border < 0) {
    gtk_widget_set_usize (w1, -border, 0);
  } else {
    gtk_widget_set_usize (w1, (i1*UI_fontsizX)+5, 0);
  }


  // add label
  if (ltxt) {
    w2 = gtk_label_new (ltxt);
    gtk_container_add (GTK_CONTAINER (box1), w2);
    gtk_widget_show (w2);
  }

  // Text nach links ausrichten: gtk_misc_set_alignment geht nicht! (nur label


  UI_act_wi = w1;
  return w1;

}


//=====================================================================
  int GUI_DialogYN_CB (GtkWidget *parent, void *data) {
//=====================================================================

  int idat;

  // printf("GUI_DialogYN_CB %d\n",(int)data);

  idat = (int)data;


/*
  if ((GTK_TOGGLE_BUTTON (parent)->active) == 0) {
    printf("skip disactivation\n");
    return 0;
  }
*/


      gtk_widget_destroy (UI_DialogYNWin);
      UI_DialogYNWin=NULL;

  // GUI_update__(); // update pending events
  // raus 2009-01-30 - blockiert Fun

  switch(idat) {

    case UI_FuncOK:
      (*UI_DialogYNFunc) (NULL, (void*)idat);
      // (*UI_DialogYNFunc) (NULL, data);
      break;

    case UI_FuncCancel:
      (*UI_DialogYNFunc) (NULL, (void*)idat);
      // (*UI_DialogYNFunc) (NULL, data);
      break;
    default:;
  }


      // gtk_widget_destroy (UI_DialogYNWin);
      // UI_DialogYNWin=NULL;

  return 0;
} 




//=====================================================================
  void GUI_DialogYN (char* text, void *funcnam ) {
//=====================================================================
/// \code
/// Ein Textausgabefenster mit einem OK-Button und einem Cancel-Butten.
/// The callbackfunction is called with int-value UI_FuncOK or UI_FuncCancel.
/// 
/// Mehrzeilig mit \n im Text.
/// 
/// Beispiel:
///   GUI_DialogYN ("OK to save file xy", f_CB_save);
/// 
/// 
/// //=====================================================================
///   int f_CB_save (GtkWidget *parent, void *data) {
/// //=====================================================================
/// 
///   int idat;
/// 
///   printf("f_CB_save %d\n",(int)data);
/// 
///   idat = (int)data;
/// 
///   switch(idat) {
/// 
///     case UI_FuncOK:
///       // save ...
///       break;
/// 
///     case UI_FuncCancel:
///       // skip saving ...
///       break;
///   }
/// 
///   return 0;
/// 
/// }
/// \endcode


  static GtkWidget *box0, *box1;


  // printf("UI_DialogYN |%s|\n",text);


  if(UI_DialogYNWin != NULL) {
    GUI_DialogYN_CB (NULL, (void*)UI_FuncKill);
  }


      UI_DialogYNWin=GUI_Window("Info-Window",NULL,NULL,0);

      // UI_DialogYNWin=GUI_Window("Info-Window",GUI_DialogYN_CB,
                               // (void*)UI_FuncKill,0);

      // gtk_widget_set_uposition (UI_DialogYNWin, UI_WinposX, UI_WinposY);
      // gtk_window_set_position (GTK_WINDOW(UI_DialogYNWin), GTK_WIN_POS_MOUSE);
      gtk_window_set_position (UI_DialogYNWin, GTK_WIN_POS_MOUSE);


      box0 = GUI_Vbox (UI_DialogYNWin, 0);

      GUI_Label (box0, text, 10);
      GUI_Hsep (box0, 0);


      box1 = GUI_Hbox (box0, 0);
      GUI_Butt (box1, "OK",    GUI_DialogYN_CB, (void*)UI_FuncOK, 5);
      GUI_Butt (box1, "Cancel",GUI_DialogYN_CB, (void*)UI_FuncCancel, 5);

      UI_DialogYNFunc=funcnam;
      gtk_widget_show (UI_DialogYNWin);



  return;

}


//=====================================================================
  int GUI_DialogY_CB (GtkWidget *parent, void *data) {
//=====================================================================

  gtk_widget_destroy (UI_DialogYWin);
  UI_DialogYWin=NULL;

  return 0;
}


//================================================================
  int GUI_MsgBox (char* text) {
//================================================================
/// \code
/// display messagewindow before having activated GTK (with gtk_main)
/// eg Errormessages before starting mainapplication.
/// \endcode

  extern void gtk_exit();

  GUI_Init ("");
  GUI_DialogY (text, gtk_exit);
  gtk_main ();
  // gtk_exit (0);
  // exit (0);

  return 0;

}


//=====================================================================
  void GUI_DialogY (char* text, void *funcnam) {
//=====================================================================
/// \code
/// Textausgabefenster mit OK-Button zum Beenden und Callback.
/// 
/// 
/// Beispiel:
///   GUI_DialogY (" - Directory does not exist", func1);
///   int func1 (GtkWidget *parent, void *data) { printf("closed ..\n"); }
///     
/// \endcode

  static GtkWidget *box0;



  if(UI_DialogYWin != NULL) {
    GUI_DialogY_CB (NULL, NULL);
  }


  if(funcnam == NULL) funcnam = GUI_DialogY_CB;

  UI_DialogYWin=GUI_Window("Info-Window",funcnam,NULL,0);


  box0 = GUI_Vbox (UI_DialogYWin, 0);

  GUI_Label (box0, text, 0);

  GUI_Butt (box0, "OK",   funcnam, NULL, 5);

  GUI_WinUpCB (UI_DialogYWin, NULL, (void*)UI_FuncInit);

  gtk_widget_set_uposition (UI_DialogYWin, UI_WinposX, UI_WinposY);
  gtk_widget_show (UI_DialogYWin);



  return;


}


//=====================================================================
  void GUI_Dialog (GtkWidget *widget, char* dialogtext) {
//=====================================================================
/// \code
/// Ein einfaches Textausgabefenster mit einem OK-Button zum Beenden.
/// DOES NOT WAIT
/// 
/// Beispiel:
///   GUI_Dialog (NULL, " - Directory does not exist");
///   GUI_Butt (box2,"DialogWindow",GUI_Dialog,"Hugo, mach was",0);
/// \endcode

// erster Parameter ist notwendig, um GUI_Dialog als gtk-CallbackFunktion
// verwenden zu koennen; also zB GUI_Butt (box2,"DialogWindow",GUI_Dialog,"Text");


  GtkWidget *window, *label, *bw1;


  // check if gtk is already up
  if(UI_tip == NULL) {    // GUI_Init not yet ..
    GUI_MsgBox (dialogtext);
    return 0;
  }


  window = gtk_dialog_new ();

  // an die momentane Mausposi
  // gtk_window_set_position (GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
  gtk_window_set_position (window, GTK_WIN_POS_MOUSE);

  bw1 = gtk_button_new_with_label ("OK");
  gtk_signal_connect_object (
             GTK_OBJECT (bw1),
             "clicked", (GtkSignalFunc) gtk_widget_destroy,
             GTK_OBJECT (window));
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->action_area), bw1,
                         TRUE, TRUE, 0);
  gtk_widget_show (bw1);


  label = gtk_label_new (dialogtext);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->vbox), label, TRUE,
                      TRUE, 0);
  gtk_widget_show (label);

  gtk_window_set_title (GTK_WINDOW (window), "Info");

  gtk_widget_show (window);

}


//================================================================
  int GUI_ColSel (void *parent, void *mode) {
//================================================================
/// \code
/// mode muss eine Callback-Function sein; zB:
/// GUI_Butt (box0, " colDialog ", GUI_ColSel, col_CB, -5);
///  int col_CB (ColRGB *cSel) {
///    printf("col_CB %d %d %d\n",cSel->cr,cSel->cg,cSel->cb);
///    return 0;
///  }
/// \endcode



// Typ_Color
typedef struct {unsigned cr:8, cg:8, cb:8, typ:8;}                  ColRGB;


  static GtkWidget  *colSel;
  static void       (*cb_func)(ColRGB*);

  GtkColorSelection *col1;
  double   da[4];
  ColRGB   cSel;


  printf("GUI_ColSel %d\n",(int)mode);


  if((int)mode == 1) {      // OK-clicked

    col1=GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(colSel)->colorsel);

    gtk_color_selection_get_color (col1, da);

    // printf(" %f %f %f\n",da[0],da[1],da[2],da[3]);
    cSel.cr = da[0] * 255;
    cSel.cg = da[1] * 255;
    cSel.cb = da[2] * 255;
    printf(" %d %d %d\n",cSel.cr,cSel.cg,cSel.cb);
    cb_func (&cSel);
    gtk_widget_destroy (colSel);
    return 0;

  }


  if((int)mode == 2) {               // Cancel clicked
    gtk_widget_destroy (colSel);
    return 0;
  }

  // Init ...

  colSel = gtk_color_selection_dialog_new (" select Modelcolor");

  gtk_signal_connect(
    GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(colSel)->ok_button),
    "clicked", (GtkSignalFunc)GUI_ColSel, (void*)1);

  gtk_signal_connect(
    GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(colSel)->cancel_button),
    "clicked", (GtkSignalFunc)GUI_ColSel, (void*)2);

  gtk_widget_show_all(colSel);

  cb_func = mode; // die callback-func

  return 0;

}


//=====================================================================
  int GUI_GetxText_get (char *txout) {
//=====================================================================


  char   *txt;

  // work ..
  txt = (char*)gtk_entry_get_text ((GtkEntry*) (UI_GetTextEnt));
  // printf("   |%s|\n",txt);
  strcpy(txout, txt);


  gtk_widget_destroy (UI_GetTextWin);
  UI_GetTextWin=NULL;

    printf("ex GUI_GetxText_get |%s|\n",txout);


  return 0;

}


//=====================================================================
  int GUI_GetxText_CB (GtkWidget *parent, void *data) {
//=====================================================================

  int    i1;
  char   *txt;


  printf("GUI_GetxText_CB %d\n",(int)data);

  i1 = (int)data;



  switch (i1) {



    //---------------------------------------------------------
    // Kill win.  ES MUSS tx FERTIG KOPIERT SEIN !!!
    case UI_FuncKill:
      if(UI_GetTextWin != NULL)
      gtk_widget_destroy (UI_GetTextWin);
      UI_GetTextWin=NULL;
      return 0;

/*
    //---------------------------------------------------------
    // cancel - button
    case UI_FuncCancel:
      txt = NULL;
      (*UI_GetTextFunc) (parent, (void*)txt);
      break;
*/

    default:
      return 0;

  }


  return 0;

}


//============================================================================
  int GUI_GetxText (char *label,char *text,int wSiz,void* funcnam,void* data) {
//============================================================================
/// \code
/// Query text from user.
/// label = text left of entryfield.
/// text  = predefined text in entryfield.
/// wsiz  = size of entryfield
/// funcnam = callbackfunction if OK clicked; Cancel: NO callback !
///
/// Example:
///
///   // ask for input
///   GUI_GetxText("keyIn","text", -200, my_CB, (void*)UI_FuncUCB1);
///   ...
/// }
///
/// //=================================================================
///   int my_CB (GtkWidget *parent, void *data) {
/// //=================================================================
/// // the callback if OK selected.
///   char cbuf[256];
///
///
///   if(data == NULL) return; // Cancel ?
///
///   printf("my_CB |%s|\n",(int*)data);
///
///   if ((int)(int*)data == UI_FuncUCB1) {
///     // get keyIn & kill Window
///     GUI_GetxText_get (cbuf);
///   }
///
///   return 0;
///
/// }
/// \endcode

 static GtkWidget *box0, *box1;


  printf("GUI_GetxText \n");


  if(UI_GetTextWin != NULL) {
    // gtk_widget_destroy (UI_GetTextWin);
    GUI_GetxText_CB (NULL, (void*)UI_FuncKill);
  }


      UI_GetTextWin = GUI_Window("Text Input", NULL, NULL, 0);
      // UI_GetTextWin=GUI_Window("Text Input",GUI_GetText_CB,
                               // (void*)UI_FuncKill,0);
                               // gtk_widget_destroy, 0);
                               // NULL, 0);


      box0 = GUI_Vbox (UI_GetTextWin, 0);

      UI_GetTextEnt = GUI_Entry (box0,label,text,NULL, wSiz);

      GUI_Hsep (box0, 0);

      box1 = GUI_Hbox (box0, 0);

      GUI_Butt (box1, "OK",    funcnam, data, 5);
      GUI_Butt (box1, "Cancel",GUI_GetxText_CB, (void*)UI_FuncKill, 5);

      // an momentane Mauspos (GTK2: call before show)
      gtk_widget_set_uposition (UI_GetTextWin, UI_WinposX, UI_WinposY);
      // gtk_window_set_position (GTK_WINDOW(UI_GetTextWin), GTK_WIN_POS_MOUSE);
      // gtk_window_set_position (UI_GetTextWin, GTK_WIN_POS_MOUSE);

      gtk_widget_show (UI_GetTextWin);
      // break;



  gtk_widget_grab_focus (UI_GetTextEnt);
  // GUI_WinUp


  return 0;

}


//=====================================================================
  int GUI_GetText_CB (GtkWidget *parent, void *data) {
//=====================================================================

  int    i1;
  char   *txt;


  // printf("GUI_GetText_CB %d\n",(int)data);

  i1 = (int)data;



  switch (i1) {



    //---------------------------------------------------------
    case UI_FuncWork:
      // printf("GUI_GetText_CB work\n");

      // work ..
      txt = (char*)gtk_entry_get_text ((GtkEntry*) (UI_GetTextEnt));
      // printf("   |%s|\n",txt);

      (*UI_GetTextFunc) (parent, (void*)txt);
      break;


    //---------------------------------------------------------
    // Kill win.  ES MUSS tx FERTIG KOPIERT SEIN !!!
    case UI_FuncKill:
      if(UI_GetTextWin != NULL)
      gtk_widget_destroy (UI_GetTextWin);
      UI_GetTextWin=NULL;
      return 0;


    //---------------------------------------------------------
    // cancel - button
    case UI_FuncCancel:
      txt = NULL;
      (*UI_GetTextFunc) (parent, (void*)txt);
      break;
  

    default:
      return 0;

  }


  return 0;

}


//=====================================================================
  int GUI_GetText (char *label, char *text, int wSiz, void* funcnam) {
//=====================================================================
/// \code
/// Query text from user.
/// parameters: see GUI_GetText1
/// \endcode

  return GUI_GetText1 ("Text Input",label, text, wSiz, funcnam);

}


//=====================================================================
  int GUI_GetText1 (char *title, char *label, char *text,
                    int wSiz, void* funcnam) {
//=====================================================================
/// \code
/// Query text from user.
/// title = windowtitle
/// label = text left of entryfield.
/// text  = predefined text in entryfield.
/// wsiz  = size of entryfield
/// funcnam = callbackfunction if OK clicked; Cancel: NO callback !
/// 
/// Example:
/// 
///   // ask for input
///   GUI_GetText(" Name of Program: ","Nowprog", -200, f_GetText_CB);
///   ...
/// }
/// 
/// //=================================================================
///   int f_GetText_CB (GtkWidget *parent, void *data) {
/// //=================================================================
/// // the callback if OK selected.
/// 
///   if(data == NULL) return; // Cancel ?
/// 
///   printf("f_GetText_CB |%s|\n",(char*)data);
/// 
///   // kill Window; muss explizit geschehen !
///   GUI_GetText_CB (NULL, (void*)UI_FuncKill);
/// 
///   return 0;
///     
/// }   
/// \endcode
    


  static GtkWidget *box0, *box1;



  if(UI_GetTextWin != NULL) {
    // gtk_widget_destroy (UI_GetTextWin);
    GUI_GetText_CB (NULL, (void*)UI_FuncKill);
    UI_GetTextWin = NULL;
    // GUI_del_events ();
  }


      // UI_GetTextWin=GUI_Window (title, NULL, NULL, 0);
      UI_GetTextWin=GUI_Window (title, NULL, gtk_exit, 0);
      // UI_GetTextWin=GUI_Window("Text Input",GUI_GetText_CB,
                               // (void*)UI_FuncKill,0);
                               // gtk_widget_destroy, 0);
                               // NULL, 0);


      box0 = GUI_Vbox (UI_GetTextWin, 0);
      box1 = GUI_Hbox (box0, 0);

      UI_GetTextEnt=GUI_Entry (box1,label,text,NULL, wSiz);
      GUI_Hsep (box0, 0);

      box1 = GUI_Hbox (box0, 0);
      GUI_Butt (box1, "OK",    GUI_GetText_CB, (void*)UI_FuncWork, 5);
      GUI_Butt (box1, "Cancel",GUI_GetText_CB, (void*)UI_FuncCancel, 5);

      UI_GetTextFunc=funcnam;

      // an momentane Mauspos (GTK2: call before show)
      // gtk_widget_set_uposition (UI_GetTextWin, UI_WinposX, UI_WinposY);
      // gtk_window_set_position (GTK_WINDOW(UI_GetTextWin), GTK_WIN_POS_MOUSE);
      gtk_window_set_position (UI_GetTextWin, GTK_WIN_POS_MOUSE);

      gtk_widget_show (UI_GetTextWin);
      // break;



  gtk_widget_grab_focus (UI_GetTextEnt);



  return 0;

}



//=====================================================================
  GtkWidget* GUI_Pix (GtkWidget *parent, char* filnam, int border) {
//=====================================================================
/// \code
/// Pixmap als Hintergrundbild
/// .xpm oder (zumindest Linux) .jpg.
/// \endcode


  GtkWidget *pixmapwid;
  GdkPixmap *pixmap;

/*
  GdkBitmap *mask;
  GtkStyle *style;
*/

  GdkBitmap *transparent;



  /* ------------------------------------------ */
  printf("GUI_Pix %s\n",filnam);



/*
  // style = gtk_widget_get_style (parent);
  style = gtk_widget_get_style (WinAct);

  // pixmap = gdk_pixmap_create_from_xpm (parent->window, &mask,
  pixmap = gdk_pixmap_create_from_xpm (WinAct->window, &mask,
                &style->bg[GTK_STATE_NORMAL], filnam);


  pixmapwid = gtk_pixmap_new (pixmap, mask);
*/


  // Methode 2:
  if(OS_checkFilExist(filnam, 0) == 0) {
    return NULL;
  }


  pixmap = gdk_pixmap_colormap_create_from_xpm (NULL,
               gdk_colormap_get_system(),
               &transparent,
               NULL,
               filnam);


  pixmapwid = gtk_pixmap_new (pixmap, transparent);

  gtk_box_pack_start (GTK_BOX (parent), pixmapwid, FALSE, FALSE, border);

  gtk_widget_show (pixmapwid);

  gdk_pixmap_unref (pixmap);

  return pixmapwid;

}


//=====================================================================
  void GUI_Butt_Att (int mode) {
//=====================================================================
/// TRUE: mehrere Buttons sollen die gesamte Breite ihrer Box benutzen.


  butt_expand = mode;

  return;

}


//=====================================================================
  GtkWidget* GUI_Butt (GtkWidget *parent, char* ltext,
                            void *funcnam, void *data, int border) {
//=====================================================================
/// \code
/// Button.
/// ltext    Beschriftung Button
/// funcnam  wird beim drcken mit data gerufen = callbackfunktion.
/// border   > 0:  freier Raum rund um Button.
///          < 0:  absolut size of Button
/// 
/// GUI_Butt (box0, "TestButton", UI_func1, NULL, 10);
/// 
/// int UI_func1 (GtkWidget *parent, void *data) {
///   ..
/// }
/// 
///   Dzt braucht man (Linux u MS) keine Parameter anzugeben! 
///   Es geht also auch "int UI_func1 () { ..};"
/// 
/// 
/// Disactivate:
/// gtk_widget_set_sensitive (ckb1, (gint)1); //1=activ, 0=inaktiv.
/// 
/// change text:
///   gtk_button_set_label (wButt1, " newText ");
/// \endcode



  UI_act_wi = gtk_button_new_with_label (ltext);
  /* gtk_widget_set_name (UI_act_wi, "Style1"); */


  gtk_signal_connect (GTK_OBJECT (UI_act_wi), "clicked",
                      GTK_SIGNAL_FUNC(funcnam), data);

//gtk_signal_connect (GTK_OBJECT (UI_act_wi), "clicked",
//                    (GtkSignalFunc) funcnam, data);


  // expand,fill (S.74/75) 
  // expand: True=fill gesamten Space in box;
  // fill: nur bei expand=TRUE: TRUE=file space by Button, else by space around
  if(border < 0) {
    // gtk_box_pack_start (GTK_BOX (parent), UI_act_wi, butt_expand, FALSE, 0);
    gtk_box_pack_start (GTK_BOX (parent), UI_act_wi, FALSE, FALSE, 0);
    gtk_widget_set_usize (UI_act_wi, -border, 0);  // size in pixel x,y.
  } else {
    // gtk_box_pack_start (GTK_BOX (parent), UI_act_wi, FALSE, TRUE, border);
    // gtk_fixed_put (GTK_BOX (parent), UI_act_wi, 0,0);
    gtk_container_add (GTK_CONTAINER (parent), UI_act_wi);
    if(border > 0) gtk_container_border_width(GTK_CONTAINER(UI_act_wi), border);
  }
  // gtk_box_pack_start (GTK_BOX (parent), UI_act_wi, FALSE, TRUE, border);

  gtk_widget_show (UI_act_wi);

  return UI_act_wi;

}


//=====================================================================
  void       GUI_Tip         (char* txt) {
//=====================================================================
/// \code
/// Tooltips fuer das zuletzt erzeugte Objekt UI_act_wi.
/// Zeilentrennung besser automatisch; mit \n gibts eine Leerzeile 
/// \r tut nix \r\n auch nicht.
/// Zum spaeteren Aendern use GUI_SetActW
/// \endcode

// Buch S.111


  // GtkTooltips *UI_tip;

  // printf("GUI_Tip |%s|\n",txt);

  // tip = gtk_tooltips_new();

  gtk_tooltips_set_tip (UI_tip, UI_act_wi, txt, NULL);

}


//=====================================================================
  GtkWidget* GUI_GetActW () {
//=====================================================================

  return UI_act_wi;

}


//=====================================================================
  void       GUI_SetActW         (GtkWidget *newAct) {
//=====================================================================
/// \code
/// ein Widget als aktives Widget setzen;
/// useful for changing GUI_Tip's
/// retrieve w. GUI_GetActW
/// \endcode

  UI_act_wi = newAct;

}


//=====================================================================
  void GUI_ButtPix (GtkWidget *parent, char* labeltext, char* filnam,
                      void *funcnam, void *data) {
//=====================================================================
/// Button mit Pixmap und Text erzeugen.


  GtkWidget *box1, *bw1;
  /* GdkPixmap *pixmap; */
  /* GdkBitmap *mask; */
  /* GtkStyle *style; */


  /* ------------------------------------------ */
  bw1 = gtk_button_new ();
  // bw1 = gtk_button_new_with_label ("a");

  gtk_signal_connect (GTK_OBJECT (bw1),
             "clicked", (GtkSignalFunc) funcnam, data);

  gtk_box_pack_start (GTK_BOX (parent), bw1, butt_expand, TRUE, 0);
  // gtk_container_add (GTK_CONTAINER (parent), bw1);

  gtk_widget_show (bw1);



  // Box mit Bild + Text (label) ber od. unter dem Bild
  box1 = GUI_Vbox (bw1, 0);

  GUI_Pix (box1, filnam, 0);

  GUI_Label (box1, labeltext, 0);


}



//===================================================================
  int GUI_File_selGet (char *filnam, void *buttID) {
//===================================================================
/// \code
/// Den (selektierten) Dateinnamen (samt Pfad!) einlesen)
/// In in data: die WidgetID der FileSelBox.
/// \endcode


  GtkWidget *fsb;
  char      *t1;


  // aus buttID die FileSelectionBoxID holen
  // fsb = GTK_BUTTON (buttID)->parent;
  // fsb = GTK_BIN (buttID)->child;
  fsb = UI_act_FileSelBox;


  // den filename (incl. Pfad) holen.
  t1 = (char*)gtk_file_selection_get_filename (GTK_FILE_SELECTION (fsb));
  strcpy(filnam, t1);
  printf("Sel.fn = %s\n",filnam);

  gtk_widget_destroy ((GtkWidget*) fsb);
  
  return 0;

}



//===================================================================
  GtkWidget* GUI_File_select (char *ltxt, void *funcnam) {
//===================================================================
/// \code
/// Komplett eigenes Fenster zum Selektieren eines Files.
/// Wird nach Fileselekt gelscht.
/// Der gelieferte Filename ist inclusive Dir.
/// 
/// ltxt:  damit kann das Dir. eingestellt werden (soll mit "/" enden).
/// 
///   GUI_File_select ("", UI_open);
/// 
/// 
/// //=============================================
///   int UI_open (GtkWidget *parent, void *data) {
/// //===========
/// 
///   char      *t1, buf[80];
/// 
///   printf("UI_open %d\n", (int)data);
/// 
///   // den filename (incl. Pfad) nach WC_modnam holen.
///   GUI_File_selGet (WC_modnam , parent);
/// 
///   return 0;
/// 
/// }
/// \endcode


   GtkWidget *w1;

  printf("GUI_File_select %s}\n",ltxt);

  /* Create a new file selection widget */
  /* Hat automat 3 Buttons; ok_button, cancel_button und help_button */
  w1 = gtk_file_selection_new ("File selection");


  /* Connect the ok_button to file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (w1)->ok_button),
                      "clicked", (GtkSignalFunc) funcnam, w1);

  /* Geht nicht mit normalem gtk_signal_connect; damit kann man nur den */
  /* Cancel-Button lschen. */
  gtk_signal_connect_object (
             GTK_OBJECT (GTK_FILE_SELECTION (w1)->cancel_button),
             "clicked", (GtkSignalFunc) gtk_widget_destroy,
             GTK_OBJECT (w1));


  /* Lets set the filename, as if this were a save dialog, and we are giving
   a default filename */
  if (strlen(ltxt) > 0) {
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(w1), ltxt);
  }

  gtk_widget_set_uposition (w1, UI_WinposX, UI_WinposY);
  gtk_widget_show (w1);


  UI_act_FileSelBox = w1;
  
  return w1;
}


//===================================================================
  int GUI_Popup (char *optLst[], void *funcnam1, void* funcnam2) {
//===================================================================
/// \code
/// callback funcnam2 if preselect (Cursor over Listentry).  Can be NULL.
/// callback funcnam1 if select (mousebutton)
/// ACHTUNG: funcnam1 unused; 
///
/// char  *optLst[]={"func 1","func 2","\0"};
/// GUI_Popup (optLst, NULL, CB_popup);
/// ..
/// int CB_popup (GtkWidget *widget, GdkEventAny *event, gpointer data) {
///   static long isel=-1;
///   if(event->type == GDK_ENTER_NOTIFY) {isel = (int)data; return 0;}
///   if(event->type != GDK_BUTTON_RELEASE) return 0;
///   printf("CB_popup %d\n",isel);
///   ..
/// }
/// \endcode



  int            i1;
  GtkWidget      *wact, *menu;
  // void (*pfc)();

  menu = gtk_menu_new();

  i1=0;


  while (optLst[i1]) {
    // printf(" optLst[%d]=|%s|\n",i1,optLst[i1]);
    if(strlen(optLst[i1]) < 1) break;

    wact = gtk_menu_item_new_with_label (optLst[i1]);

    // GTK1:
    // select-func
    // gtk_signal_connect (GTK_OBJECT (wact), "activate",
                     // (GtkSignalFunc) funcnam1, (void*)i1);

    // preview
    if(funcnam2)
      // // GTK1:
      gtk_signal_connect (GTK_OBJECT (wact), "enter_notify_event",
                     (GtkSignalFunc) funcnam2, (void*)i1);
      // GTK2:
      gtk_signal_connect (GTK_OBJECT(wact), "leave_notify_event",
                     (GtkSignalFunc) funcnam2, (void*)i1);
      // g_signal_connect_swapped (GTK_OBJECT (wact), "enter_notify_event",
                     // G_CALLBACK (funcnam2), GTK_OBJECT (menu));

    gtk_menu_append (GTK_MENU (menu), wact);
    gtk_widget_show (wact);

    ++i1;
  }



  // kommt nie: destroy,delete-event
  if(funcnam2) {
    // i1 = -1;
    // pfc = funcnam2;
    // (*pfc) (NULL, NULL, (void*)i1);   // init funcnam2

    gtk_signal_connect (GTK_OBJECT(menu), "button_release_event",
                     (GtkSignalFunc) funcnam2, NULL);
  }


  //gtk_menu_popup (GTK_MENU(menu), NULL,NULL,NULL,NULL,NULL,NULL);
  gtk_menu_popup (GTK_MENU(menu), NULL,NULL,NULL,NULL,0,0);
  gtk_widget_show (menu);



  return 0;

}


//===================================================================
  double GUI_Slider_get (GtkWidget* wsl1) {
//===================================================================
/// query slider-value

  double  d1;

  d1 = gtk_adjustment_get_value  ((GtkAdjustment*)wsl1);

  // d1 = ((GtkAdjustment*)wsl1)->value;
  return d1;

}


//===================================================================
  void GUI_Slider_set (GtkWidget* wsl1, double newVal) {
//===================================================================
/// change slider-value


  gtk_adjustment_set_value  ((GtkAdjustment*)wsl1, newVal);


/*
  ((GtkAdjustment*)wsl1)->value = newVal;
  // update Slider
  gtk_adjustment_value_changed ((GtkAdjustment*)wsl1);
*/

  return;

}


//===================================================================
  GtkWidget* GUI_Slider__ (GtkWidget *parent, int typ, void *funcnam,
                           double valMin, double valMax, double valStart) {
//===================================================================
/// \code
/// Input:
///   typ       0=horizontal, 1=vertical.
///   funcnam   callBack-function for moving the slider; NULL = no callback.
/// RetCod:
///
/// Example without callback:
/// wsl1 = GUI_Slider__ (box1, 0, NULL, 0., 1., 0.5);
/// // query slider-value
/// printf(" sliVal=%f\n",GUI_Slider_get(wsl1));
/// // change slider-value
/// GUI_Slider_set (wsl1, 0.75);
///
/// Example with callback:
/// wsl1 = GUI_Slider__ (box1, 0, sl_CB, 0., 1., 0.5);
/// int sl_CB (GtkAdjustment *adj1, void *data) {
///   printf("sl_CB %f\n",gtk_adjustment_get_value(adj1));
/// }
/// \endcode


  GtkObject     *adj1;
  GtkWidget     *wsc1;

  double        d1;


  // Adjustment (StartVal minVal maxVal incr pageIncr pageSize)
  d1 = (valMax - valMin ) / 100.;
  adj1 = gtk_adjustment_new (valStart, valMin, valMax, d1, 0., 0.);


  // callback for moving the control
  if(funcnam) {
    gtk_signal_connect (GTK_OBJECT(adj1), "value_changed",
                       GTK_SIGNAL_FUNC(funcnam), NULL);
                       // (GtkSignalFunc)gtk_exit, NULL);
  }

  wsc1 = gtk_hscale_new (GTK_ADJUSTMENT(adj1));

  // do not display actual value
  gtk_scale_set_draw_value (GTK_SCALE(wsc1), FALSE);

  gtk_container_add (GTK_CONTAINER(parent), wsc1);
  gtk_widget_show (wsc1);


  return (void*)adj1;

}


//===================================================================
  GtkWidget* GUI_File_selext(char *wtit,char *ltxt,void *funcnam,void* data){
//===================================================================
/// \code
/// Komplett eigenes Fenster zum Selektieren eines Files.
/// Wird nach Fileselekt geloescht.
/// Der gelieferte Filename ist inclusive Dir.
/// 
/// ltxt:  damit kann das Dir. voreingestellt werden (soll mit "/" enden).
/// 
/// 
///   GUI_File_selext ("WinTit","*.dat", UI_openCB,(void*)"open");
/// 
/// 
/// //===============================================
///   int UI_openCB (GtkWidget *parent, void *data) {
/// //=============
/// 
///   char      *cp1;
/// 
///   cp1 = (char*)data;
/// 
///   // selekt. Dateinamen einlesen
///   GUI_File_selGet (xa_auxbuf1 , parent);
/// 
///   if(!strcmp(cp1, "open")) {
///     ..
/// \endcode



   GtkWidget *w1;

  printf("GUI_File_selext |%s|\n",ltxt);


  /* Create a new file selection widget */
  /* Hat automat 3 Buttons; ok_button, cancel_button und help_button */
  w1 = gtk_file_selection_new (wtit);


  /* Connect the ok_button to file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (w1)->ok_button),
                      "clicked", (GtkSignalFunc) funcnam, data);

  /* Geht nicht mit normalem gtk_signal_connect; damit kann man nur den */
  /* Cancel-Button loeschen. */
  gtk_signal_connect_object (
             GTK_OBJECT (GTK_FILE_SELECTION (w1)->cancel_button),
             "clicked", (GtkSignalFunc) gtk_widget_destroy,
             GTK_OBJECT (w1));


  /* Lets set the filename, as if this were a save dialog, and we are giving
   a default filename */
  if (strlen(ltxt) > 0) {
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(w1), ltxt);
  }

  // an momentane Mauspos (GTK2: call before show)
  // geht scheinbar immer in die Screenmitte ..
  // gtk_widget_set_uposition (w1, UI_WinposX, UI_WinposY);
  // gtk_window_set_position (GTK_WINDOW(w1), GTK_WIN_POS_MOUSE);
  gtk_window_set_position (w1, GTK_WIN_POS_MOUSE);

  gtk_widget_show (w1);

  UI_act_FileSelBox = w1;

  return w1;
}


//=====================================================================
  void GUI_List_add (GtkWidget *list, char* item) {
//=====================================================================
/// /usr/include/gtk/gtkscrolledwindow.h


  /* int       i1; */
  GtkWidget *list_item;


  // printf("GUI_List_add |%s|\n",item);


  /* for (i1=0; i1 < 999; i1++) { */
    /* if (!strcmp(item[i1],"\0")) break; */
    /* printf("GUI_List_add %s\n", item[i1]); */
    /* list_item = gtk_list_item_new_with_label (item[i1]); */
    list_item = gtk_list_item_new_with_label (item);

    /* list = g_list_prepend (list, list_item); */

    // gtk_list_append_items (GTK_LIST(list), list_item);
    // g_list_append ((GList*)list, list_item);

    gtk_container_add (GTK_CONTAINER (list), list_item);


    /* gtk_list_item_select (list_item); */

    /* gtk_widget_grab_default (list_item); */

    gtk_widget_show (list_item);

  /* } */

}


//=====================================================================
  void GUI_List_clear (GtkWidget *list, int ianf, int iend) {
//=====================================================================
/// alle loeschen: GUI_List_clear (w_list, 0, 9999);


  gint      i1, i2;
  /* GList     *dlist; */
  /* GtkWidget *list_item; */


  // printf("GUI_List_clear %d %d\n",ianf, iend);

  if (iend < 1) return;

  i1=ianf; i2=iend;
  gtk_list_clear_items (GTK_LIST (list), i1, i2);

}


//=====================================================================
  void GUI_List_remove (GtkWidget *widget, GtkList *list) {
//=====================================================================


  GList *clear_list;


  // printf("GUI_List_remove\n");

  clear_list = GTK_LIST (list)->selection;
  gtk_list_remove_items (GTK_LIST (list), clear_list);

}


//=====================================================================
  int GUI_List_select (GtkWidget *list, int mode) {
//=====================================================================
/// \code
/// mode = 0: normal, Line bleibt nach Selektion selektiert
/// mode = 1: line wird sofort unselektiert
/// mode = 2: init selection (i1=99999)
/// 
/// Retcodes: -1 = deselect Line
///           >0 = line selected
/// \endcode


  static gint      i1;
  GList     *dlist;
  GtkWidget *list_item;


  /* --------------------------------------------- */
  // printf("GUI_List_select\n");


  // if(mode == 2) {i1 = 999999; return 0;}


  dlist = GTK_LIST(list)->selection;

  if (dlist) {
    list_item = dlist->data;
    i1 = gtk_list_child_position (GTK_LIST(list), list_item) + 1;
    // printf("pos = %d\n", i1);
    if (mode == 1) {
      gtk_list_unselect_child (GTK_LIST(list), list_item);
    // } else {
      // gtk_list_select_item (GTK_LIST(list), i1);
    }

  } else {
    // printf("unselect\n");
    if(i1 > 0) i1 = -i1;
  }

  // printf("ex GUI_List_select %d\n",i1);

  return i1;

}


/*
//================================================================
  gint GUI_List_CB (GtkWidget *widget, GdkEventButton *event) {
//================================================================
// nach M3 in Liste soll File geloescht werden - kann aktiven ZeilenIndex
// nicht eruieren ...

  int i1;
  GList     *dlist;
  GtkWidget *list_item;

  printf("GUI_List_CB  %d\n",event->button);


  // if (event->button == 1) {
    dlist = widget;
    list_item = dlist->data;
    i1 = gtk_list_child_position (GTK_LIST(UI_act_FileSelBox), list_item) + 1;
    printf("pos = %d\n", i1);

  // GUI_List_select (widget, 1);


  Fertig:
  // printf("ex UI_GR_ButtonPress %d %d %d\n",x, y, state);
  // return FALSE;
  return TRUE;
}
*/

//=====================================================================
 GtkWidget* GUI_List (GtkWidget *parent, void *funcnam, void *data) {
//=====================================================================
/// \code
///   GUI_Butt(box0,"List", UI_List3, (void*)UI_FuncInit, 10);
/// 
/// int UI_List3 (GtkWidget *parent, void *data) {
/// 
///   static GtkWidget *winID, *box1;
///   static GtkList   *list;
///   long             i1, selInd;
/// 
///   static char *list_items[] = {"hello     ", "world     ", "\0"};
/// 
///   i1 = (int)data;
/// 
///   switch (i1) {
/// 
///     case UI_FuncInit:
/// 
///       if (winID) { return 0; }
/// 
///       // Create Mainwindow
///       winID = GUI_Window ("Undo", UI_undo, (void*)UI_FuncKill, 0);
/// 
///       // damit Zeilenlnge setzen !
///       gtk_widget_set_usize (winID, 200, 100);
/// 
///       box1 = GUI_Vbox (winID, 0);
/// 
///       // create Liste
///       list = GUI_List (box1, UI_undo, (void*)0);
/// 
///       // Liste befllen
///       for (i1 = 0; i1<10; i1++) {
///         if (!strcmp(list_items[i1],"\0")) break;
///         GUI_List_add (list, list_items[i1]);
///       }
/// 
///       GUI_Butt (box1, "done",  UI_undo, (void*)UI_FuncKill, 0);
///       gtk_widget_show (winID);
///       break;
/// 
///     case 0:
///       selInd = GUI_List_select (list);
///       printf("list1_sel %d\n",selInd);
///       break;
/// 
///     case UI_FuncKill:
///       if (winID) {
///         gtk_widget_destroy (winID);
///         winID = NULL;
///         goto Fertig;
///       }
///   }
/// }
/// 
/// Problem:  beim Callback (von funcnam) wird data nicht mitgeliefert !
/// Nachteil: man kann den Text nicht auslesen !
/// ------------------------------------
/// add. Features:
/// gtk_list_set_selection_mode(GTK_LIST(wLst),GTK_SELECTION_MULTIPLE);
/// \endcode
 


  GtkWidget *list;
  GtkWidget *box2;
  GtkWidget *scrolled_win;
  // GtkList   *gl1=NULL;


  /* --------------------------------------------------------- */
  box2 = gtk_vbox_new (TRUE, 4);
  gtk_container_border_width (GTK_CONTAINER (box2), 4);
  gtk_box_pack_start (GTK_BOX (parent), box2, TRUE, TRUE, 0);
  // gtk_box_pack_start (GTK_BOX (parent), box2, FALSE, FALSE, 0);
  gtk_widget_show (box2);


  scrolled_win = gtk_scrolled_window_new (NULL, NULL);

  /* gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win), */
                                  /* GTK_POLICY_AUTOMATIC, */
                                  /* GTK_POLICY_AUTOMATIC); */
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
                                  GTK_POLICY_AUTOMATIC,
                                  GTK_POLICY_ALWAYS);
  gtk_box_pack_start (GTK_BOX (box2), scrolled_win, TRUE, TRUE, 0);
  gtk_widget_show (scrolled_win);




  list = gtk_list_new ();

  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrolled_win),
                                         list);


  // Default ist SINGLE */
  // gtk_list_set_selection_mode(GTK_LIST (list),GTK_SELECTION_SINGLE); */
  // gtk_list_set_selection_mode(GTK_LIST (list),GTK_SELECTION_MULTIPLE);
  // gtk_list_set_selection_mode(GTK_LIST (list),GTK_SELECTION_BROWSE); */

  if (funcnam) {


    // gtk_signal_connect (GTK_OBJECT (list),
                        // "enter_notify_event",     // "button_press_event",
                        // (GtkSignalFunc) GUI_List_CB, NULL);
    gtk_signal_connect (GTK_OBJECT (list),
                        "select_child",
                        (GtkSignalFunc) funcnam, data);
    gtk_signal_connect (GTK_OBJECT (list),
                        "unselect_child",
                        (GtkSignalFunc) funcnam, NULL);
    // gtk_signal_connect (GTK_OBJECT (list),
                        // "selection_changed",
                        // (GtkSignalFunc) funcnam, data);
  }


  // gtk_container_add (GTK_CONTAINER (scrolled_win), list);
  gtk_container_set_focus_vadjustment(GTK_CONTAINER(list),
                     gtk_scrolled_window_get_vadjustment
                     (GTK_SCROLLED_WINDOW (scrolled_win)));


  gtk_widget_show (list);

  UI_act_FileSelBox = list;

  UI_act_wi = scrolled_win;
  // UI_act_wi = box2;

  return list;
  // return gl1;

}


//=====================================================================
  int GUI_unmap_act () {
//=====================================================================

  // gtk_widget_unrealize (UI_act_wi);
  gtk_widget_destroy (UI_act_wi);

  return 0;

}


//================================================================
  GtkWidget* GUI_Notebook__ (GtkWidget *parent, void *funcnam) {
//================================================================
/// \code
/// Create a new Notebook.
/// Add Pages with GUI_Notebook_add.
/// Example see tst_gtk6.c.
/// parent should be a window;
/// funcnam is called when noteBook-pages change; first Page has Nr 0.
///   int my_Notebook_CB (int pgNr) {printf("_CB %d\n",pgNr); return;}
/// \endcode


  UI_act_wi = gtk_notebook_new ();

  if (funcnam)
    gtk_signal_connect (GTK_OBJECT(UI_act_wi), "switch-page",
                       (GtkSignalFunc)GUI_Notebook_CB, NULL);
                        // GTK_SIGNAL_FUNC(GUI_Notebook_CB), (gpointer)wnb);


  gtk_container_add(GTK_CONTAINER(parent), UI_act_wi);

  gtk_widget_show (UI_act_wi);

  GUI_Notebook_CB (NULL, NULL, 0, funcnam);  // save pointer to func

  return UI_act_wi;

}


//======================================================================
  GtkWidget* GUI_Notebook_add (GtkWidget *wnb, char *title) {
//======================================================================
/// returns a VBOX in the new Notebook-Page.


  GtkWidget   *wtmp1, *child;

  wtmp1 = gtk_label_new (title);    // label for notebook-page

  child = gtk_vbox_new (FALSE, 0);

  gtk_widget_show (child);

  gtk_notebook_append_page (GTK_NOTEBOOK(wnb), child, wtmp1);

  return child;

}


//================================================================
void GUI_Notebook_CB (GtkNotebook *ntb, GtkNotebookPage *nbp,
                   guint pgNr, void* data) {
//================================================================
/// callback of switch-notebook-page

static void      (*userFunc)();

  // printf("GUI_Notebook_CB %d\n",pgNr);

  if(ntb == NULL) {
    userFunc = data;
    return;
  }

  (*userFunc) ((int)pgNr);

  return;

}


//=====================================================================
  int UI_test11 (GtkWidget *parent, void *data) {
//=====================================================================


  printf("UI_test11,  /%s/\n",(char*)data);

  return 0;
}


//=====================================================================
  GtkWidget* GUI_MenuCkBox (GtkWidget *parent, char* ltxt,
                            void *funcnam, void *data) {
//=====================================================================
/// \code
/// abfragen mit GUI_get_CkBox
///  i1 = ((GtkCheckMenuItem*)parent)->active;   // 0=ON; else=Off.
/// setzen mit: GUI_set_CkBox
///   gtk_check_menu_item_set_active (parent, FALSE);
///   gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM(parent), TRUE);
/// \endcode

  GtkWidget *w1;

  w1 = gtk_check_menu_item_new_with_label (ltxt);

  /* ...and add it to the menu. */
  gtk_menu_append (GTK_MENU (parent), w1);

  if (funcnam) {
    gtk_signal_connect (GTK_OBJECT(w1), "activate",
                     (GtkSignalFunc) funcnam, data);
  }


  /* Show the widget */
  gtk_widget_show (w1);


  UI_act_wi = w1;
  return w1;

}




//=====================================================================
  GtkWidget* GUI_MenuEntry (GtkWidget *parent, char* ltxt,
                              void *funcnam, void *data) {
//=====================================================================
/// \code
/// Menupunkt oder MenuSeparator (wenn ltxt == "---")
/// 
/// Offen:
/// gtk_menu_item_set_submenu S.87,103
/// 
///   GUI_MenuEntry (menu, "Save as", UI_CB,   (void*)"saveAs");
///   GUI_MenuEntry (menu, "---",     NULL,    NULL);   // Separator
/// \endcode



  GtkWidget *menu_item;

 /* kein ltxt: einen Separator */
  if (!strcmp(ltxt, "---")) {
    menu_item = gtk_menu_item_new ();



  } else {
    /* Create a new menu-item with a name... */
    menu_item = gtk_menu_item_new_with_label (ltxt);

    gtk_signal_connect (GTK_OBJECT (menu_item), "activate",
                      (GtkSignalFunc) funcnam, data);

  }


  /* ...and add it to the menu. */
  gtk_menu_append (GTK_MENU (parent), menu_item);

  /* Show the widget */
  gtk_widget_show (menu_item);


  UI_act_wi = menu_item; // Fuer Tooltips

  return menu_item;

}

//=====================================================================
  GtkWidget* GUI_MenuBar (GtkWidget *parent) {
//=====================================================================
/// \code
/// 
/// Zuerst eine vbox, dann den MenuBar.
/// 
/// GtkWidget *menu_bar, *menu;
/// 
/// box0 = GUI_Vbox (window, 0);
/// menu_bar = GUI_MenuBar (box0);
/// 
/// menu = GUI_Menu (menu_bar, "File  ");
///   GUI_MenuEntry (menu, "New", MF_Menu, (void*)"new");
/// \endcode



  GtkWidget *menu_bar;

  /* Create a menu-bar to hold the menus and add it to our main window*/
  menu_bar = gtk_menu_bar_new ();

  gtk_box_pack_start (GTK_BOX (parent), menu_bar, FALSE, FALSE, 0);

  gtk_widget_show (menu_bar);

  return menu_bar;

}

//=====================================================================
  GtkWidget* GUI_Menu (GtkWidget *menu_bar, char *ltxt, int mode) {
//=====================================================================
/// \code
/// Generiert ein neues Menu oder Submenu.
/// mode: 0  = normal
///       'r'= right-justified
///       's'= Submenu.
/// 
/// GtkWidget *menu_bar, *menu, *men_imp;
/// GtkWidget *fil_men;
/// 
/// menu_bar = GUI_MenuBar (box0);                      // create Menubar
/// 
/// men_fil = GUI_Menu (menu_bar, "File ", 0);          // first Menu on Menubar
/// 
/// men_hlp = GUI_Menu (menu_bar, "Help ", 'r');        // Menu rechts
/// fil_men = GUI_GetActW();   // get RootWindow of menu for disactivate
///                            // muss sofort nach GUI_Menu sein !
/// 
/// GUI_MenuEntry   (men_fil,"New",UI_CB,(void*)"new"); // add entry to Menu
/// men_imp=GUI_Menu(men_fil,"Import", 's');            // Menuentry mit Submenu
/// 
/// // disactivate menu:
/// gtk_widget_set_sensitive (fil_men, FALSE);
/// \endcode



  GtkWidget *menu, *root_menu;


  /* Init the menu-widget, and never gtk_show_widget() the menu widget!! */
  menu = gtk_menu_new();

  /* This is the root menu, the label will be the menu name displayed on
   * the menu bar.  There won't be a signal handler attached, as it only
   * pops up the rest of the menu when pressed. */
  root_menu = gtk_menu_item_new_with_label (ltxt);

  if(mode == 'r') {
    gtk_menu_item_right_justify(GTK_MENU_ITEM(root_menu));
  }

  gtk_widget_show (root_menu);


  /* Now we specify that we want our newly created "menu" to be the menu
   *  for the "root menu" */
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (root_menu), menu);


  // And finally we append the menu-item to the menu-bar
  if(mode != 's') {
    gtk_menu_bar_append (GTK_MENU_BAR (menu_bar), root_menu);
  } else {
    gtk_menu_append (GTK_MENU (menu_bar), root_menu);
  }


  UI_act_wi = root_menu;

  return menu;

}


//=====================================================================
  GtkWidget* GUI_MenuSub (GtkWidget *item) {
//=====================================================================


  GtkWidget *submenu;


  submenu = gtk_menu_new ();

  gtk_menu_item_set_submenu (GTK_MENU_ITEM (item), submenu);

  return submenu;

}


//=====================================================================
  int GUI_WinDwn (GtkWidget *parent) {
//=====================================================================
/// \code
/// GUI_WinDwn             remove alwaysOnTop-attribute
/// use it if you open an additional window ..
/// \endcode


  printf("GUI_WinDwn \n");

  gtk_signal_disconnect_by_func (GTK_OBJECT(parent),
                            (GtkSignalFunc)GUI_WinUpCB, NULL);
  return 0;

}



//=====================================================================
  int GUI_WinUp (GtkWidget *parent) {
//=====================================================================
/// \code
/// window always on top ..
/// - muss vor gtk_widget_show gerufen werden !!!!
/// - this events MUST (additonally) be activated: 
/// gtk_widget_set_events (window, 
///                                 GDK_FOCUS_CHANGE_MASK|
///                                 GDK_VISIBILITY_NOTIFY_MASK);
/// 
/// for additional Window: hide & restore the window_always_on_top:
/// GUI_WinDwn (win0);
/// after the new window is gone:
/// GUI_WinUp (win0);  // - again
/// 
/// DOES NOT WORK FOR THE PARENT-WINDOW: USE WM_raise_wTit
/// \endcode

  // printf("GUI_WinUp \n");

  // init
  GUI_WinUpCB (parent, NULL, (void*)UI_FuncInit);

  // *w_act = parent;

  return 0;

}


//===========================================================================
  int GUI_WinUpCB (GtkWidget *parent, GdkEventVisibility *event, void *data) {
//===========================================================================
/// \code
/// this win always up
/// UI_FuncInit muss vor gtk_widget_show gerufen werden !!!!
/// UI_FuncExit = hide window; damit kann anders (zB FileSelection)
///               druebergelegt werden; reset mit gtk_widget_show !!
/// jedoch nur das zuletzt aktivierte Raisen (sonst loop!)
/// 
/// GUI_WinUpCB (NULL,NULL,(void*)UI_FuncExit);  // NOT always on top
/// \endcode

// Macht das Init UND in der Folge das raise !



static GtkWidget *w_act = NULL;
static int       sid1, sid2;


  // printf("GUI_WinUpCB \n");



  // init ..
  if((int)(int*)data == UI_FuncInit) {
    printf("GUI_WinUpCB init\n");
    w_act = parent;

// #ifdef _MSC_VER
    // focus_out_event kommt in MS-Win und in Debian; nicht in Mandrake !
    // ACHTUNG: gtk_widget_set_events nur einmal rufen !!!
    // gtk_widget_set_events(parent, GDK_FOCUS_CHANGE_MASK |
                                         // GDK_VISIBILITY_NOTIFY_MASK);

    sid1=gtk_signal_connect(GTK_OBJECT(parent), "focus_out_event",
                         (GtkSignalFunc)GUI_WinUpCB, NULL);
// #else
    // nur Linux/Mandrake (nicht MS-Win, Debian)
    // gtk_widget_set_events(parent, GDK_VISIBILITY_NOTIFY_MASK);
    sid2=gtk_signal_connect(GTK_OBJECT(parent), "visibility_notify_event",
                         (GtkSignalFunc)GUI_WinUpCB, NULL);
// #endif
    return 0;



  // diconnect; geht aber kein reconnect mehr moeglich (muss vor show sein ..)
  } else if((int)(int*)data == UI_FuncExit) {
    // printf("GUI_WinUpCB exit\n");
    // gtk_signal_disconnect(GTK_OBJECT(w_act), sid1);
    // gtk_signal_disconnect(GTK_OBJECT(w_act), sid2);
    gtk_widget_hide (w_act);
    GUI_update__ ();
    return 0;
  }


  if(parent == w_act) {
    // printf("GUI_WinUpCB raise\n");
    gdk_window_raise (event->window);
    // gdk_window_raise (parent);  geht ned !
    return 1;
  }

    // printf(" ex GUI_WinUpCB\n");

 return 0;

}


//================================================================
  int GUI_update__ () {
//================================================================
/// update all windows

  // Display zwischendurch updaten
  while (gtk_events_pending()) {
    gtk_main_iteration();
  }

  return 0;

}


//================================================================
  int GUI_del_events () {
//================================================================
/// \code
/// GUI_del_events         kill all pending events
/// 
/// Usage:
///  gtk_main_quit ();   // stop collecting events ...
///  .. langwierige work ..
///  GUI_del_events ();  // kill pending events ...
///  gtk_main ();        // resume collecting events ...
/// \endcode


  GdkEvent  *evNtx;

  L_kill:
  evNtx =  gdk_event_get ();
  if(evNtx != NULL) {
    gdk_event_free (evNtx);
    goto L_kill;
  }

  gtk_main_iteration();

  return 0;

}


//================================================================
  int GUI_Idle (void *funcnam, void *data) {
//================================================================
/// \code
/// GUI_Idle               register a idle-function
/// Example:
///  GUI_Idle (AP_Idle_CB, NULL);
///  int AP_Idle_CB (void *data) {
///    .. work ..
///    return 0; // removes idle-Call!
///    return 1; // keep idle-Call; call AP_Idle_CB again.
///  }
/// \endcode

  gtk_idle_add ((GtkFunction)funcnam, data);


  return 0;

}


//================================================================
  int GUI_del_widged (GtkWidget *wdg1) {
//================================================================
// GUI_del_widged            delete widget

  gtk_widget_hide (wdg1);
  gtk_widget_unrealize (wdg1);

  return 0;

}

// EOF
