/***************************************************************************
                             prototypes ../ut/ut_umem.c
                             -------------------
    begin                : Tue Mai 30 2003
    copyright            : (C) 2003 by CADCAM-Services Franz Reiter
    email                : franz.reiter@cadcam.co.at

****************************************************************************
*//*!
\file ../ut/ut_umem.h
\ingroup grp_ut_obj
*/

  int UME_init (Memspc *memSpc, void* objDat, int osiz);
  void* UME_save (Memspc *memSpc, void* objDat, int osiz);
  void* UME_reserve (Memspc *memSpc, int osiz);
  int UME_add (Memspc *memSpc, int osiz);
  int UME_reset (Memspc *memSpc, void* newStart);
  int UME_ck_free (Memspc *memSpc);
  int UME_dump    (Memspc *memSpc, char *txt);
  int UME_del (Memspc *memSpc, void *nach, void *von, ...);
  void UME_connect (void *memPos, Memspc *memSeg);
  void UME_release (void *memPos, Memspc *memSeg);

  int UME_reall_add (long *spcOff, Memspc *memSpc, long addSiz);
  int UME_realloc (long *spcOff, Memspc *memSpc, long newSiz);
  int UME_reall_save (long *spcOff, Memspc *memSpc, void* objDat, int osiz);

  void* UME_alloc_tmp (int siz);



#define UME_EMPTY {NULL, NULL, NULL, 0, 0}


/// \code
/// UME_alloc_tmp             allocate mem for active function
/// spc = (typ*)UME_alloc_tmp(size);
/// \endcode
#ifdef _MSC_VER
#define UME_alloc_tmp(siz) _alloca(siz)
#else
#define UME_alloc_tmp(siz) alloca(siz)
#endif


/// UME_connect               get actual memSpacePosition
#define UME_connect(memPos,memSeg)(memPos)=(memSeg)->next

/// UME_release               release memSpace
#define UME_release(memPos,memSeg)(memSeg)->next=(memPos)




//======================== EOF ======================================
